﻿Imports System.Xml.Linq
Imports System.Linq
Imports System.IO
Imports System.Reflection

Public Class DAL
    Private Shared Function ReadXml() As XDocument
        Dim Ass As Assembly = Assembly.GetExecutingAssembly
        Dim ResName As String = "BilderDAL.Bilddaten.xml"
        Dim XDoc As XDocument
        Try
            Using St As Stream = Ass.GetManifestResourceStream(ResName)
                Using Sr As New StreamReader(St)
                    XDoc = XDocument.Load(Sr)
                End Using
            End Using
            Return XDoc
        Catch ex As SystemException
            Throw New SystemException("Fehler in ReadXml - XML konnte aus Ressource nicht gelesen werden.")
        End Try
    End Function

    Shared Function GetKategorien()   ' Kein Rückgabewert, da Anonymer Typ
        Dim XDoc As XDocument = ReadXml()
        ' Hier wird ein Anonymer Typ angelegt
        Dim Kategorien = From K In XDoc.<BilderDaten>.<Kategorien>.<Kategorie> Select New With {.Kategorie = K.Value, .ID = K.Attribute("ID").Value}
        ' Alternativ geht auch New XElement("Kategorie", K.Value)
        Return Kategorien.ToList
    End Function

    Shared Function GetBilderByKatID(ByVal KatID As Integer) ' Ebenfalls anonymer Typ
        Dim XDoc As XDocument = ReadXml()
        Dim Bilder = From B In XDoc.<BilderDaten>.<BilderListe>.<Bild> Where B.Attribute("KategorieID").Value = KatID Select New With {.Titel = B.Element("Titel").Value, .BildID = B.Attribute("BildID").Value}
        ' Alternativ geht auch New XElement("Kategorie", K.Value)
        Return Bilder.ToList
    End Function

    Shared Function GetBildPfad(ByVal BildTitel As String) As String
        Dim XDoc As XDocument = ReadXml()
        Dim BildPfad As String = (From B In XDoc.<BilderDaten>.<BilderListe>.<Bild> Where B.Element("Titel").Value = BildTitel Select B.Element("BildPfad").Value).SingleOrDefault
        Return BildPfad
    End Function

    Shared Function GetBildPfadByID(ByVal BildID As Integer) As String
        Dim XDoc As XDocument = ReadXml()
        Dim BildPfad As String = (From B In XDoc.<BilderDaten>.<BilderListe>.<Bild> Where B.Attribute("BildID").Value = BildID Select B.Element("BildPfad").Value).SingleOrDefault
        Return BildPfad
    End Function

End Class
