﻿Imports System.IO
Imports System.Windows.Forms
Imports System.Diagnostics

Public Class fmMain
    Private mWdApp As Word.Application
    Private BildDateiPfad As String
    Private D As Word.Document

    Sub New(ByVal WdApp As Word.Application)
        InitializeComponent()
        mWdApp = WdApp
    End Sub

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        tbZielverzeichnis.Text = "C:\2008\Buchprojekte08\Office2007\Fertig\Bilder\"
        tbQuellverzeichnis.Text = "C:\2008\Buchprojekte08\Office2007\Bilder"
        bnRefresh.PerformClick()
    End Sub

    Private Sub bnBilderKopieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnBilderKopieren.Click
        Dim QuellDateiPfad As String
        Dim ZielDateipfad As String
        Dim Anzahl As Integer
        If BildDateiPfad = "" Then
            If liAktiveDokumente.SelectedIndex >= 0 Then
                BildDateiPfad = "C:\Bildliste_" & Path.GetFileName(liAktiveDokumente.Text) & ".txt"
            Else
                MessageBox.Show("Kein Dokument in der Liste selektiert!")
                Exit Sub
            End If
        End If
        Try
            Using Ts As New StreamReader(BildDateiPfad)
                ' Jetzt zeilenweise lesen und kopieren
                liStatus.Items.Clear()
                While Not Ts.EndOfStream
                    QuellDateiPfad = Ts.ReadLine
                    QuellDateiPfad = Path.Combine(tbQuellverzeichnis.Text, QuellDateiPfad)
                    ZielDateipfad = tbZielverzeichnis.Text
                    ' Wichtig: Zielpfad muss mit einem \ enden
                    Try
                        File.Copy(QuellDateiPfad, ZielDateipfad, True)
                    Catch ex As SystemException
                        MessageBox.Show("Fehler beim Kopieren!", ex.Message)
                        liStatus.Items.Add("Fehler: " & ex.Message)
                        Exit Sub
                    End Try
                    Anzahl += 1
                    liStatus.Items.Add("Datei " & QuellDateiPfad & " wurde nach " & _
                     ZielDateipfad & " kopiert.")
                    liStatus.SelectedIndex = liStatus.Items.Count - 1
                    Application.DoEvents()
                End While
                liStatus.Items.Add(Anzahl & " Dateien wurden kopiert.")
            End Using
        Catch ex As SystemException
            MessageBox.Show("Bildatei " & BildDateiPfad & " konnte nicht geöffnet werden!")
            liStatus.Items.Add(ex.Message)
        End Try
    End Sub

    Private Sub bnBildPfadeInTextdatei_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnBildPfadeInTextdatei.Click
        Dim Sp As Word.InlineShape
        If liAktiveDokumente.SelectedIndex >= 0 Then
            D = mWdApp.Documents(liAktiveDokumente.Text)
            BildDateiPfad = "C:\Bildliste_" & Path.GetFileName(liAktiveDokumente.Text) & ".txt"
            Using Ts As New StreamWriter(BildDateiPfad)
                For Each Sp In D.InlineShapes
                    If Sp.Type = Word.WdInlineShapeType.wdInlineShapeLinkedPicture Then
                        Ts.WriteLine(Sp.LinkFormat.SourceName)
                    End If
                Next
            End Using
        End If
        Dim Pi As New ProcessStartInfo
        Pi.WindowStyle = ProcessWindowStyle.Normal
        Pi.FileName = "Notepad"
        Pi.Arguments = BildDateiPfad
        Process.Start(Pi)
    End Sub

    Private Sub bnQuellverzeichnisAuswahl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnQuellverzeichnisAuswahl.Click
        Using Fbd As New FolderBrowserDialog
            With Fbd
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    tbQuellverzeichnis.Text = .SelectedPath
                End If
            End With
        End Using
    End Sub

    Private Sub bnZielverzeichnisAuswahl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnZielverzeichnisAuswahl.Click
        Using Fbd As New FolderBrowserDialog
            With Fbd
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    tbZielverzeichnis.Text = .SelectedPath
                End If
            End With
        End Using

    End Sub

    Private Sub bnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnRefresh.Click
        liAktiveDokumente.Items.Clear()
        For Each D As Word.Document In mWdApp.Documents
            liAktiveDokumente.Items.Add(Path.Combine(D.Path, D.Name))
        Next
        If liAktiveDokumente.Items.Count > 0 Then
            liAktiveDokumente.SelectedIndex = 0
        End If
    End Sub
End Class