﻿' Ein einfaches Outlook-Automatisierungsbeispiel

Imports Out = Microsoft.Office.Interop.Outlook

Public Class fmHaupt
    Private OutApp As Out.Application
    Private Ta As Out.Table
    Private InBox As Out.Folder

    Sub InitListView()
        lvMails.View = View.Details
        lvMails.Columns.Add("Absender", 180, HorizontalAlignment.Center)
        lvMails.Columns.Add("Betreff", 240, HorizontalAlignment.Left)
        lvMails.Columns.Add("Zeitpunkt", 140, HorizontalAlignment.Center)
        lvMails.ShowItemToolTips = True
    End Sub

    Function ReadMails() As Integer
        Dim Betreff As String
        Dim Absender As String
        Dim AnzahlMails As Integer
        Dim AnzahlGelesen As Integer
        Try
            ' Für denn Fall, dass Outlook bereits läuft
            OutApp = GetObject([Class]:="Outlook.Application")
        Catch ex As Exception
            ' Hier passiert nichts
        End Try
        If OutApp Is Nothing Then
            Try
                ' Outlook läuft noch nicht und wird gestartet
                OutApp = CreateObject("Outlook.Application", "Localhost")
            Catch ex As Exception
                MessageBox.Show("Outlook kann nicht gestartet werden, sorry!", Application.ProductName)
                bnRefresh.Enabled = False
                Return 0
            End Try
        End If
        InBox = OutApp.Session.GetDefaultFolder(Microsoft.Office.Interop.Outlook.OlDefaultFolders.olFolderInbox)
        Ta = InBox.GetTable("[Unread]=True")
        lvMails.Items.Clear()
        AnzahlMails = Ta.GetRowCount
        tsProgress.Minimum = 0
        tsProgress.Maximum = AnzahlMails
        While Not Ta.EndOfTable
            Dim Zeile As Out.Row = Ta.GetNextRow
            Try
                ' Absender über EntryID des MailItems holen
                Absender = CType(OutApp.Session.GetItemFromID(Zeile.Item("EntryID")), Out.MailItem).SenderName
            Catch ex As Exception
                ' Wenn es nicht geklappt hat
                Absender = "Kein Absender"
            End Try
            ' Die Betreff-Zeile direkt aus der Zeile holen
            Try
                Betreff = Zeile.Item("Subject").ToString
            Catch ex As Exception
                Betreff = "Kein Betreff"
            End Try
            ' ListView-Eintrag mit Absender als ersten Eintrag hinzufügen
            Dim Lv As ListViewItem = lvMails.Items.Add(Absender)
            ' Betreff und Zeitpunkt hinzufügen
            Lv.SubItems.Add(Betreff)
            Lv.SubItems.Add(Zeile.Item("CreationTime").ToString)
            Lv.ToolTipText = Betreff
            AnzahlGelesen += 1
            tsProgress.Value = AnzahlGelesen
        End While
        tsProgress.Value = 0
        Return AnzahlMails
    End Function

    Private Sub fmHaupt_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If OutApp IsNot Nothing Then
            Try
                OutApp.Quit()
                OutApp = Nothing
            Catch ex As Exception
                ' Hier passiert nichts
            End Try
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        InitListView()
    End Sub

    Private Sub bnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnRefresh.Click
        Dim AnzahlMails As Integer = ReadMails()
        tsStatusFeld.Text = AnzahlMails & " Mails gelesen."
    End Sub

    Private Sub lvMails_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvMails.DoubleClick
        Dim Betreff As String
        If lvMails.SelectedItems.Count > 0 Then
            Betreff = lvMails.SelectedItems.Item(0).Text
            Dim bGefunden As Boolean
            Dim InEx As Out.Explorer
            For Each Ex As Out.Explorer In OutApp.Explorers
                If Ex.CurrentFolder Is InBox Then
                    bGefunden = True
                    InEx = Ex
                End If
            Next
            If bGefunden = False Then
                InEx = OutApp.Explorers.Add(InBox, Microsoft.Office.Interop.Outlook.OlFolderDisplayMode.olFolderDisplayNormal)
            End If
            InEx.Display()
            InEx.Search(Betreff, Microsoft.Office.Interop.Outlook.OlSearchScope.olSearchScopeCurrentFolder)
        End If
    End Sub

End Class
