﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' Eín Beispiel für den Umgang mit VSTO-Bookmarks
' -----------------------------------------------------------
Imports System.Data

Public Class ThisDocument

    Private Sub ThisDocument_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        Dim BuchID As Integer = 1000
        ' Me.BuchID.Range.Text = BuchID
        SetBuchInfo(BuchID)
        Me.Tables(1).Rows.Add()
        Me.Application.Selection.Range.Text = 0
        Me.Application.Selection.Expand(Unit:=Word.WdUnits.wdCharacter)
        Dim SumBm As Microsoft.Office.Tools.Word.Bookmark = Me.Controls.AddBookmark(Me.Application.Selection.Range, "Summe")
    End Sub

    Private Sub ThisDocument_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        '
    End Sub

    ' Eine fiktive Datenbankabfrage
    Sub SetBuchInfo(ByVal BuchID As Integer)
        Try
            ' Pfad zur Mdb-Datei festlegen
            'Dim DBPfad As String = My.Application.Info.DirectoryPath & "\BuchInfo.mdb"
            Dim DBPfad As String = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) & "\BuchInfo.mdb"
            Clipboard.SetText(My.Application.Info.DirectoryPath)
            ' Verbindungszeichenfolge zusammenbauen
            Dim CnSt As String = "Provider=Microsoft.Jet.OleDb.4.0;Data Source=" & DBPfad
            ' Connection-Objekt anlegen
            Dim Cn As New OleDb.OleDbConnection(CnSt)
            ' Command-Objekt anlegen
            Using Cmd As New OleDb.OleDbCommand("Select * From Buecher Where BuchID=@BuchID", Cn)
                ' Parameter zur Abfrage hinzufügen
                Cmd.Parameters.AddWithValue("@BuchID", BuchID)
                ' Verbindung öffnen
                Cn.Open()
                Dim Dr As OleDb.OleDbDataReader = Cmd.ExecuteReader(System.Data.CommandBehavior.SingleRow)
                ' Gibt es eine Zeile?
                If Dr.HasRows Then
                    ' Dann diese Zeile lesen
                    Dr.Read()
                    ' Jetzt Ergebnis den Textmarken zuweisen
                    Me.ErschJahr.Range.Text = Dr.Item("ErschJahr")
                    Me.Titel.Range.Text = Dr.Item("Titel")
                    Me.Preis.Range.Text = Dr.Item("Preis")
                    Me.Autor.Range.Text = Dr.Item("Autor")
                    Me.ISBN.Range.Text = Dr.Item("ISBN")
                Else
                    MessageBox.Show("Zu der Buch-ID gibt es keine Infos, sorry", "Keine Daten erhalten.")
                End If
            End Using
        Catch ex As OleDb.OleDbException
            MessageBox.Show("OleDb-Error: " & ex.Message, "Fehler beim Datenbankzugriff")
        Catch ex As SystemException
            MessageBox.Show("Error: " & ex.Message, "Allgemeiner Fehler")
        End Try
    End Sub

End Class
