﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' Zugriff auf die Dokumenteigenschaften eines Word2003/2007-Dokuments
' -----------------------------------------------------------

Imports System.Runtime.InteropServices

Public Class ThisDocument

    Private Sub ThisDocument_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        Dim DocPropName As String = "AuthorOwnsRights"
        If Not DocPropExists(Me, DocPropName) Then
            If AddDocProp(Me, DocPropName, True, Microsoft.Office.Core.MsoDocProperties.msoPropertyTypeBoolean) Then
                MessageBox.Show("Eigenschaft wurde hinzugefügt!")
            Else
                MessageBox.Show("Es gab ein Problem beim Hinzufügen der Eigenschaft!")
            End If
        End If
        ListDocProps(Me)
    End Sub

    Sub ListDocProps(ByVal D As ThisDocument)
        Dim Ta As Word.Table = D.Tables.Add(D.Application.Selection.Range, 1, 3)
        Ta.Rows(1).Cells(1).Range.Text = "Nr"
        Ta.Rows(1).Cells(2).Range.Text = "Name"
        Ta.Rows(1).Cells(3).Range.Text = "Wert"
        For Each P As Office.DocumentProperty In D.CustomDocumentProperties
            Ta.Rows.Add()
            'Me.Application.Selection.TypeText(P.Name & vbCrLf)
            Ta.Rows(Ta.Rows.Count).Cells(1).Range.Text = Ta.Rows.Count - 1
            Ta.Rows(Ta.Rows.Count).Cells(2).Range.Text = P.Name
            Try
                Ta.Rows(Ta.Rows.Count).Cells(3).Range.Text = P.Value
            Catch ex As COMException
                Ta.Rows(Ta.Rows.Count).Cells(3).Range.Text = "Kein Wert"
            End Try
        Next
    End Sub

    Function DocPropExists(ByVal D As ThisDocument, ByVal PropName As String) As Boolean
        For Each P As Office.DocumentProperty In D.CustomDocumentProperties
            If P.Name = PropName Then
                Return True
            End If
        Next
        Return False
    End Function

    Function AddDocProp(ByVal D As ThisDocument, ByVal PropName As String, ByVal Wert As Object, ByVal PropTyp As Office.MsoDocProperties)
        Try
            CType(D.CustomDocumentProperties, Office.DocumentProperties).Add(Name:=PropName, LinkToContent:=False, Type:=PropTyp, Value:=Wert)
            Return True
        Catch ex As COMException
            MessageBox.Show(ex.Message)
            Return False
        Catch ex As SystemException
            MessageBox.Show(ex.Message)
            Return False
        End Try
    End Function

    Private Sub ThisDocument_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown

    End Sub

End Class
