﻿' Beispiel für Word-ContentControls mit XML-Bindung
Imports System.Reflection
Imports System.IO

Public Class ThisDocument
    <Cached()> Public ArtikelXMLPartID As String = String.Empty
    Private ArtikelXMLPart As Office.CustomXMLPart
    Private Const prefix As String = "xmlns:ns='http://schemas.microsoft.com/vsto/samples'"

    Private Sub ThisDocument_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        Dim xmlData As String = GetXmlFromResource()
        If xmlData IsNot Nothing Then
            AddCustomXmlPart(xmlData)
            BindControlsToCustomXmlPart()
        End If
    End Sub

    Private Sub ThisDocument_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        '
    End Sub

    Private Function GetXmlFromResource() As String
        Dim Asm As Assembly = Assembly.GetExecutingAssembly()
        Dim St As Stream = Asm.GetManifestResourceStream("VSTO_WDContentXML_Beispiel.Artikel.xml")
        Using ResRd As New StreamReader(St)
            If ResRd IsNot Nothing Then
                Return ResRd.ReadToEnd()
            End If
        End Using
        Return Nothing
    End Function

    Private Sub AddCustomXmlPart(ByVal xmlData As String)
        If xmlData IsNot Nothing Then
            ArtikelXMLPart = Me.CustomXMLParts.SelectByID(ArtikelXMLPartID)
            If (ArtikelXMLPart Is Nothing) Then
                ArtikelXMLPart = Me.CustomXMLParts.Add(xmlData)
                ArtikelXMLPartID = ArtikelXMLPart.Id
            End If
        End If
    End Sub

    Private Sub BindControlsToCustomXmlPart()
        Dim xPathTitel As String = "ns:ArtikelListe/ns:Artikel/ns:Titel"
        Dim xPathDatum As String = "ns:ArtikelListe/ns:Artikel/ns:Datum"
        Dim xPathAutor As String = "ns:ArtikelListe/ns:Artikel/ns:Autor"
        Me.DatePickerContentControl1.DateDisplayFormat = "MMMM d, yyyy"
        Me.DatePickerContentControl1.XMLMapping.SetMapping(xPathDatum, prefix, ArtikelXMLPart)
        Me.DropDownListContentControl1.XMLMapping.SetMapping(xPathAutor, prefix, ArtikelXMLPart)
        Me.PlainTextContentControl1.XMLMapping.SetMapping(xPathTitel, prefix, ArtikelXMLPart)
    End Sub

End Class
