﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' Verschiedene Word-Automatisierungsbeispiele
' -----------------------------------------------------------
Imports Wd = Microsoft.Office.Interop.Word
Imports System.Runtime.InteropServices

Public Class Form1
    Private WdApp As Wd.Application
    Private WdDoc As Wd.Document
    Private bRunning As Boolean
    Declare Function FindWindow Lib "User32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Integer

    Sub SetupWord()
        Try
            Try
                WdApp = GetObject(Class:="Word.Application")
            Catch Ex As Exception
                '
            End Try
            If WdApp Is Nothing Then
                WdApp = New Wd.Application()
                WdApp.Documents.Add()
                WdApp.Visible = True
                WdApp.Selection.TypeText("=Rand()")
                WdApp.Selection.MoveEnd(Unit:=Wd.WdUnits.wdParagraph)
                'WdApp.Selection.TypeBackspace()
                Windows.Forms.SendKeys.Send("{ENTER}")
            End If
            If WdApp.Documents.Count = 0 Then
                WdApp.Documents.Add()
            End If
            WdDoc = WdApp.ActiveDocument
        Catch ex As COMException
            MessageBox.Show("COM-Server nicht verfügbar!", My.Application.Info.Title)
        End Try
    End Sub

    Sub ShowMeldung(ByVal Meldung As String)
        Dim WdWin As New NativeWindow()
        Dim WdHwnd As Integer = FindWindow("OpusApp", vbNullString)
        WdWin.AssignHandle(New IntPtr(WdHwnd))
        MessageBox.Show(Meldung, My.Application.Info.Title)
        WdWin.ReleaseHandle()
    End Sub

    Private Sub bnTextmarkeAnlegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        SetupWord()
        WdApp.ActiveDocument.Bookmarks.Add(Name:="Hausmarke", Range:=WdApp.Selection.Range)
        ShowMeldung("Anzahl Textmarken: " & WdDoc.Bookmarks.Count)
    End Sub

    Private Sub bnFeldInTabelleAnlegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnFeldInTabelleAnlegen.Click
        SetupWord()
        Dim WdRa As Wd.Range
        Dim WdTab As Wd.Table = WdDoc.Tables.Add(Range:=WdApp.Selection.Range, NumRows:=2, NumColumns:=2)
        WdTab.AutoFormat(Wd.WdTableFormat.wdTableFormatProfessional)
        WdTab.Cell(1, 1).Range.Text = "Wert"
        WdTab.Cell(1, 2).Range.Text = "Mwst-Betrag"
        WdRa = WdTab.Cell(2, 1).Range
        WdApp.ActiveDocument.Bookmarks.Add(Name:="Betrag", Range:=WdRa)
        WdRa.Text = 100
        WdTab.Cell(2, 2).Select()
        WdApp.Selection.MoveLeft()
        WdApp.Selection.Fields.Add(Range:=WdApp.Selection.Range, Type:=Wd.WdFieldType.wdFieldEmpty, Text:="=Betrag/119*19")
    End Sub

    Private Sub bnFontDialogAnzeigen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim FontAuswahl As Wd.Dialog
        FontAuswahl = WdApp.Dialogs(Wd.WdWordDialog.wdDialogFormatFont)
        With FontAuswahl
            .Bold = 1
            .Italic = 1
            .Color = 3
            .Points = 24
            .Font = "Courier"
            .Show()
        End With
    End Sub

    Private Sub bnTastaturBelegungAnzeigen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnTastaturBelegungAnzeigen.Click
        SetupWord()
        'WdApp.KeyBindings.Add(Wd.WdKeyCategory.wdKeyCategoryStyle, "bla", 32)
        WdApp.Selection.Collapse(Direction:=Wd.WdCollapseDirection.wdCollapseEnd)
        If WdApp.KeyBindings.Count > 0 Then
            For Each K As Wd.KeyBinding In WdApp.KeyBindings
                WdApp.Selection.InsertAfter(Text:=K.KeyString & vbTab & K.Command _
                    & vbTab & " (" & K.CommandParameter & " ) ")
                WdApp.Selection.Collapse(Direction:=Wd.WdCollapseDirection.wdCollapseEnd)
                WdApp.Selection.InsertParagraph()
            Next
            WdApp.Selection.Collapse(Direction:=Wd.WdCollapseDirection.wdCollapseEnd)
        Else
            WdApp.Selection.InsertAfter(Text:="Es gibt keine Tastaturzuordnungen.")
        End If
    End Sub

    Private Sub bnAlleZeilenHervorheben_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnAlleZeilenHervorheben.Click
        Try
            SetupWord()
            bRunning = True
            ' Verschieben der Einfügemarke an den Anfang des Dokuments.
            WdApp.Selection.HomeKey(Unit:=Wd.WdUnits.wdStory, Extend:=Wd.WdMovementType.wdMove)
            ' Durchführen einer Schleife durch die Anzahl der Zeilen des Dokuments
            Dim AnzahlZeilen As Integer = _
                CType(WdApp.ActiveDocument.BuiltInDocumentProperties("NUMBER OF LINES").Value, Integer)
            'Durchlaufen aller Zeilen des Dokuments
            For ZeilenNr As Integer = 1 To AnzahlZeilen
                ' Markieren einer Zeile.
                WdApp.ActiveDocument.Bookmarks("\LINE").Select()
                ' Anzeigen der Zeilenanzahl - Kontrollmeldung zu Testzwecken
                ' Messagebox.Show ("Line: " & ZeilenNr, "Word-Automatisierung")
                ' Wechseln zur nächsten Zeile
                Threading.Thread.Sleep(1000)
                WdApp.Selection.MoveDown(Unit:=Wd.WdUnits.wdLine, Count:=1, Extend:=Wd.WdMovementType.wdMove)
                Windows.Forms.Application.DoEvents()
            Next
            bRunning = False
        Catch ex As COMException
            MessageBox.Show("Vorzeitiger Abbruch!", My.Application.Info.Title)
        End Try
    End Sub

    Private Sub bnSpaltenFormelEinfuegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnSpaltenFormelEinfuegen.Click
        SetupWord()
        Dim WdTab As Wd.Table = WdDoc.Tables.Add(Range:=WdApp.Selection.Range, NumRows:=2, NumColumns:=2)
        WdTab.Rows(1).Cells(1).Range.Text = 100
        WdTab.Rows(2).Cells(1).Range.Text = 200
        Dim MwstSatz As Byte = 19
        For Zeile As Integer = 1 To WdTab.Rows.Count
            WdTab.Rows(Zeile).Cells(2).Formula("=A" & CType(Zeile, String) & "/119 * " & MwstSatz, "0,00€")
        Next
    End Sub

    Private Sub bnBMPGrafikenEinfuegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnBMPGrafikenEinfuegen.Click
        SetupWord()
        Dim WdDocNeu As Wd.Document = WdApp.Documents.Add
        For Each Bild As System.IO.FileInfo In New  _
              System.IO.DirectoryInfo(Environment.GetFolderPath(Environment.SpecialFolder.MyPictures)).GetFiles("*.bmp")
            WdApp.ScreenUpdating = False
            With WdApp.Selection
                .InlineShapes.AddPicture(FileName:=Bild.FullName, LinkToFile:=True, SaveWithDocument:=False)
                .InsertParagraphAfter()
                .Collapse(Direction:=Wd.WdCollapseDirection.wdCollapseEnd)
                .TypeText(Text:=Bild.FullName)
                .InsertParagraphAfter()
                .Collapse(Direction:=Wd.WdCollapseDirection.wdCollapseEnd)
            End With
        Next
    End Sub

    Private Sub bnVerknuepfteGrafikenAuflisten_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnVerknuepfteGrafikenAuflisten.Click
        SetupWord()
        Dim WdBild As Wd.InlineShape
        WdDoc.Content.Text = "List der verknüpften Bilder"
        For Each WdBild In WdDoc.InlineShapes
            If WdBild.Type = Wd.WdInlineShapeType.wdInlineShapeLinkedPicture Then
                WdDoc.Content.Text &= WdBild.LinkFormat.SourceFullName
            End If
        Next
    End Sub

    Private Sub bnTabelleAnlegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnTabelleAnlegen.Click
        SetupWord()
        Dim Ta As Wd.Table = WdApp.ActiveDocument.Tables.Add(Range:=WdApp.Selection.Range, NumRows:=3, NumColumns:=3)
        Dim R As Wd.Range = Ta.Rows(1).Cells(1).Range
        R.Text = 100
        WdApp.ActiveDocument.Bookmarks.Add("Betrag", R)
        R = Ta.Rows(1).Cells(2).Range
        Dim WdFeld As Wd.Field = R.Fields.Add(Range:=R, Type:=Wd.WdFieldType.wdFieldFormula, Text:="=Betrag/100*19\# 0,00")
    End Sub

    Private Sub bnEigeneBilderInTabelle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnEigeneBilderInTabelle.Click
        SetupWord()
        WdDoc = WdApp.Documents.Add()
        Dim WdTab As Wd.Table
        Dim DateiZaehler As Integer
        Dim BilderVerzeichnis As String = Environment.GetFolderPath(Environment.SpecialFolder.MyPictures)
        With WdApp.Selection
            .TypeText("Inhalt von " & BilderVerzeichnis)
            .MoveLeft(Unit:=Wd.WdUnits.wdCharacter, Count:=.End)
            .Expand(Wd.WdUnits.wdSentence)
            .Range.ParagraphFormat.Alignment = Wd.WdParagraphAlignment.wdAlignParagraphCenter
            With .Range.Font
                .Name = "Arial"
                .Size = 16
                .Bold = True
                .ColorIndex = Wd.WdColorIndex.wdBlue
            End With
            .Collapse(Direction:=Wd.WdCollapseDirection.wdCollapseEnd)
            .TypeParagraph()
            .Expand(Unit:=Wd.WdUnits.wdParagraph)
            With .Range.Font
                .Size = 12
                .Bold = False
                .ColorIndex = Wd.WdColorIndex.wdAuto
            End With
            .TypeParagraph()
            WdTab = WdDoc.Tables.Add(Range:=.Range, NumRows:=1, NumColumns:=3)
            With WdTab
                .AutoFitBehavior(Wd.WdAutoFitBehavior.wdAutoFitContent)
                .Range.Font.Name = "Arial"
                .Range.Font.Size = 8
            End With
            With WdTab.Rows(1)
                .Cells(1).Range.Text = "Nr."
                .Cells(2).Range.Text = "Dateiname"
                .Cells(3).Range.Text = "Größe"
            End With
        End With
        For Each Datei As System.IO.FileInfo In New System.IO.DirectoryInfo(BilderVerzeichnis).GetFiles()
            ' Handelt es sich um eine Bitmap-Datei
            Dim BitmapEx() As String = New String() {".bmp", ".jpg", ".gif"}
            If Array.IndexOf(BitmapEx, Datei.Extension) <> -1 Then
                DateiZaehler += 1
                With WdTab.Rows.Add
                    .Cells(1).Range.Text = DateiZaehler
                    .Cells(2).Range.Hyperlinks.Add(.Cells(2).Range, "file://" & Datei.FullName)
                    .Cells(2).Range.Font.Size = 8
                    .Cells(2).Range.Paragraphs(1).Alignment = Wd.WdParagraphAlignment.wdAlignParagraphLeft
                    .Cells(3).Range.Text = Datei.Length
                End With
            End If
        Next
        WdTab.AutoFormat(Format:=Wd.WdTableFormat.wdTableFormatGrid8, AutoFit:=True)
    End Sub

    Private Sub bnU3Unterstreichen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        SetupWord()
        Dim WdSuchbereich As Wd.Range
        Dim SuchEnde, AnzahlGefunden As Integer
        With WdApp.ActiveDocument
            WdSuchbereich = .Content
            SuchEnde = .Content.End
        End With
        With WdSuchbereich.Find
            .Format = True
            .Style = "Überschrift 3"
            Do
                .Execute()
                If .Found = True Then
                    With WdSuchbereich
                        If .Font.Underline <> Wd.WdUnderline.wdUnderlineDash Then
                            .Font.Underline = Wd.WdUnderline.wdUnderlineDash
                            AnzahlGefunden += 1
                        End If
                    End With
                Else
                    Exit Do
                End If
                With WdSuchbereich
                    .Start = .End + 1
                    .End = SuchEnde
                End With
            Loop
        End With
        ShowMeldung("Anzahl Treffer: " & AnzahlGefunden)
    End Sub

    Private Sub bnSuchenErsetzen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnSuchenErsetzen.Click
        SetupWord()
        Dim Suchwort, ErsatzWort As String
        Dim WdSuchBereich As Wd.Range
        Dim AnzahlGefunden As Integer
        Suchwort = "VSTO"
        ErsatzWort = "Visual Studio Tools for Office"
        WdSuchBereich = WdDoc.Content
        With WdSuchBereich.Find
            .ClearFormatting()
            .MatchCase = False
            .Wrap = Wd.WdFindWrap.wdFindStop
            .Replacement.Text = ErsatzWort
            .Text = Suchwort
        End With
        Do
            If Not WdSuchBereich.Find.Execute(Replace:=Wd.WdReplace.wdReplaceOne) Then
                Exit Do
            End If
            WdSuchBereich.Start = WdSuchBereich.End
            AnzahlGefunden = AnzahlGefunden + 1
        Loop
        ShowMeldung("Anzahl Ersetzungen: " & AnzahlGefunden)
    End Sub

    Private Sub bnWdSuche_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnWdSuche.Click
        SetupWord()
        Dim Suchwort As String = "VSTO"
        Dim Anzahl As Long
        With WdApp.ActiveDocument.Content.Find
            Do
                .Text = Suchwort
                .Execute(MatchCase:=True, MatchWholeWord:=True)
                If .Found = False Then Exit Do
                Anzahl += 1
            Loop
        End With
        ShowMeldung("Anzahl Suchergebnisse: " & Anzahl)
    End Sub

    Private Sub ZeichenFormateAuflisten_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZeichenFormateAuflisten.Click
        SetupWord()
        Dim WdDocNeu As Wd.Document = WdApp.Documents.Add
        WdDocNeu.Content.Text = "Zeichenformate in " & WdDoc.FullName
        For Each FormatVorlage As Wd.Style In WdDoc.Styles
            If FormatVorlage.Type = Wd.WdStyleType.wdStyleTypeCharacter Then
                WdDocNeu.Content.Text &= FormatVorlage.NameLocal '& Chr(10)
            End If
        Next
        WdDocNeu.Activate()
        WdDocNeu.Sentences(1).Font.Bold = True
    End Sub

    Private Sub bnAnzahlSaetzeMitKleinbuchstaben_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnAnzahlSaetzeMitKleinbuchstaben.Click
        SetupWord()
        Dim KeinGrossBuchstabe As Integer
        Dim WdApp As Wd.Application = GetObject(Class:="Word.Application")
        For Each WdSatz As Wd.Range In WdApp.ActiveDocument.Sentences
            If Char.IsLower(WdSatz.Characters(1).Text) Then
                KeinGrossBuchstabe += 1
            End If
        Next
        ShowMeldung("Anzahl Sätze, die mit keinem Großbuchstaben beginnen: " & KeinGrossBuchstabe)
    End Sub

    Private Sub bnFussnotenKopieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnFussnotenKopieren.Click
        SetupWord()
        Dim WdDocNeu As Wd.Document = WdApp.Documents.Add
        WdDocNeu.Content.InsertAfter("Fussnotenliste:" & Chr(10))
        WdApp.Selection.Move(Unit:=Wd.WdUnits.wdParagraph, Count:=1)
        For Each F As Wd.Footnote In WdDoc.Footnotes
            Dim R As Wd.Range = WdDocNeu.Paragraphs.Add().Range
            R.Text = F.Range.Text & Chr(10)
            ' Für den Fall, dass es Formatvorlage nicht gibt
            Try
                R.Style = "Aufzählungszeichen"
            Catch ex As SystemException
                ' Hier passiert nichts
            End Try
            WdApp.Selection.Move(Unit:=Wd.WdUnits.wdParagraph, Count:=1)
        Next
    End Sub

    Private Sub bnKopfFusszeilenErstellen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnKopfFusszeilenErstellen.Click
        SetupWord()
        Dim WdR As Wd.Range
        Dim WdAbschnitt As Wd.Section
        Dim KapitelTitel As String
        Dim AnzahlAbschnitte As Integer
        For Each WdAbschnitt In WdDoc.Sections
            AnzahlAbschnitte += 1
            With WdAbschnitt.PageSetup
                .OddAndEvenPagesHeaderFooter = True
                .DifferentFirstPageHeaderFooter = True
            End With
            ' Verknüpfung auf vorherigen Bereich aufheben
            WdAbschnitt.Headers(Wd.WdHeaderFooterIndex.wdHeaderFooterPrimary).LinkToPrevious = False
            ' Verknüpfung auf vorherigen Bereich aufheben
            WdAbschnitt.Headers(Wd.WdHeaderFooterIndex.wdHeaderFooterEvenPages).LinkToPrevious = False
            ' Kapitelüberschrift abfragen - 1. Absatz muss "Überschrift 1" als Style besitzen
            If CType(WdAbschnitt.Range.Paragraphs(1).Style, Wd.Style).NameLocal = "Überschrift 1" Then
                KapitelTitel = "Kapitel: " & WdAbschnitt.Range.Paragraphs(1).Range.Text
            Else
                KapitelTitel = "Keine Überschrift"
            End If
            ' Chr(13)-Zeichen am Ende entfernen
            If KapitelTitel.Substring(KapitelTitel.Length - 1) = Chr(13) Then
                KapitelTitel = KapitelTitel.Substring(0, KapitelTitel.Length - 1)
            End If
            ' Ungerade Kopfzeilen enthalten aktuelle Zwischenüberschrift
            WdR = WdAbschnitt.Headers(Wd.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range
            With WdR
                ' Aktuelle Seitenzahl einfügen
                .Fields.Add(WdR, Wd.WdFieldType.wdFieldPage)
                ' Durch Field-Objekt wird offenbar zentrierter Tab bei 8cm
                ' gesetzt - kann auch direkt gelöscht werden:
                '  ParagraphFormat.TabStops(1).Clear
                .Text = .Text.Substring(0, .Text.Length - 1) & vbTab
                .Collapse(Wd.WdCollapseDirection.wdCollapseEnd)
                ' Formatvorlage muss in Anführungsstriche stehen
                .Fields.Add(WdR, Wd.WdFieldType.wdFieldStyleRef, """Überschrift 2""")
                ' Alle Tabstopps löschen und einen rechtsbündigen setzen
                .ParagraphFormat.TabStops.ClearAll()
                .ParagraphFormat.TabStops.Add(Position:= _
                    WdAbschnitt.PageSetup.PageWidth - WdAbschnitt.PageSetup.RightMargin - _
                    WdAbschnitt.PageSetup.LeftMargin, Alignment:=Wd.WdTabAlignment.wdAlignTabRight)
            End With
            ' Die geraden Kopfzeilen enthalten die Kapitelüberschrift und eine Seitenzahl
            WdR = WdAbschnitt.Headers(Wd.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range
            With WdR
                .Text = KapitelTitel & vbTab
                .Collapse(Wd.WdCollapseDirection.wdCollapseEnd)
                ' Aktuelle Seitenzahl einfügen
                .Fields.Add(WdR, Wd.WdFieldType.wdFieldPage)
                ' Alle Tabstopps löschen und einen rechtsbündigen setzen
                .ParagraphFormat.TabStops.ClearAll()
                .ParagraphFormat.TabStops.Add(Position:=WdAbschnitt.PageSetup.PageWidth - _
                    WdAbschnitt.PageSetup.RightMargin - WdAbschnitt.PageSetup.LeftMargin, _
                    Alignment:=Wd.WdTabAlignment.wdAlignTabRight)
            End With
        Next
        ShowMeldung(AnzahlAbschnitte & " Sektion(en) durchlaufen!")
    End Sub

    Private Sub bnSeriendruck_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnSeriendruck.Click
        SetupWord()
        WdApp.DisplayAlerts = Wd.WdAlertLevel.wdAlertsNone
        Dim AppDir As String = My.Application.Info.DirectoryPath
        Dim BriefVorlage As String = System.IO.Path.Combine(AppDir, "TeilnahmeUrkundeVorlage.doc")
        Dim WdBrief As Wd.Document = WdApp.Documents.Open(BriefVorlage)
        Dim TeilnehmerDateiPfad As String = System.IO.Path.Combine(AppDir, "Teilnehmerliste.txt")
        WdBrief.MailMerge.OpenDataSource(Name:=TeilnehmerDateiPfad, _
            SQLStatement:="Select * From TeilnehmerListe.txt")
        Dim WdMerge As Wd.MailMerge = WdBrief.MailMerge
        WdMerge.MainDocumentType = Wd.WdMailMergeMainDocType.wdFormLetters
        WdMerge.Destination = Wd.WdMailMergeDestination.wdSendToNewDocument
        WdMerge.Execute()
        WdMerge.DataSource.Close()
        WdBrief.Close()
        ShowMeldung("Seriendruck abgeschlossen!")
        WdApp.DisplayAlerts = Wd.WdAlertLevel.wdAlertsAll
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If bRunning Then
            e.Cancel = True
        End If
    End Sub
End Class