﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' -----------------------------------------------------------
Imports System.Collections.Generic

Public Class RechnungAuswahlPane
    Private mRechnungen As New Dictionary(Of String, Rechnung)

    Sub InitRechnungen()
        mRechnungen.Add("1000", New Rechnung() With {.Betrag = 1000, .Datum = "1.5.2007", .Gegenstand = "Reise an den Südpol", .RechnungsNr = 1000})
        mRechnungen.Add("1001", New Rechnung() With {.Betrag = 2000, .Datum = "1.6.2007", .Gegenstand = "Reise an den Nordpol", .RechnungsNr = 1001})
        mRechnungen.Add("1002", New Rechnung() With {.Betrag = 40000, .Datum = "1.8.2007", .Gegenstand = "Reise auf den Mond", .RechnungsNr = 1002})
    End Sub

    Private Sub bnRechnungAbrufen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnRechnungAbrufen.Click
        If mRechnungen.ContainsKey(tbRechnungNr.Text) Then
            Dim R As Rechnung = mRechnungen.Item(tbRechnungNr.Text)
            RechnungDetails(R)
            If liAbgerufen.FindStringExact(tbRechnungNr.Text) = -1 Then
                liAbgerufen.Items.Add(R)
            End If
        Else
            tbStatus.Text = "Rechnungsnummer nicht gefunden, sorry."
        End If
    End Sub

    Sub RechnungDetails(ByVal R As Rechnung)
        Dim Sb As New System.Text.StringBuilder
        Sb.Append("Rechnungs-Nr: " & R.RechnungsNr & vbCrLf)
        Sb.Append("Betrag: " & R.Betrag.ToString("C") & vbCrLf)
        Sb.Append("Datum:" & R.Datum.ToShortDateString & vbCrLf)
        Sb.Append("Gegenstand: " & R.Gegenstand)
        tbStatus.Text = Sb.ToString
    End Sub

    Private Sub liAbgerufen_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles liAbgerufen.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left AndAlso liAbgerufen.SelectedIndex >= 0 Then
            liAbgerufen.DoDragDrop(liAbgerufen.SelectedItem.Gegenstand, DragDropEffects.Copy)
        End If
    End Sub

    Private Sub RechnungAuswahlPane_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        InitRechnungen()
        liAbgerufen.DisplayMember = "RechnungsNr"
    End Sub
End Class
