﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' Ein und Ausblenden der ActionsPane per Befehlsleiste
' -----------------------------------------------------------

Public Class Tabelle1
    Private CbBn1 As Office.CommandBarButton
    Private CbBn2 As Office.CommandBarButton
    Private CbBn3 As Office.CommandBarButton

    Private Sub Tabelle1_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        BefehlsleisteSetup()
        Dim Lb As New Label
        Lb.Text = "Nur ein Test..."
        Globals.ThisWorkbook.ActionsPane.Controls.Add(LB)
    End Sub

    Private Sub Tabelle1_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        Try
            Me.Application.CommandBars.Item("ActionsPane").Delete()
        Catch ex As SystemException
            ' Hier passiert nichts
        End Try
    End Sub

    Sub BefehlsleisteSetup()
        Try
            Dim Cb As Office.CommandBar = Me.Application.CommandBars.Add("ActionsPane", Temporary:=True)
            With Cb
                .Visible = True
                .Position = Microsoft.Office.Core.MsoBarPosition.msoBarFloating
                CbBn1 = Cb.Controls.Add(Type:=Office.MsoControlType.msoControlButton, Temporary:=True)
                With CbBn1
                    .Caption = "Actionspane Ein/aus"
                    .FaceId = 30
                    .Style = Microsoft.Office.Core.MsoButtonStyle.msoButtonIconAndCaption
                End With
                CbBn2 = Cb.Controls.Add(Type:=Office.MsoControlType.msoControlButton, Temporary:=True)
                With CbBn2
                    .Caption = "Aufgabenbereich Ein/aus"
                    .FaceId = 31
                    .Style = Microsoft.Office.Core.MsoButtonStyle.msoButtonIconAndCaption
                End With
                CbBn3 = Cb.Controls.Add(Type:=Office.MsoControlType.msoControlButton, Temporary:=True)
                With CbBn3
                    .Caption = "Taskpane Ein/aus"
                    .FaceId = 32
                    .Style = Microsoft.Office.Core.MsoButtonStyle.msoButtonIconAndCaption
                End With
            End With
            AddHandler CbBn1.Click, AddressOf ActionsPaneEinAusHandler
            AddHandler CbBn2.Click, AddressOf TaskPaneEinAusHandler
            AddHandler CbBn3.Click, AddressOf AufgabenbereichEinAusHandler
        Catch ex As SystemException
            MessageBox.Show("Fehler beim Einrichten der Befehlsleiste.")
        End Try
    End Sub

    Sub ActionsPaneEinAusHandler(ByVal Bn As Office.CommandBarButton, ByRef DefaultAction As Boolean)
        Globals.ThisWorkbook.ActionsPane.Visible = Not Globals.ThisWorkbook.ActionsPane.Visible
    End Sub

    Sub TaskPaneEinAusHandler(ByVal Bn As Office.CommandBarButton, ByRef DefaultAction As Boolean)
        Try
            Me.Application.DisplayDocumentActionTaskPane = Not Me.Application.DisplayDocumentActionTaskPane
        Catch ex As SystemException
            MessageBox.Show("Aufgabenbereich kann nicht angesprochen werden.")
        End Try
    End Sub

    Sub AufgabenbereichEinAusHandler(ByVal Bn As Office.CommandBarButton, ByRef DefaultAction As Boolean)
        Me.Application.CommandBars("Task Pane").Visible = Not Me.Application.CommandBars("Task Pane").Visible
    End Sub

End Class
