﻿Imports VSTO2 = Microsoft.VisualStudio.Tools.Applications.Runtime
Imports System.Data
Imports System.IO

Partial Class _Default
    Inherits System.Web.UI.Page
    Private ExPfad As String = Server.MapPath("ExDateninsel.xls")
    Private ManifestPfad As String = Server.MapPath("VSTOCachedDataBeispiel.manifest")
    Private AssPfad As String = Server.MapPath("VSTOCachedDataBeispiel.dll")

    Protected Sub bnCustomizationAnlegen_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnCustomizationAnlegen.Click
        Try
            If VSTO2.ServerDocument.IsCustomized(ExPfad) Then
                liStatus.Items.Add("Excel-Mappe enthält bereits eine Customization.")
            Else
                ' Jetzt Customization anlegen
                'Dim ManifestUri As New Uri(ManifestPfad)
                Try
                    ' Manifestpfad ist optional
                    VSTO2.ServerDocument.AddCustomization(ExPfad, AssPfad, Nothing, "1.0.0.0", True)
                    'VSTO2.ServerDocument.AddCustomization(ExPfad, AssPfad, ManifestPfad, "1.0.0.0", True)
                    liStatus.Items.Add("Customization wurde angelegt.")
                Catch ex As SystemException
                    liStatus.Items.Add("Fehler beim Anlegen der Customization." & ex.Message & "(" & ex.GetType().Name & ")")
                    Exit Sub
                End Try
            End If
        Catch ex As SystemException
            liStatus.Items.Add("Fehler beim Lesen der Excel-Mappe.")
            Exit Sub
        End Try
        ' Jetzt Dateninsel anlegen
        Try
            Using Sd As New VSTO2.ServerDocument(ExPfad)
                Dim DatenInsel As VSTO2.CachedDataHostItem
                Dim DatenBereich As VSTO2.CachedDataItem
                If Not Sd.CachedData.HostItems.Contains("Dateninsel") Then
                    DatenInsel = Sd.CachedData.HostItems.Add("Dateninsel")
                    liStatus.Items.Add("Dateninsel wurde angelegt.")
                Else
                    DatenInsel = Sd.CachedData.HostItems.Item("Dateninsel")
                End If
                If Not DatenInsel.CachedData.Contains("Testdaten") Then
                    ' DataSet würde als Typname auch genügen
                    Dim Typname As String = "VSTOAnpassungSetzen.DataSet"
                    DatenBereich = DatenInsel.CachedData.Add("Testdaten", TypName)
                    liStatus.Items.Add("Datenbereich wurde angelegt.")
                Else
                    DatenBereich = DatenInsel.CachedData.Item("Testdaten")
                End If
                ' Jetzt Daten schreiben
                Dim DsDaten As DataSet
                DsDaten = InitDs()
                ' Beim Neuanlegen über SerializeDataInstance
                DatenBereich.SerializeDataInstance(DsDaten)
                liStatus.Items.Add("Daten in Dateninsel abgelegt.")
                Sd.Save()
                liStatus.Items.Add("ServerDocument wurde gespeichert.")
            End Using
        Catch ex As SystemException
            liStatus.Items.Add("Error: " & ex.Message & "(" & ex.GetType().Name & ")")
        End Try
    End Sub

    Function InitDs() As DataSet
        Dim Ds As New DataSet("Testdaten")
        Dim Ta As New DataTable("Buecher")
        Ta.Columns.Add("BuchNr", GetType(Integer))
        Ta.Columns.Add("Titel", GetType(String))
        Ta.Columns.Add("Autor", GetType(String))
        Dim Zeile As DataRow = Ta.NewRow()
        Zeile.ItemArray = New Object() {1000, "Alles über VSTO", "Monadjemi"}
        Ta.Rows.Add(Zeile)
        Zeile = Ta.NewRow()
        Zeile.ItemArray = New Object() {1001, "XML gekonnt und clever", "Dr. Pfeifer"}
        Ta.Rows.Add(Zeile)
        Ds.Tables.Add(Ta)
        Return Ds
    End Function
End Class
