﻿'Imports VSTO3 = Microsoft.VisualStudio.Tools.Applications
Imports VSTO2 = Microsoft.VisualStudio.Tools.Applications
Imports System.Reflection
Imports System.Data
Imports System.Xml
Imports System.IO

Partial Class _Default
    Inherits System.Web.UI.Page
    'Private Sd As VSTO2.Runtime.ServerDocument
    Private ExPfad As String = "VSTOCachedDataBeispiel.xls"
    Private DsBuecher As DataSet

    Protected Sub bnRefresh_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnRefresh.Click
        ExPfad = Server.MapPath(ExPfad)
        Try
            If Not VSTO2.Runtime.ServerDocument.IsCustomized(ExPfad) Then
                liStatus.Items.Add("Excel-Mappe enthält keine Customization.")
                Exit Sub
            End If
        Catch ex As SystemException
            liStatus.Items.Add("Fehler beim Lesen der Excel-Mappe.")
            Exit Sub
        End Try
        ' Jetzt Inhalt der Dateninsel lesen
        Using Sd As New VSTO2.Runtime.ServerDocument(ExPfad, IO.FileAccess.Read)
            If VSTO2.Runtime.ServerDocument.IsCacheEnabled(ExPfad) Then
                Dim DatenCache As VSTO2.Runtime.CachedData = Sd.CachedData()
                Try
                    Dim Daten As VSTO2.Runtime.CachedDataItemCollection = DatenCache.HostItems.Item("VSTOCachedDataBeispiel.Tabelle1").CachedData
                    Dim DatenInselXml As String = Daten.Item("DsBuecher").Xml
                    Dim DatenInselSchema As String = Daten.Item("DsBuecher").Schema
                    tbDateninsel.Text = DatenInselXml
                    liStatus.Items.Add("Dateninsel wurde eingelesen.")
                    DsBuecher = New DataSet("Buecher")
                    Using SchemaRd As New StringReader(DatenInselSchema)
                        DsBuecher.ReadXmlSchema(SchemaRd)
                    End Using
                    Using XmlRd As New StringReader(DatenInselXml)
                        Dim Res As System.Data.XmlReadMode = DsBuecher.ReadXml(XmlRd, XmlReadMode.DiffGram)
                    End Using
                    liStatus.Items.Add(DsBuecher.Tables(0).Rows.Count & " Datensätze in DataSet eingelesen.")
                    GridView1.DataSource = DsBuecher
                    GridView1.DataBind()
                Catch ex As SystemException
                    liStatus.Items.Add("Error: " & ex.Message & "(" & ex.GetType().Name & ")")
                End Try
            Else
                liStatus.Items.Add("Keine Dateninsel vorhanden.")
            End If
        End Using
        ' DsBuecher noch speichern
        Session.Add("DsBuecher", DsBuecher)

    End Sub

    Protected Sub bnUpdate_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnUpdate.Click
        Try
            DsBuecher.Tables(0).Rows(0).Item(0) = tbNeuerWert.Text
            ExPfad = Server.MapPath(ExPfad)
            Using Sd As New VSTO2.Runtime.ServerDocument(ExPfad, IO.FileAccess.Write)
                Dim DatenCache As VSTO2.Runtime.CachedData = Sd.CachedData()
                Dim HostElement As VSTO2.Runtime.CachedDataHostItem = DatenCache.HostItems.Item("VSTOCachedDataBeispiel.Tabelle1")
                Dim DatenElement As VSTO2.Runtime.CachedDataItem = HostElement.CachedData.Item("DsBuecher")
                Dim Sb As New StringBuilder()
                Dim Sw As New StringWriter(Sb)
                DsBuecher.WriteXml(Sw, XmlWriteMode.DiffGram)
                DatenElement.Xml = Sw.ToString
                Sd.Save()
                liStatus.Items.Add("Dateninsel wurde aktualisiert.")
            End Using
        Catch ex As SystemException
            liStatus.Items.Add("Error: " & ex.Message & "(" & ex.GetType().Name & ")")
        End Try
    End Sub

    Protected Sub form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles form1.Load
        If Me.IsPostBack Then
            DsBuecher = Session.Item("DsBuecher")
        End If
    End Sub
End Class
