﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' -----------------------------------------------------------
Imports System.Text.RegularExpressions
Imports VSTO = Microsoft.Office.Tools.Excel

Public Class ThisWorkbook

    Private Sub ThisWorkbook_Startup(ByVal sender As Object, ByVal e As System.EventArgs) _
            Handles Me.Startup
        ' Neuen SmartTag erzeugen
        Try
            Dim SmartTagISBN As New VSTO.SmartTag("urn:smarttag#ISBNSmartTag", "ISBN-Aktionen")
            SmartTagISBN.Expressions.Add(New Regex("^\d{9}[\d|X]$"))
            ' Action-Titel festlegen
            Dim AmazonAktion As New VSTO.Action("Daten von Amazon abrufen")
            Dim GoogleAktion As New VSTO.Action("Daten von Google abrufen")
            ' Aktionen anhängen
            SmartTagISBN.Actions = New VSTO.Action() {AmazonAktion, GoogleAktion}
            ' SmartTag zur SmartTags-Auflistung hinzufügen
            VstoSmartTags.Add(SmartTagISBN)
            ' Click-Handler hinzufügen
            AddHandler AmazonAktion.Click, AddressOf AmazonActionClick
            AddHandler GoogleAktion.Click, AddressOf GoogleActionClick
        Catch ex As SystemException
            MessageBox.Show("Fehler: " & ex.Message)
        End Try
    End Sub

    Sub AmazonActionClick(ByVal Sender As Object, ByVal e As VSTO.ActionEventArgs)
        MessageBox.Show("Abfrage bei Amazon war leider erfolglos!", My.Application.Info.Title)
    End Sub

    Sub GoogleActionClick(ByVal Sender As Object, ByVal e As VSTO.ActionEventArgs)
        MessageBox.Show("Abfrage bei Google war leider erfolglos!", My.Application.Info.Title)
    End Sub

End Class
