﻿Imports VSTO2 = Microsoft.VisualStudio.Tools.Applications.Runtime
Imports System.IO

Partial Class _Default
    Inherits System.Web.UI.Page
    Private ExPfad As String

    Protected Sub bnRefresh_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnDetailsAnzeigen.Click
        If FileUpload1.HasFile Then
            If Path.IsPathRooted(FileUpload1.PostedFile.FileName) Then
                ExPfad = FileUpload1.PostedFile.FileName
            Else
                ExPfad = Server.MapPath(FileUpload1.FileName)
            End If
        Else
            ExPfad = Server.MapPath("ExDateninsel.xls")
        End If
        liDetails.Items.Add("*** Details zu " & Spezialtrim(ExPfad, 60) & "***")
        Try
            If Not VSTO2.ServerDocument.IsCustomized(ExPfad) Then
                liDetails.Items.Add("Excel-Mappe besitzt keine Anpassung.")
                Exit Sub
            Else
                liDetails.Items.Add("Excel-Mappe besitzt eine Anpassung.")
            End If
            If VSTO2.ServerDocument.IsCacheEnabled(ExPfad) Then
                liDetails.Items.Add("Excel-Mappe besitzt einen  Datencache.")
            Else
                liDetails.Items.Add("Excel-Mappe besitzt keinen  Datencache.")
            End If
            Using Sd As New VSTO2.ServerDocument(ExPfad, IO.FileAccess.Read)
                liDetails.Items.Add("Manifest-Pfad: " & Spezialtrim(Sd.AppManifest.DeployManifestPath, 60))
                liDetails.Items.Add("Anzahl Entrypoints: " & Sd.AppManifest.EntryPoints.Count)
                For Each Ep As VSTO2.EntryPoint In Sd.AppManifest.EntryPoints
                    liDetails.Items.Add("Entry-Point: " & Ep.ClassName)
                Next
                Dim AssName As String
                With Sd.AppManifest.Dependency.AssemblyIdentity
                    AssName = "Name: " & .Name & ","
                    AssName &= "Version: " & .Version.ToString & ","
                    AssName &= "Public Keytoken: " & .PublicKeyToken
                End With
                liDetails.Items.Add("Assembly-Identität: " & Spezialtrim(AssName, 60))
                liDetails.Items.Add("Assembly-Pfad: " & Spezialtrim(Sd.AppManifest.Dependency.AssemblyPath, 90))
            End Using
        Catch ex As SystemException
            liDetails.Items.Add("Fehler beim Zugriff auf die Mappe - " & Spezialtrim(ex.Message, 60))
        End Try
    End Sub

    Function Spezialtrim(ByVal LangerText As String, ByVal Anzahl As Integer) As String
        If LangerText.Length > 90 Then
            Do
                LangerText = LangerText.Remove(10, 4)
            Loop Until (LangerText.Length < 90)
            LangerText = LangerText.Insert(10, "...")
        End If
        Return LangerText
    End Function
End Class
