﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' -----------------------------------------------------------
Imports Extensibility
Imports System.Runtime.InteropServices
Imports Office = Microsoft.Office.Core
Imports Wd = Microsoft.Office.Interop.Word
Imports Ex = Microsoft.Office.Interop.Excel
Imports Out = Microsoft.Office.Interop.Outlook
Imports Pp = Microsoft.Office.Interop.PowerPoint

#Region " Read me for Add-in installation and setup information. "
' When run, the Add-in wizard prepared the registry for the Add-in.
' At a later time, if the Add-in becomes unavailable for reasons such as:
'   1) You moved this project to a computer other than which is was originally created on.
'   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
'   3) Registry corruption.
' you will need to re-register the Add-in by building the $SAFEOBJNAME$Setup project, 
' right click the project in the Solution Explorer, then choose install.
#End Region

<GuidAttribute("00E92FD1-015C-4926-8EC1-6399C533423C"), ProgIdAttribute("Zitatgeber.Connect")> _
Public Class Connect
    Implements Extensibility.IDTExtensibility2
    Private AppEx As Ex.Application
    Private AppWd As Wd.Application
    Private AppPP As PP.Application
    Private AppOut As Out.Application
    Private HostAppName As String
    Private CbCn1 As Office.CommandBarButton

    Private applicationObject As Object
    Private addInInstance As Object
	
	Public Sub OnBeginShutdown(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnBeginShutdown
	End Sub
	
	Public Sub OnAddInsUpdate(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnAddInsUpdate
	End Sub
	
	Public Sub OnStartupComplete(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnStartupComplete
	End Sub
	
    Public Sub OnDisconnection(ByVal RemoveMode As Extensibility.ext_DisconnectMode, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnDisconnection
        DeleteCommandBar()
    End Sub
	
	Public Sub OnConnection(ByVal application As Object, ByVal connectMode As Extensibility.ext_ConnectMode, ByVal addInInst As Object, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnConnection
		applicationObject = application
        addInInstance = addInInst
        Select Case applicationObject.name
            Case "Microsoft Excel"
                AppEx = CType(applicationObject, Ex.Application)
                HostAppName = "Excel"
            Case "Microsoft Word"
                AppWd = CType(applicationObject, Wd.Application)
                HostAppName = "Word"
            Case "Microsoft PowerPoint"
                AppPP = CType(applicationObject, Pp.Application)
                HostAppName = "PowerPoint"
            Case "Outlook"
                AppOut = CType(applicationObject, Out.Application)
                HostAppName = "Outlook"
        End Select
        SetUpCommandBar()
    End Sub

    Sub DeleteCommandBar()
        Try
            Dim Cb As Office.CommandBar = applicationObject.Commandbars.Item("Zitatgeber")
            Cb.Delete()
        Catch ex As SystemException
            ' Hier passiert nichts
        End Try
    End Sub
    Sub SetupCommandbar()
        Dim CbNeu As Office.CommandBar = applicationObject.CommandBars.Add(Name:="Zitatgeber", Temporary:=True)
        With CbNeu
            .Visible = True
            CbCn1 = CbNeu.Controls.Add(Type:=Office.MsoControlType.msoControlButton, Temporary:=True)
            CbCn1.Tag = "Zitatgeber"
            CbCn1.FaceId = 59
            CbCn1.Caption = "Peters Zitatgeber"
            CbCn1.Style = Microsoft.Office.Core.MsoButtonStyle.msoButtonIconAndCaption
        End With
        ' Jetzt Handler hinzufügen
        AddHandler CbCn1.Click, AddressOf CbCn1_ClickHandler
    End Sub

    Sub CbCn1_ClickHandler(ByVal Btn As Office.CommandBarButton, ByRef CancelDefault As Boolean)
        Dim Frm As New frmZitate(HostAppName, applicationObject)
        Frm.Show()
    End Sub
End Class

