﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' -----------------------------------------------------------
Imports System.Xml
Imports System.IO
Imports Ex = Microsoft.Office.Interop.Excel
Imports Wd = Microsoft.Office.Interop.Word
Imports Out = Microsoft.Office.Interop.Outlook
Imports PP = Microsoft.Office.Interop.PowerPoint

Public Class frmZitate
    Private XDoc As New XmlDocument
    Private AppName As String
    Private AppObjekt As Object

    Sub New(ByVal AppName As String, ByVal AppObjekt As Object)
        InitializeComponent()
        Me.AppName = AppName
        Me.AppObjekt = AppObjekt
    End Sub

    Private Sub frmZitate_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ZitatePfad As String = Path.Combine(Environment.GetEnvironmentVariable("userprofile"), "Zitate.xml")
        Try
            XDoc.Load(ZitatePfad)
            Dim Kategorien As XmlNodeList = XDoc.SelectNodes("//Kategorien/Kategorie")
            cbKategorien.Items.Clear()
            For Each Kat As XmlNode In Kategorien
                cbKategorien.Items.Add(Kat.InnerText)
            Next
        Catch ex As SystemException
            MessageBox.Show("Exception - " & ex.Message, ex.TargetSite.Name)
        End Try
        ' ListBox einrichten
        liZitate.DisplayMember = "Spruch"
    End Sub

    Private Sub cbKategorien_ItemCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles cbKategorien.ItemCheck
        ' Das Event ist leider nicht so gut geeignet, da es ausgelöst wird bevor die
        ' Auswahl getroffen wird
    End Sub

    Private Sub bnZitatUebernehmen_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnZitatUebernehmen.Click
        Dim Spruch As String = liZitate.Text
        If liZitate.SelectedIndex = -1 Then
            MessageBox.Show("Bitte ein Zitat auswählen!", My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        Dim ZitatPfad As String = "//Zitate/Zitat[@Nr='" & CType(CType(liZitate.SelectedItem, Zitat).ZitatNr, String) & "']"
        'MessageBox.Show(ZitatPfad)
        Dim Quelle As String = XDoc.SelectSingleNode(ZitatPfad).SelectSingleNode("Quelle").InnerText
        Select Case AppName
            Case "Excel"
                CType(AppObjekt, Ex.Application).ActiveCell.Value2 = Spruch
                CType(AppObjekt, Ex.Application).ActiveCell.Offset(RowOffset:=1).Value2 = Quelle
            Case "Word"
                CType(AppObjekt, Wd.Application).Selection.TypeText(Spruch & vbCrLf)
                CType(AppObjekt, Wd.Application).Selection.TypeText(Quelle)
            Case "Outlook"
                Dim OutApp As Out.Application = CType(AppObjekt, Out.Application)
                If TypeOf OutApp.ActiveInspector.CurrentItem Is Out.MailItem Then
                    Dim Mi As Out.MailItem = CType(OutApp.ActiveInspector.CurrentItem, Out.MailItem)
                    Mi.Body &= Spruch & vbCrLf
                    Mi.Body &= Quelle
                End If
            Case "PowerPoint"
                Dim PPApp As PP.Application = CType(AppObjekt, PP.Application)
                If PPApp.ActivePresentation IsNot Nothing Then
                    Dim PPSh As PP.Shape = PPApp.ActivePresentation.Slides.Item(PPApp.ActivePresentation.Slides.Count).Shapes.AddLabel(Microsoft.Office.Core.MsoTextOrientation.msoTextOrientationHorizontal, 10, 10, 200, 32)
                    PPSh.TextFrame.TextRange.Text = Spruch & vbCrLf
                    PPSh.TextFrame.TextRange.Text &= "Quelle: " & Quelle
                End If
        End Select
    End Sub

    Private Sub bnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnRefresh.Click
        Dim XMlAbfrage As String = "//Zitate/Zitat["
        For Each Kat As String In cbKategorien.CheckedItems
            XMlAbfrage &= "@Kategorie='" & Kat & "' or "
        Next
        ' Das letzte " or " wieder abtrennen, also 4 Zeichen
        XMlAbfrage = XMlAbfrage.Substring(0, XMlAbfrage.Length - 4)
        XMlAbfrage &= "]"
        'MessageBox.Show(XMlAbfrage)
        Dim Zitate As XmlNodeList = XDoc.SelectNodes(XMlAbfrage)
        liZitate.Items.Clear()
        For Each ZitatNode As XmlNode In Zitate
            Dim Z As New Zitat
            Dim ZitatNr As Integer = CType(ZitatNode.Attributes("Nr").InnerText, Integer)
            Z.Spruch = ZitatNode.SelectSingleNode("Spruch").InnerText
            Z.ZitatNr = ZitatNr
            liZitate.Items.Add(Z)
        Next
    End Sub
End Class

Class Zitat
    Private mSpruch As String
    Private mZitatNr As Integer

    Property Spruch() As String
        Get
            Return mSpruch
        End Get
        Set(ByVal value As String)
            mSpruch = value
        End Set
    End Property

    Property ZitatNr() As Integer
        Get
            Return mZitatNr
        End Get
        Set(ByVal value As Integer)
            mZitatNr = value
        End Set
    End Property
End Class
