﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' -----------------------------------------------------------
Imports System.Xml
Imports System.IO
Imports System.Windows.Forms

Friend Class fmZitate
    Private XDoc As New XmlDocument
    Private mSpruch As String
    Private mQuelle As String

    Friend ReadOnly Property Spruch() As String
        Get
            Return mSpruch
        End Get
    End Property

    Friend ReadOnly Property Quelle() As String
        Get
            Return mQuelle
        End Get
    End Property

    Private Sub fmZitate_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Not e.CloseReason = CloseReason.UserClosing Then
            ' Formular mit Cancel-Result schließen
            Me.DialogResult = Windows.Forms.DialogResult.Cancel
        End If
    End Sub

    Private Sub frmZitate_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ZitatePfad As String = Path.Combine(Environment.GetEnvironmentVariable("userprofile"), "Zitate.xml")
        Try
            XDoc.Load(ZitatePfad)
            Dim Kategorien As XmlNodeList = XDoc.SelectNodes("//Kategorien/Kategorie")
            cbKategorien.Items.Clear()
            For Each Kat As XmlNode In Kategorien
                cbKategorien.Items.Add(Kat.InnerText)
            Next
        Catch ex As SystemException
            MessageBox.Show("Exception - " & ex.Message, ex.TargetSite.Name)
        End Try
        ' ListBox einrichten
        liZitate.DisplayMember = "Spruch"
    End Sub

    Private Sub bnZitatUebernehmen_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnZitatUebernehmen.Click
        If liZitate.SelectedIndex = -1 Then
            MessageBox.Show("Bitte ein Zitat auswählen!", My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        Dim ZitatPfad As String = "//Zitate/Zitat[@Nr='" & CType(CType(liZitate.SelectedItem, Zitat).ZitatNr, String) & "']"
        mQuelle = XDoc.SelectSingleNode(ZitatPfad).SelectSingleNode("Quelle").InnerText
        mSpruch = liZitate.Text
        ' Formular mit OK-Result schließen
        Me.DialogResult = Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub bnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnRefresh.Click
        Dim XMlAbfrage As String = "//Zitate/Zitat["
        For Each Kat As String In cbKategorien.CheckedItems
            XMlAbfrage &= "@Kategorie='" & Kat & "' or "
        Next
        ' Das letzte " or " wieder abtrennen, also 4 Zeichen
        XMlAbfrage = XMlAbfrage.Substring(0, XMlAbfrage.Length - 4)
        XMlAbfrage &= "]"
        'MessageBox.Show(XMlAbfrage)
        Dim Zitate As XmlNodeList = XDoc.SelectNodes(XMlAbfrage)
        liZitate.Items.Clear()
        For Each ZitatNode As XmlNode In Zitate
            Dim Z As New Zitat
            Dim ZitatNr As Integer = CType(ZitatNode.Attributes("Nr").InnerText, Integer)
            Z.Spruch = ZitatNode.SelectSingleNode("Spruch").InnerText
            Z.ZitatNr = ZitatNr
            liZitate.Items.Add(Z)
        Next
    End Sub
End Class

