﻿'HINWEIS: Wenn Sie den Namespace ändern, müssen Sie auf "XmlnsDefinitionAttribute" in "AssemblyInfo.vb" aktualisieren.
Public Class Workflow1
    Inherits SequentialWorkflowActivity

    Private TaskCompleted As Boolean = False

    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub
    Public workflowProperties As SPWorkflowActivationProperties = New Microsoft.SharePoint.Workflow.SPWorkflowActivationProperties
    Public Shared myTaskIDProperty As System.Workflow.ComponentModel.DependencyProperty = DependencyProperty.Register("myTaskID", GetType(System.Guid), GetType(VSTO_KaufvertragWorkflow.Workflow1))

    <System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <System.ComponentModel.BrowsableAttribute(True)> _
            <System.ComponentModel.CategoryAttribute("Sonstiges")> _
                Public Property myTaskID() As System.Guid
        Get
            Return CType(MyBase.GetValue(VSTO_KaufvertragWorkflow.Workflow1.myTaskIDProperty), System.Guid)

        End Get
        Set(ByVal value As System.Guid)
            MyBase.SetValue(VSTO_KaufvertragWorkflow.Workflow1.myTaskIDProperty, value)

        End Set
    End Property
    Public Shared myTaskPropertiesProperty As System.Workflow.ComponentModel.DependencyProperty = DependencyProperty.Register("myTaskProperties", GetType(Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties), GetType(VSTO_KaufvertragWorkflow.Workflow1))

    <System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <System.ComponentModel.BrowsableAttribute(True)> _
            <System.ComponentModel.CategoryAttribute("Sonstiges")> _
                Public Property myTaskProperties() As Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties
        Get
            Return CType(MyBase.GetValue(VSTO_KaufvertragWorkflow.Workflow1.myTaskPropertiesProperty), Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties)

        End Get
        Set(ByVal value As Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties)
            MyBase.SetValue(VSTO_KaufvertragWorkflow.Workflow1.myTaskPropertiesProperty, value)

        End Set
    End Property

    Private Sub MyTaskCreation(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Try
            myTaskID = Guid.NewGuid()
            myTaskProperties = New Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties
            myTaskProperties.PercentComplete = 0
            myTaskProperties.AssignedTo = System.Threading.Thread.CurrentPrincipal.Identity.Name
            myTaskProperties.DueDate = Now.AddDays(3)
            myTaskProperties.StartDate = Now
            myTaskProperties.Title = "Kaufvertrag-Workflow"
            myTaskProperties.Description = String.Format("Ein Kaufvertrag zwischen Käufer {0} und Verkäufer {1} über einen Betrag von {2}", _
             GetCustomFieldValue("Käufer"), GetCustomFieldValue("Verkäufer"), GetCustomFieldValue("Preis"))
        Catch ex As SystemException
            Throw New SystemException("Task kann nicht initialisiert werden.")
        End Try
    End Sub

    Function GetCustomFieldValue(ByVal FeldName As String) As String
        Try
            Dim PropItem As Object = Me.workflowProperties.Item(FeldName)
            Dim Wert As String = Me.workflowProperties.Item.Fields(FeldName).GetFieldValueAsText(PropItem)
            Return Wert
        Catch ex As SystemException
            Return String.Empty
        End Try
    End Function

    Private Sub myTaskNotCompleted(ByVal sender As System.Object, ByVal e As System.Workflow.Activities.ConditionalEventArgs)
        e.Result = Not TaskCompleted
    End Sub
    Public Shared afterMyTaskPropertyChangeProperty As System.Workflow.ComponentModel.DependencyProperty = DependencyProperty.Register("afterMyTaskPropertyChange", GetType(Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties), GetType(VSTO_KaufvertragWorkflow.Workflow1))

    <System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)> _
        <System.ComponentModel.BrowsableAttribute(True)> _
            <System.ComponentModel.CategoryAttribute("Sonstiges")> _
                Public Property afterMyTaskPropertyChange() As Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties
        Get
            Return CType(MyBase.GetValue(VSTO_KaufvertragWorkflow.Workflow1.afterMyTaskPropertyChangeProperty), Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties)

        End Get
        Set(ByVal value As Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties)
            MyBase.SetValue(VSTO_KaufvertragWorkflow.Workflow1.afterMyTaskPropertyChangeProperty, value)

        End Set
    End Property

    Private Sub onTaskChanged1_Invoked(ByVal sender As System.Object, ByVal e As System.Workflow.Activities.ExternalDataEventArgs)
        If afterMyTaskPropertyChange.PercentComplete = 1 Then
            TaskCompleted = True
        End If
    End Sub
End Class
