﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' -----------------------------------------------------------
Imports Sql = System.Data.SqlClient
Imports Oledb = System.Data.OleDb
Imports System.Windows.Forms

Module Module1

    Sub Main()
        'Dim Ds As DataSet = DsMitXmlUndSchemaLaden()
        'Dim Ds As DataSet = DsMitXmlLaden()
        'Dim Ds As DataSet = DsMitLoadLaden()
        'Console.WriteLine("DataSet mit {0} Tabellen, Tabelle 1 mit {1} Datensätzen.", _
        '                 Ds.Tables.Count, Ds.Tables(0).Rows.Count)
        TaMitXmlLesen()
        'TaAnlegen()
        'Dim Ds As DataSet = DsNurSchemaLaden()
        'Dim Ds As DataSet = DsMitDataTableLaden()
        'For Each Ta As DataTable In Ds.Tables
        'Console.WriteLine("Tabelle {0} mit {1} Zeilen.", Ta.TableName, Ta.Rows.Count)
        'Next
        Console.ReadLine()
    End Sub

    Sub TaAnlegen()
        Dim Ta As New DataTable("Buecher")
        Dim Dc As DataColumn = Ta.Columns.Add("Nr", GetType(Integer))
        Dc.AutoIncrement = True
        Dc.AutoIncrementSeed = 1000
        Ta.Constraints.Add("PK_Nr", Dc, True)
        Ta.Columns.Add("Titel", GetType(String))
        Ta.Columns.Add("Preis", GetType(Double))
        Ta.Columns.Add("NettoPreis", GetType(Double), "Preis/100*93")
        Dim NeueZeile As DataRow = Ta.NewRow()
        NeueZeile.Item("Titel") = "Alles klar mit Vaubeh"
        NeueZeile.Item("Preis") = 29.9
        Ta.Rows.Add(NeueZeile)
        Console.WriteLine("Titel-Nr: {0}, Titel: {1}, Netto-Preis: {2:C}", _
                          Ta.Rows(0).Item("Nr"), Ta.Rows(0).Item("Titel"), Ta.Rows(0).Item("NettoPreis"))
    End Sub

    Sub TaMitXmlLesen()
        Dim Ta As New DataTable("Buch")
        Ta.ReadXmlSchema("Buecher.xsd")
        Ta.ReadXml("Buecher.xml")
        Console.WriteLine("{0} Zeilen.", Ta.Rows.Count)
    End Sub

    Sub SQLServerDBLesen()
        Dim Csb As New Sql.SqlConnectionStringBuilder
        Csb.Add("Server", "HARIBO2007\SQLEXPRESS")
        Csb.Add("Trusted_Connection", "Yes")
        Csb.Add("Database", "Adventureworks")
        Csb.Add("Timeout", 60)
        Clipboard.SetText(Csb.ConnectionString)
        Try
            Using Cn As New Sql.SqlConnection(Csb.ConnectionString)
                Cn.Open()
                Dim Cmd As Sql.SqlCommand = Cn.CreateCommand
                Cmd.CommandText = "Select LastName From Person.Contact Order By LastName"
                Dim Dr As Sql.SqlDataReader = Cmd.ExecuteReader
                Console.ForegroundColor = ConsoleColor.Green
                While Dr.Read
                    Console.WriteLine(Dr.Item("LastName"))
                End While
            End Using
            Console.ForegroundColor = ConsoleColor.Cyan
            Dim Ta As DataTable = GetAccessTable()
            For Each Zeile As DataRow In Ta.Rows
                Console.WriteLine(Zeile.Item("NachName"))
            Next
            Console.ForegroundColor = ConsoleColor.Magenta
            Ta = GetExcelTable()
            For Each Zeile As DataRow In Ta.Rows
                Console.WriteLine(Zeile.Item(0))
            Next
        Catch ex As SystemException
            Console.ForegroundColor = ConsoleColor.Yellow
            Console.WriteLine("Fehlertyp: {0}, Fehlermeldung: {1}", ex.GetType().Name, _
                              ex.Message)
        End Try
    End Sub

    Function GetAccessTable() As DataTable
        Dim Csb As New Oledb.OleDbConnectionStringBuilder
        Csb.Provider = "Microsoft.Jet.Oledb.4.0"
        Csb.DataSource = "C:\Nordwind.mdb"
        Clipboard.SetText(Csb.ConnectionString)
        Try
            Using Cn As New Oledb.OleDbConnection(Csb.ConnectionString)
                Dim Da As New Oledb.OleDbDataAdapter("Select * From Personal", Csb.ConnectionString)
                Dim Ta As New DataTable("Personal")
                Da.Fill(Ta)
                Return Ta
            End Using
        Catch ex As SystemException
            Console.ForegroundColor = ConsoleColor.Yellow
            Console.WriteLine("Fehlertyp: {0}, Fehlermeldung: {1}", ex.GetType().Name, _
                              ex.Message)
        End Try

    End Function

    Function GetExcelTable() As DataTable
        Dim Csb As New Oledb.OleDbConnectionStringBuilder
        Csb.Provider = "Microsoft.Jet.Oledb.4.0"
        Csb.DataSource = "C:\Verkaufsdaten2008.xls"
        Csb.Add("Extended Properties", "Excel 8.0;HDR=Yes")
        Try
            Using Cn As New Oledb.OleDbConnection(Csb.ConnectionString)
                Dim Da As New Oledb.OleDbDataAdapter("Select * From [Verkauf2008$]", Csb.ConnectionString)
                Dim Ta As New DataTable("Verkauf2008")
                Da.Fill(Ta)
                Return Ta
            End Using
        Catch ex As SystemException
            Console.ForegroundColor = ConsoleColor.Yellow
            Console.WriteLine("Fehlertyp: {0}, Fehlermeldung: {1}", ex.GetType().Name, _
                              ex.Message)
        End Try

    End Function

    Function DsMitXmlUndSchemaLaden() As DataSet
        Dim Ds As New DataSet("Buecher")
        Ds.ReadXmlSchema("Buecher.xsd")
        Dim XmlPfad As String = "Buecher.xml"
        Ds.ReadXml(XmlPfad)
        Return Ds
    End Function

    Function DsMitXmlLaden() As DataSet
        Dim Ds As New DataSet("Buecher")
        Dim XmlPfad As String = "Buecher.xml"
        Ds.ReadXml(XmlPfad)
        Return Ds
    End Function

    Function DsNurSchemaLaden() As DataSet
        Dim Ds As New DataSet("Buecher")
        Ds.ReadXmlSchema("Buecher.xsd")
        Return Ds
    End Function

    Function DsMitDataTableLaden() As DataSet
        Dim Ds As New DataSet("Nw")
        Try
            Using Cn As New Sql.SqlConnection(My.Settings.NwCn)
                Cn.Open()
                Dim Cmd As Sql.SqlCommand = Cn.CreateCommand
                Cmd.CommandText = "Select * From Employees"
                Dim Dr As Sql.SqlDataReader = Cmd.ExecuteReader
                Dim Ta As New DataTable("Employees")
                Ta.Load(Dr)
                Ds.Tables.Add(Ta)
                Return Ds
            End Using
            Return Ds
        Catch ex As Sql.SqlException
            Console.ForegroundColor = ConsoleColor.Yellow
            Console.WriteLine("Fehlertyp: {0}, Fehlermeldung: {1}", ex.GetType().Name, _
                              ex.Message)
        Catch ex As SystemException
            Console.ForegroundColor = ConsoleColor.Yellow
            Console.WriteLine("Fehlertyp: {0}, Fehlermeldung: {1}", ex.GetType().Name, _
                              ex.Message)
        End Try
    End Function

    Function DsMitLoadLaden() As DataSet
        Try
            Using Cn As New Sql.SqlConnection(My.Settings.NwCn)
                Cn.Open()
                Dim Cmd As Sql.SqlCommand = Cn.CreateCommand
                Cmd.CommandText = "Select * From Employees"
                Dim Dr As Sql.SqlDataReader = Cmd.ExecuteReader
                Dim Ta As New DataTable("Employees")
                Ta.Load(Dr)
                Ta.Rows.Clear()
                Dim Ds As New DataSet("Nw")
                Ds.Tables.Add(Ta)
                Dr = Cmd.ExecuteReader
                Ds.Load(Dr, LoadOption.OverwriteChanges, Ta)
                Return Ds
            End Using
        Catch ex As Sql.SqlException
            Console.ForegroundColor = ConsoleColor.Yellow
            Console.WriteLine("Fehlertyp: {0}, Fehlermeldung: {1}", ex.GetType().Name, _
                              ex.Message)
        Catch ex As SystemException
            Console.ForegroundColor = ConsoleColor.Yellow
            Console.WriteLine("Fehlertyp: {0}, Fehlermeldung: {1}", ex.GetType().Name, _
                              ex.Message)
        End Try
    End Function

    Sub FillErrorProc(ByVal Sender As Object, ByVal e As FillErrorEventArgs)
        Console.WriteLine("Fehler beim Einlesen...")
        e.Continue = True
    End Sub
End Module
