﻿' -----------------------------------------------------------
' Office 2007-Programmierung, Microsoft Press
' Datenbindung "zu Fuss"
' -----------------------------------------------------------
Imports VSTO = Microsoft.Office.Tools.Excel

Public Class Tabelle1
    Private LiProds As VSTO.ListObject
    Private WithEvents cbSub As ComboBox
    Private TaSup As NwDs.SuppliersDataTable
    Private TaProd As NwDs.ProductsDataTable
    Private DaSup As NwDsTableAdapters.SuppliersTableAdapter
    Private DaProd As NwDsTableAdapters.ProductsTableAdapter

    Private Sub Tabelle1_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        Try
            DaSup = New NwDsTableAdapters.SuppliersTableAdapter
            TaSup = DaSup.GetData()
            Me.Range("A1").Value = "Hersteller"
            Dim R As Excel.Range = Me.Range("A2")
            cbSub = Me.Controls.AddComboBox(R.Left, R.Top + 1, 180, R.Height - 1, "Lieferanten")
            ' Schritt 2 - Anzeigen der Produkte des Herstellers in einer Liste
            Me.Range("D1").Value = "Produkte"
            R = Me.Range("D2")
            LiProds = Me.Controls.AddListObject(R, "Produkte")
            LiProds.AutoSetDataBoundColumnHeaders = True
            ' ComboBox darf erst jetzt gesetzt werden
            cbSub.ValueMember = "SupplierID"
            cbSub.DisplayMember = "CompanyName"
            cbSub.DataSource = TaSup
        Catch ex As SystemException
            MessageBox.Show(ex.Message, "Fehler in Tabelle1_Startup")
        End Try
    End Sub

    Private Sub Tabelle1_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        ' Hier passiert nichts
    End Sub

    Private Sub cbSub_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbSub.SelectedIndexChanged
        ' Hier wird die Liste mit den Produkten des Herstellers gefüllt
        DaProd = New NwDsTableAdapters.ProductsTableAdapter()
        TaProd = DaProd.GetProducts(cbSub.SelectedValue)
        LiProds.DataSource = TaProd
        LiProds.HeaderRowRange.Columns.AutoFit()
        LiProds.DataBodyRange.Columns(2).AutoFit()
        LiProds.DataBodyRange.HorizontalAlignment = Excel.XlHAlign.xlHAlignCenter
    End Sub

    Private Sub bnProdukteUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnProdukteUpdate.Click
        Dim AnzahlZeilen As Integer = DaProd.Update(TaProd)
        MessageBox.Show(AnzahlZeilen & " wurden aktualisiert.", My.Application.Info.Title)
    End Sub
End Class
