﻿Public Class Rechnungsauswahl

    Private TadProdQuery As AwDsTableAdapters.ProductTableAdapter
    Private TaProdukte As AwDs.ProductDataTable
    Private AktuellesProdukt As AwDs.ProductRow

    Private Sub bnArtikelAbrufen_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnArtikelAbrufen.Click
        Dim ProdID As Integer
        Dim ProdIdIsNumber As Boolean = Int32.TryParse(tbArtikelNr.Text, ProdID)
        If Not ProdIdIsNumber AndAlso ProdID = 0 Then
            lbStatus.Text = "ArtikelNr als Zahl eingeben (z.B. 780)."
            Exit Sub
        End If
        ' Liste mit gefundenen Artikeln vorsorglich leeren
        liArtikel.Items.Clear()
        TadProdQuery = New AwDsTableAdapters.ProductTableAdapter
        TaProdukte = TadProdQuery.GetProducByID(ProdID)
        If TaProdukte.Rows.Count > 0 Then
            tbArtikel.Text = TaProdukte.Rows(0).Item("Name")
            lbStatus.Text = "Abfrage wurde ausgeführt."
        Else
            lbStatus.Text = "Kein Ergebnis."
        End If

    End Sub

    Private Sub bnSuchen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnSuchen.Click
        If tbProduktName.Text = "" Then
            lbStatus.Text = "Produktname eingeben (z.B. 'helmet')."
            Exit Sub
        End If
        TadProdQuery = New AwDsTableAdapters.ProductTableAdapter
        TaProdukte = TadProdQuery.GetProductByName("%" & tbProduktName.Text & "%")
        If TaProdukte.Rows.Count > 0 Then
            liArtikel.Items.Clear()
            For Each Dr In TaProdukte.Rows
                liArtikel.Items.Add(Dr.item("Name"))
            Next
            lbStatus.Text = TaProdukte.Rows.Count & " Artikel."
        Else
            lbStatus.Text = "Kein Ergebnis."
        End If
    End Sub

    Private Sub liArtikel_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles liArtikel.MouseMove
        Dim ArtikelIndex As Integer = liArtikel.IndexFromPoint(e.Location)
        If ArtikelIndex <> -1 Then
            ToolTip1.SetToolTip(liArtikel, TaProdukte.Rows(ArtikelIndex).Item("Name"))
        Else
            ToolTip1.SetToolTip(liArtikel, "")
        End If
    End Sub

    Private Sub liArtikel_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles liArtikel.SelectedIndexChanged
        Dim ArtikelIndex As Integer = liArtikel.SelectedIndex
        If ArtikelIndex <> -1 Then
            AktuellesProdukt = TaProdukte.Rows(ArtikelIndex)
            tbProductID.Text = AktuellesProdukt.ProductID
            tbProdName.Text = AktuellesProdukt.Name
            tbProductNumber.Text = AktuellesProdukt.ProductNumber
            ToolTip1.SetToolTip(tbProdName, AktuellesProdukt.Name)
        End If
    End Sub

    Private Sub Rechnungsauswahl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Width = 220
        tbArtikelNr.Text = "680"
    End Sub

    Private Sub bnArtikelAusListeEinfuegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnArtikelAusListeEinfuegen.Click
        ' Sicherstellen, dass ein Artikel ausgewählt ist
        If liArtikel.SelectedIndex <> -1 Then
            ArtikelDatenEinfügen(TaProdukte.Rows(liArtikel.SelectedIndex))
        Else
            lbStatus.Text = "Keine Artikeldaten vorhanden."
        End If
    End Sub

    Private Sub ArtikelDatenEinfügen(ByVal Prod As AwDs.ProductRow)
        Dim NeueZeile As Excel.ListRow = Globals.Tabelle1.liRechnung.ListRows.AddEx()
        Dim Bereich As Excel.Range = NeueZeile.Range.Item(1, 1)
        With Bereich
            .Value2 = Prod.ProductNumber
            .Offset(ColumnOffset:=1).Value2 = Prod.Name
            ' Für den Fall, dass es keinen Wert gibt
            .Offset(ColumnOffset:=2).Value2 = Prod.Color & ""
            .Offset(ColumnOffset:=3).Value2 = Prod.ListPrice
        End With
    End Sub

    Private Sub bnArtikelDirektEinfuegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnArtikelDirektEinfuegen.Click
        ' Sicherstellen, dass wirklich Produkt abgerufen wurde
        If TaProdukte.Rows.Count = 1 Then
            ArtikelDatenEinfügen(TaProdukte.Rows(0))
        Else
            lbStatus.Text = "Keine Artikeldaten vorhanden."
        End If
    End Sub

    ' Ausgewählten Eintrag direkt einfügen
    Private Sub liArtikel_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles liArtikel.DoubleClick
        ' Sicherstellen, dass ein Artikel ausgewählt ist
        If liArtikel.SelectedIndex <> -1 Then
            ArtikelDatenEinfügen(TaProdukte.Rows(liArtikel.SelectedIndex))
        End If
    End Sub
End Class
