﻿' Beispiele für API-Funktionen
Imports System.Runtime.InteropServices
Imports System.Text
Imports System.IO

Public Class Form1
    Private IniPfad As String = My.Application.Info.DirectoryPath & "\Werte.ini"
    Private Const SWP_SHOWWINDOW As Integer = &H40
    Private Const SWP_HIDEWINDOW As Integer = &H80

    Delegate Function EnumWindowsProc(ByVal hWnd As System.IntPtr, ByVal lParam As IntPtr) As Boolean
    Declare Function EnumWindows Lib "User32" (ByVal lpEnumFunc As EnumWindowsProc, ByVal lParam As Integer) As Integer

    <DllImport("user32.dll", EntryPoint:="FindWindow", SetLastError:=True, CharSet:=CharSet.Auto)> _
Private Shared Function FindWindowByCaption( _
     ByVal zero As IntPtr, _
     ByVal lpWindowName As String) As IntPtr
    End Function

    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Ansi)> _
Private Shared Function GetWindowText(ByVal hwnd As IntPtr, _
                       ByVal lpString As Byte(), _
                       ByVal cch As Integer) As Integer
    End Function

    <DllImport("user32.dll", SetLastError:=True)> _
Private Shared Function SetWindowPos(ByVal hWnd As IntPtr, _
     ByVal hWndInsertAfter As IntPtr, _
     ByVal X As Integer, _
     ByVal Y As Integer, _
     ByVal cx As Integer, _
     ByVal cy As Integer, _
     ByVal uFlags As UInteger) As Boolean
    End Function

    <DllImport("kernel32.dll", SetLastError:=True, CharSet:=CharSet.Ansi)> _
  Private Shared Function GetPrivateProfileString(ByVal lpAppName As String, _
                          ByVal lpKeyName As String, _
                          ByVal lpDefault As String, _
                          ByVal lpReturnedString() As Byte, _
                          ByVal nSize As Integer, _
                          ByVal lpFileName As String) As Integer
    End Function

    '<DllImport("kernel32.dll")> _
    '    Shared Function GetPrivateProfileSectionNames( _
    '    ByVal lpszReturnBuffer As IntPtr, ByVal nSize As System.Int32, ByVal lpFileName As String) As System.Int32
    'End Function
    Private Declare Ansi Function GetPrivateProfileSectionNames Lib "kernel32" Alias "GetPrivateProfileSectionNamesA" (ByVal lpszReturnBuffer() As Byte, ByVal nSize As Integer, ByVal lpFileName As String) As Integer


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        tbX.Text = "0"
        tbY.Text = "0"
        tbBreite.Text = "800"
        tbHoehe.Text = "600"
    End Sub

    Private Sub bnLokalisieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnLokalisieren.Click
        Dim hWnd As IntPtr = FindWindowByCaption(IntPtr.Zero, tbTitel.Text)
        If hWnd <> IntPtr.Zero Then
            tbFensterHandle.Text = hWnd
        Else
            tbFensterHandle.Text = 0
        End If
    End Sub

    Private Sub bnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnRefresh.Click
        Using Sr As New StreamReader(IniPfad)
            tbIniDatei.Text = Sr.ReadToEnd()
        End Using
        Dim SektionsPuffer(1024) As Byte
        Dim Ret As Integer
        Ret = GetPrivateProfileSectionNames(SektionsPuffer, 1024, IniPfad)
        Dim Sektionen() As String = Encoding.ASCII.GetString(SektionsPuffer).Trim(ControlChars.NullChar).Split(ControlChars.NullChar)
        liSektionen.Items.Clear()
        For Each Sektion As String In Sektionen
            liSektionen.Items.Add(Sektion)
        Next
    End Sub

    'Speziellere Techniken
    'Dim ptr As IntPtr = Marshal.StringToHGlobalAnsi(New String(vbNullChar, 1024))
    'Dim buff As String = Marshal.PtrToStringAnsi(ptr, len)
    'Marshal.FreeHGlobal(ptr)

    Private Sub bnUpdateIniDatei_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnUpdateIniDatei.Click
        Using Sw As New StreamWriter(IniPfad)
            Sw.Write(tbIniDatei.Text)
        End Using
    End Sub

    Private Sub liSektionen_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles liSektionen.SelectedIndexChanged
        Dim Sektion As String = liSektionen.Text
        Dim SektionsPuffer(1024) As Byte
        Dim Ret As Integer
        Ret = GetPrivateProfileString(Sektion, vbNullString, "Keine Namen", SektionsPuffer, 1024, IniPfad)
        Dim Eintraege() As String = Encoding.ASCII.GetString(SektionsPuffer).Trim(ControlChars.NullChar).Split(ControlChars.NullChar)
        liEintraege.Items.Clear()
        For Each Eintrag As String In Eintraege
            liEintraege.Items.Add(Eintrag)
        Next
    End Sub

    Private Sub liEintraege_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles liEintraege.SelectedIndexChanged
        Dim Eintrag As String = liEintraege.Text
        Dim Sektion As String = liSektionen.Text
        Dim SektionsPuffer(1024) As Byte
        Dim Ret As Integer
        Ret = GetPrivateProfileString(Sektion, Eintrag, "Kein Wert", SektionsPuffer, 1024, IniPfad)
        Dim Wert As String = Encoding.ASCII.GetString(SektionsPuffer).Trim(ControlChars.NullChar)
        tbWert.Text = Wert
    End Sub

    Private Sub bnFensterAuflisten_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnFensterAuflisten.Click
        liFenster.Items.Clear()
        EnumWindows(New EnumWindowsProc(AddressOf WindowsProc), 0)
        lbAnzahlFenster.Text = liFenster.Items.Count & " Fenster"
    End Sub

    Function WindowsProc(ByVal hWnd As IntPtr, ByVal lParam As Integer) As Boolean
        Dim FensterName As String = GetFensterName(hWnd)
        If FensterName.Trim(ControlChars.NullChar) <> "" Then
            liFenster.Items.Add(FensterName)
        End If
        Return True
    End Function

    Function GetFensterName(ByVal hWnd As IntPtr) As String
        Dim tmpBuffer(256) As Byte
        Dim Ret As Integer = GetWindowText(hWnd, tmpBuffer, tmpBuffer.Length)
        Return Encoding.ASCII.GetString(tmpBuffer)
    End Function

    Private Sub bnAktivieren_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnAktivieren.Click
        Dim hWnd As New IntPtr(CType(tbFensterHandle.Text, Integer))
        Dim Breite, Hoehe, X, Y As Integer
        Breite = tbBreite.Text
        Hoehe = tbHoehe.Text
        X = tbX.Text
        Y = tbY.Text
        X = (My.Computer.Screen.WorkingArea.Width - Breite) \ 2
        Y = (My.Computer.Screen.WorkingArea.Height - Hoehe) \ 2
        SetWindowPos(hWnd, IntPtr.Zero, 0, 0, Breite, Hoehe, SWP_SHOWWINDOW)
    End Sub
End Class
