﻿Module Module1
    Private Buecher As New List(Of Buch)
    Private Autoren As New List(Of Autor)

    Sub Main()
        InitDaten()
        ' Alle Buecher, die 2007 erschienen sind
        Dim Titel2007 = From B In Buecher Where B.ErschJahr = 2007 Select B
        Console.ForegroundColor = ConsoleColor.Green
        Console.WriteLine("2007-Bücher:")
        For Each T In Titel2007
            Console.WriteLine("Titel: {0}, Preis: {1}", T.Titel, T.Preis)
        Next
        ' Alle Autoren, die 2007 ein Buch veröffentlich haben
        Console.ForegroundColor = ConsoleColor.Magenta
        Console.WriteLine("2007-Autoren:")
        Dim Autoren2007 = From B In Buecher Join A In Autoren On B.AutorID Equals A.AutorID Where B.ErschJahr = 2007 Select A
        For Each A In Autoren2007
            Console.WriteLine("Autor: {0}", A.Name)
        Next
        ' Die Summe aller Preise der 2008-Bücher
        Console.ForegroundColor = ConsoleColor.Gray
        Dim Summe2008 = (From B In Buecher Where B.ErschJahr = 2008 Select B.Preis).Sum
        Console.WriteLine("Alle 2008er-Bücher kosten: " & Summe2008)
        ' Der Autor mit dem teuersten Buch 
        Dim TeuersterAutor = (From B In Buecher Join A In Autoren On B.AutorID Equals A.AutorID Where B.Preis = (From B1 In Buecher Select B1.Preis).Max Select A.Name).First
        Console.WriteLine("Der teuerste Autor: " & TeuersterAutor)
        Console.ReadLine()
    End Sub

    Sub InitDaten()
        Buecher.Add(New Buch With {.AutorID = 1, .ErschJahr = 2007, .Preis = 10, .Titel = "Alles über VB9"})
        Buecher.Add(New Buch With {.AutorID = 1, .ErschJahr = 2008, .Preis = 20, .Titel = "VB9-Geheimnisse"})
        Buecher.Add(New Buch With {.AutorID = 2, .ErschJahr = 2008, .Preis = 30, .Titel = "Der große Bluff - VB9"})
        Buecher.Add(New Buch With {.AutorID = 2, .ErschJahr = 2007, .Preis = 40, .Titel = "C# als Offenbarung"})
        Buecher.Add(New Buch With {.AutorID = 3, .ErschJahr = 2007, .Preis = 125, .Titel = "VB als die neue Mitte"})
        Autoren.Add(New Autor With {.AutorID = 1, .Name = "Otto Optimist"})
        Autoren.Add(New Autor With {.AutorID = 2, .Name = "Dr. Pia Pessimist"})
        Autoren.Add(New Autor With {.AutorID = 3, .Name = "Guido Dauerwelle"})
    End Sub

End Module

Class Buch
    Friend Titel As String
    Friend ErschJahr As Integer
    Friend Preis As Single
    Friend AutorID As Integer
End Class

Class Autor
    Friend AutorID As Integer
    Friend Name As String
End Class