﻿' Beispiele für Reflection
Imports System.Reflection
Imports System.IO

Module Module1

    Sub Main()
        ' Die Namen aller Klassen auflisten
        Dim Ass As Assembly = Assembly.GetEntryAssembly
        Dim Typen() As Type = Ass.GetTypes
        Console.ForegroundColor = ConsoleColor.Green
        Console.WriteLine("Die Klassen in der Assembly:")
        For Each Typ As Type In Typen
            If Typ.IsClass Then
                Console.WriteLine("Die Klasse: {0}", Typ.Name)
            End If
        Next
        ' Die Namen der Eigenschaften ausgeben
        Console.ForegroundColor = ConsoleColor.Magenta
        Console.WriteLine("Die Properties in der Klasse A:")
        For Each Prop As PropertyInfo In GetType(A).GetProperties()
            Console.WriteLine("Die Property: {0}", Prop.Name)
        Next
        ' Jetzt die Werte der Eigenschaften ausgeben
        ' Dazu muss die Klasse natürlich instanziert werden
        Dim AInstanz As A = Ass.CreateInstance("VSTOReflectionBeispiel.A")
        Console.WriteLine("Der Wert ist: {0}", AInstanz.P1)
        ' Jetzt eine Assembly laden, die eine Methode M1 besitzt, die einen
        ' Byte-Wert mit einem Zufallswert zurück gibt
        Dim AppPfad As String = My.Application.Info.DirectoryPath
        Dim AssPfad As String = Path.Combine(AppPfad, "..\..\..\ZufallsLib\bin\debug\ZufallsLib.dll")
        Dim AssLib As Assembly = Assembly.LoadFile(AssPfad)
        Dim AssLibKlasse As Type = AssLib.GetType("ZufallsLib.Zufall")
        Dim M As MethodInfo = AssLibKlasse.GetMethod("GetZahl", BindingFlags.Static + BindingFlags.Public)
        Dim ZufallsZahl As Byte = M.Invoke(Nothing, Nothing)
        Console.WriteLine("Die Zufallszahl: {0}", ZufallsZahl)
        Console.ReadLine()
    End Sub

End Module

Class A
    ReadOnly Property P1()
        Get
            Return 123
        End Get
    End Property

    ReadOnly Property P2()
        Get
            Return 456
        End Get
    End Property

End Class

Class B

End Class

Class C

End Class