﻿' Beispiele für Registry-Zugriffe
Imports Microsoft.Win32

Module Module1
    Const AddinKey As String = "Software\Microsoft\Office\Excel\AddIns"
    Dim SubKeyName As String

    Sub Main()
        ' Alle Excel-Add-Ins-Einträge auslesen
        Using R As RegistryKey = Registry.CurrentUser.OpenSubKey(AddinKey)
            Console.ForegroundColor = ConsoleColor.Blue
            For Each W As String In R.GetSubKeyNames()
                Console.WriteLine(W)
                SubKeyName = W
            Next
            ' Die Namen und Werte eines Schlüssels
            SubKeyName = AddinKey & "\" & SubKeyName
            Using R1 As RegistryKey = Registry.CurrentUser.OpenSubKey(SubKeyName)
                Console.ForegroundColor = ConsoleColor.Yellow
                Console.WriteLine("Die Namen in {0}", SubKeyName)
                For Each N As String In R1.GetValueNames()
                    Dim W As Object = R1.GetValue(N)
                    Console.WriteLine("Name: {0}, Wert: {1}", N, W)
                Next
            End Using
            ' Einen neuen Add-In-Unterschlüssel anlegen
            Using R2 As RegistryKey = Registry.CurrentUser.OpenSubKey(AddinKey, True)
                Dim RkNeu As RegistryKey = R2.CreateSubKey("TestKey")
                RkNeu.SetValue("", "Ein Standardwert")
                RkNeu.SetValue("LoadBehavior", 3)
                RkNeu.SetValue("Description", "Nur ein Test")
                Console.ForegroundColor = ConsoleColor.White
                Console.WriteLine("Registry-Schlüssel wurde angelegt!")
            End Using
        End Using
        ' Alle Excel-Add-Ins per My-Namespace auflisten
        Console.WriteLine("Jetzt mit dem My-Namespace:")
        Console.ForegroundColor = ConsoleColor.Green
        For Each K As String In My.Computer.Registry.CurrentUser.OpenSubKey(AddinKey).GetSubKeyNames
            Console.WriteLine(K)
        Next
        Console.ReadLine()
    End Sub

End Module
