﻿' Ein paar Beispiele für den Umgang mit Zertifikaten
Imports System.Security.Cryptography
Imports System.Security.Cryptography.X509Certificates

Module Module1

    Sub Main()
        Dim CertBytes() As Byte
        Try
            ' Ein Zertifikat direkt laden - Datei muss natürlich existieren!
            Dim Z As New X509Certificate2("C:\Pemo2008.cer")
            ' Zertifikatinformation anzeigen
            X509Certificates.X509Certificate2UI.DisplayCertificate(Z)
            ' Die Ablage mit den eigenen Zertifikaten öffnen
            Dim XStore As New X509Store(StoreName.My, StoreLocation.CurrentUser)
            XStore.Open(OpenFlags.ReadWrite)
            ' Alle Zertifikate durchgehen und ihnen einen Friendly Name verpassen
            Dim Anzahl As Integer
            For Each Cert As X509Certificate2 In XStore.Certificates
                Anzahl += 1
                If Cert.FriendlyName <> "" Then
                    Console.WriteLine("Name: " & Cert.FriendlyName)
                    Console.ForegroundColor = ConsoleColor.Cyan
                    Console.WriteLine("Subject: " & Cert.Subject)
                    Console.ForegroundColor = ConsoleColor.White
                Else
                    Cert.FriendlyName = "Zertifikat Nr. " & Anzahl
                End If
            Next
            ' Exportieren eines Zertifikats in eine Byte-Folge
            CertBytes = XStore.Certificates(0).Export(X509ContentType.SerializedCert)
            XStore.Close()
            ' Öffnen der Ablage für vertrauenswürdige Stammzertifizierungsstellen
            Dim PubStore As New X509Store(StoreName.Root, StoreLocation.CurrentUser)
            PubStore.Open(OpenFlags.ReadWrite)
            ' Importieren der zuvor exportierten Byte-Folge
            PubStore.Certificates.Import(CertBytes)
            PubStore.Close()
        Catch ex As CryptographicException
            Console.WriteLine("Crypto-Error: " & ex.Message)
        Catch ex As SystemException
            Console.WriteLine("System-Error: " & ex.Message)
        End Try
        Console.ReadLine()
    End Sub

End Module
