﻿Imports System.ComponentModel
Imports System.Configuration.Install

Public Class Installer1
#If DEBUG Then
    Private Const DebugMode As Boolean = True
#Else
    Private Const DebugMode As Boolean = False
#End If

    Public Sub New()
        MyBase.New()

        'Dieser Aufruf ist für den Komponenten-Designer erforderlich.
        InitializeComponent()

        'Initialisierungscode nach dem Aufruf von InitializeComponent hinzufügen

    End Sub

    Public Overrides Sub Install(ByVal stateSaver As System.Collections.IDictionary)
        ' Aufruf von certmgr -add -c Ex07_TrustPromptBeispiel.cer -s Root
        Dim CertArgs As String = "-add -c Ex07_TrustPromptBeispiel.cer -s Root"
        Dim AppDir As String = Me.Context.Parameters("AppDir")
        Dim CertPfad As String = AppDir & "Certmgr.exe"
        Dim PI As New ProcessStartInfo(CertPfad, CertArgs)
        PI.WindowStyle = ProcessWindowStyle.Hidden
        ' Wichtig, sonst funzt es nicht
        PI.WorkingDirectory = AppDir
        Try
            If DebugMode Then
                System.Diagnostics.Debugger.Break()
            End If
            Dim P As Process = Process.Start(PI)
            P.WaitForExit()
        Catch ex As SystemException
            EventLog.WriteEntry(My.Application.Info.Title, "Error in Install: " & ex.Message, EventLogEntryType.Error)
        End Try
        ' Jetzt Zertifikat auch zur Ablage Vetraute Hersteller hinzufügen
        CertArgs = "-add -c Ex07_TrustPromptBeispiel.cer -s TrustedPublisher"
        PI = New ProcessStartInfo(CertPfad, CertArgs)
        PI.WindowStyle = ProcessWindowStyle.Hidden
        PI.WorkingDirectory = AppDir
        Try
            If DebugMode Then
                System.Diagnostics.Debugger.Break()
            End If
            Dim P As Process = Process.Start(PI)
            P.WaitForExit()
        Catch ex As SystemException
            EventLog.WriteEntry(My.Application.Info.Title, "Error in Install: " & ex.Message, EventLogEntryType.Error)
        End Try

        MyBase.Install(stateSaver)
    End Sub

    Public Overrides Sub Uninstall(ByVal savedState As System.Collections.IDictionary)
        ' Es wird davon ausgegangen, dass der Name in Ausgestellt für-Spalte
        ' der Domänen/Workgroup- Benutzernamen-Kombination entspricht
        Dim ZertName As String = Environment.UserDomainName & "\" & Environment.UserName
        Dim CertArgs As String = "-del -c -n " & ZertName & " -s Root"
        Dim AppDir As String = Me.Context.Parameters("AppDir")
        Dim CertPfad As String = AppDir & "Certmgr.exe"
        Dim PI As New ProcessStartInfo(CertPfad, CertArgs)
        PI.WindowStyle = ProcessWindowStyle.Hidden
        PI.WorkingDirectory = AppDir
        Try
            If DebugMode Then
                System.Diagnostics.Debugger.Break()
            End If
            Dim P As Process = Process.Start(PI)
            P.WaitForExit()
        Catch ex As SystemException
            EventLog.WriteEntry(My.Application.Info.Title, "Error in Uninstall: " & ex.Message, EventLogEntryType.Error)
        End Try
        CertArgs = "-del -c -n " & ZertName & " -s Trusted Publisher"
        PI = New ProcessStartInfo(CertPfad, CertArgs)
        PI.WindowStyle = ProcessWindowStyle.Hidden
        PI.WorkingDirectory = AppDir
        Try
            If DebugMode Then
                System.Diagnostics.Debugger.Break()
            End If
            Dim P As Process = Process.Start(PI)
            P.WaitForExit()
        Catch ex As SystemException
            EventLog.WriteEntry(My.Application.Info.Title, "Error in Uninstall: " & ex.Message, EventLogEntryType.Error)
        End Try
        MyBase.Uninstall(savedState)
    End Sub

    Public Overrides Sub Commit(ByVal savedState As System.Collections.IDictionary)
        MyBase.Commit(savedState)
    End Sub

    Public Overrides Sub Rollback(ByVal savedState As System.Collections.IDictionary)
        MyBase.Rollback(savedState)
    End Sub
End Class
