﻿' Excel 2007-Add-In zur Inklusionlist hinzufügen
Imports System.ComponentModel
Imports System.Configuration.Install
Imports System.Security
Imports System.Security.Permissions
Imports Microsoft.VisualStudio.Tools.Office.Runtime.Security

Public Class AddInInstaller
    ' Stammt aus Vsto-Datei
    Private Const RSA_PublicKey As String = "<RSAKeyValue><Modulus>sNGD/+TsKbciw8g3xdDv0DL/7ujXZDGBKP1h8E/T6nAQFhFhUjWz4nbrqAw+OrtECsa1UZqqfaDN/WMwLMqbUo2xBUqKM9fbN/8/HxU8yClexqM/TbStdMJm2VKm61q3WiYJ/eRcWnUzLfoTuD+YEkofT7u/pm3/dBzpge/KXpc=</Modulus><Exponent>AQAB</Exponent></RSAKeyValue>"

    Public Sub New()
        MyBase.New()
        'Dieser Aufruf ist für den Komponenten-Designer erforderlich.
        InitializeComponent()
        'Initialisierungscode nach dem Aufruf von InitializeComponent hinzufügen
    End Sub

    Public Overrides Sub Install(ByVal stateSaver As System.Collections.IDictionary)
        Try
            ' Ist die erforderliche FullTrust-Berechtigung vorhanden?
            Dim SecPerm As New SecurityPermission(PermissionState.Unrestricted)
            SecPerm.Demand()
        Catch Ex As SecurityException
            Throw New InstallException("Keine ausreichendenden .NET-Berechtigungen. Add-In muss direkt durch Aufruf der Vsto-Datei installiert werden.")
        End Try
        Dim DeployManifestLocationString As String = MyBase.Context.Parameters.Item("deploymentManifestLocation")
        Dim DeployManifestLocationUri As Uri = Nothing
        If Not Uri.TryCreate(DeployManifestLocationString, UriKind.RelativeOrAbsolute, DeployManifestLocationUri) Then
            Throw New InstallException("Verzeichnispfad der Vsto-Datei nicht vorhanden oder ungültig.")
        End If
        Dim SecEntry As New AddInSecurityEntry(DeployManifestLocationUri, RSA_PublicKey)
        UserInclusionList.Add(SecEntry)
        stateSaver.Add("entryKey", DeployManifestLocationUri)
        MyBase.Install(stateSaver)
    End Sub

    Public Overrides Sub Uninstall(ByVal savedState As System.Collections.IDictionary)
        Dim DeployManifestLocation As Uri = DirectCast(savedState.Item("entryKey"), Uri)
        If Not DeployManifestLocation Is Nothing Then
            UserInclusionList.Remove(DeployManifestLocation)
        End If
        MyBase.Uninstall(savedState)
    End Sub

    Public Overrides Sub Commit(ByVal savedState As System.Collections.IDictionary)
        MyBase.Commit(savedState)
    End Sub

    Public Overrides Sub Rollback(ByVal savedState As System.Collections.IDictionary)
        MyBase.Rollback(savedState)
    End Sub
End Class
