' Anpassen des Manifest-Assemblypfades
Imports VSTO = Microsoft.VisualStudio.Tools.Applications.Runtime
Imports VSTO3 = Microsoft.VisualStudio.Tools.Applications
Imports System.IO

Public Class fmHaupt
    Private UseSd3 As Boolean

    Private Sub fmHaupt_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '
    End Sub

    Private Sub bnChooseDok_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnChooseDok.Click
        Using Ofd As New OpenFileDialog
            With Ofd
                .Filter = "Excel-Arbeitsmappen (*.xls)|*.xls|Excel 2007-Dokumente (*.xlsx)|*.xlsx|Word-Dokumente (*.doc)|*.doc|Word 2007-Dokumente (*.docx)|*.docx|Alle Dateien|*.*"
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    tbDocPfad.Text = .FileName
                    If Path.GetExtension(.FileName) = ".docx" OrElse Path.GetExtension(.FileName) = ".dotx" Or Path.GetExtension(.FileName) = ".xlsx" Then
                        UseSd3 = True
                        If VSTO3.ServerDocument.IsCustomized(.FileName) Then
                            lbIsCustomized.Text = VSTO3.ServerDocument.IsCustomized(.FileName)
                            Try
                                Using Sd3 As New VSTO3.ServerDocument(.FileName)
                                    tbAssPfad.Text = Sd3.DeploymentManifestUrl.ToString
                                End Using
                            Catch ex As SystemException
                                tbStatus.Text = "System-Error: " & ex.Message
                            End Try
                        Else
                            MessageBox.Show("Dokument ist nicht Customized!")
                            tbAssPfad.Text = ""
                        End If
                    Else
                        UseSd3 = False
                        lbIsCustomized.Text = VSTO.ServerDocument.IsCustomized(.FileName).ToString
                        If VSTO.ServerDocument.IsCustomized(.FileName) Then
                            Try
                                Using Sd As New VSTO.ServerDocument(.FileName)
                                    tbAssPfad.Text = Sd.AppManifest.Dependency.AssemblyPath
                                End Using
                            Catch Ex As VSTO.InvalidManifestException
                                tbStatus.Text = "Manifest-Error: " & Ex.Message
                            Catch Ex As System.Exception
                                tbStatus.Text = "System-Error: " & Ex.Message
                            End Try
                        Else
                            MessageBox.Show("Dokument ist nicht Customized!")
                            tbAssPfad.Text = ""
                        End If
                    End If
                End If
            End With
        End Using
    End Sub

    Private Sub bnChooseAssPfad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnChooseAssPfad.Click
        Using Ofd As New OpenFileDialog
            With Ofd
                .Filter = "Assembly-Datei|*.dll|Alle Dateien|*.*"
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    tbAssNeuPfad.Text = .FileName
                End If
            End With
        End Using
    End Sub

    Private Sub bnAnpassen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnAnpassen.Click
        If tbDocPfad.Text = "" Then Exit Sub
        If tbAssPfad.Text = "" Then Exit Sub
        If UseSd3 = False Then
            Try
                Using Sd As New VSTO.ServerDocument(tbDocPfad.Text)
                    Sd.AppManifest.Dependency.AssemblyPath = tbAssNeuPfad.Text
                    Sd.Save()
                    TsStatusFeld.Text = "Anpassung wurde vorgenommen."
                    tbStatus.Text = "OK."
                End Using
            Catch Ex As VSTO.InvalidManifestException
                tbStatus.Text = "Manifest-Error: " & Ex.Message
            Catch Ex As System.Exception
                tbStatus.Text = "System-Error: " & Ex.Message
            End Try
        Else
            Try
                Dim ManifestPfad As String
                If VSTO3.ServerDocument.IsCustomized(tbDocPfad.Text) Then
                    VSTO3.ServerDocument.RemoveCustomization(tbDocPfad.Text)
                    MessageBox.Show("Anpassung wurde entfernt!")
                End If
                Using Ofd As New OpenFileDialog
                    Ofd.Filter = ".vsto|*.vsto|Alle Dateien|*.*"
                    If Ofd.ShowDialog = Windows.Forms.DialogResult.OK Then
                        ManifestPfad = Ofd.FileName
                    Else
                        Exit Sub
                    End If
                    'Dim SolutionID As New Guid("bddfe828-929e-445a-ad76-5f6c778f909a")
                    VSTO3.ServerDocument.AddCustomization(tbDocPfad.Text, New System.Uri(ManifestPfad, UriKind.RelativeOrAbsolute))
                    TsStatusFeld.Text = "Anpassung wurde vorgenommen."
                    tbStatus.Text = "OK."
                End Using
            Catch Ex As VSTO.InvalidManifestException
                tbStatus.Text = "Manifest-Error: " & Ex.Message
            Catch Ex As System.Exception
                tbStatus.Text = "System-Error: " & Ex.Message
            End Try
        End If
    End Sub
End Class
