<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                xmlns:b="http://schemas.openxmlformats.org/officeDocument/2006/bibliography">
  <xsl:output method="html" encoding="utf-8"/>
  <xsl:template match="/">
    <xsl:apply-templates select="*" />
  </xsl:template>
  <xsl:template match="b:StyleName">
    <xsl:text>Einfaches Literaturverzeichnis</xsl:text>
  </xsl:template>
  <xsl:template match="b:GetImportantFields[b:SourceType = 'Book']">
    <b:ImportantFields>
      <b:ImportantField>
        <xsl:text>b:Author/b:Author/b:NameList</xsl:text>
      </b:ImportantField>
      <b:ImportantField>
        <xsl:text>b:Title</xsl:text>
      </b:ImportantField>
      <b:ImportantField>
        <xsl:text>b:Publisher</xsl:text>
      </b:ImportantField>
      <b:ImportantField>
        <xsl:text>b:City</xsl:text>
      </b:ImportantField>
      <b:ImportantField>
        <xsl:text>b:Year</xsl:text>
      </b:ImportantField>
    </b:ImportantFields>
  </xsl:template>
  <xsl:template match="b:Source[b:SourceType = 'Book']">
    <xsl:element name="p">
      <b>
        <xsl:value-of select="b:Author/b:Author/b:NameList/b:Person/b:Last"/>
        <xsl:text>, </xsl:text>
        <xsl:value-of select="b:Author/b:Author/b:NameList/b:Person/b:First"/>
        <xsl:text>: </xsl:text>
      </b>
      <xsl:value-of select="b:Title"/>
      <xsl:text>. </xsl:text>
      <xsl:value-of select="b:Publisher"/>
      <xsl:text>, </xsl:text>
      <xsl:value-of select="b:City"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="b:Year"/>
      <xsl:text>.</xsl:text>
    </xsl:element>
  </xsl:template>
  <xsl:template match="b:bliography">
    <html xmlns="http://www.w3.org/TR/REC-html40">
      <body>
        <xsl:apply-templates select ="*">
        </xsl:apply-templates>
      </body>
    </html>
  </xsl:template>
  <xsl:template match="b:Citation/b:Source[b:SourceType = 'Book']">
    <html xmlns="http://www.w3.org/TR/REC-html40">
      <body>
        <xsl:text>(</xsl:text>
        <xsl:value-of select="b:Author/b:Author/b:NameList/b:Person/b:Last"/>
        <xsl:text> [</xsl:text>
        <xsl:value-of select="b:Year"/>
        <xsl:text>])</xsl:text>
      </body>
    </html>
  </xsl:template>
  <xsl:template match="text()" />
</xsl:stylesheet>
