﻿Imports <xmlns:ep="urn:ep:dev2007:workshops:linq">
Imports <xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet">

Public Class Form1

    Private Sub btnByElements_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnByElements.Click
        Dim strName As String = "Peter"
        Dim ns As XNamespace = "urn:ep:dev2007:workshops:linq"
        Dim level1 As New XAttribute("level", 1)
        Dim tag1 As New XElement(ns + "tag", "heute")
        Dim thema1 As New XElement(ns + "thema", "XML 1")
        Dim trainer1 As New XElement(ns + "trainer", strName)
        Dim uhrzeit1 As New XElement(ns + "uhrzeit", "11:00")
        Dim workshop1 As New XElement(ns + "workshop", level1, tag1, thema1, trainer1, uhrzeit1)
        Dim level2 As New XAttribute("level", 2)
        Dim tag2 As New XElement(ns + "tag", "heute")
        Dim thema2 As New XElement(ns + "thema", "XML 2")
        Dim trainer2 As New XElement(ns + "trainer", strName)
        Dim uhrzeit2 As New XElement(ns + "uhrzeit", "15:00")
        Dim workshop2 As New XElement(ns + "workshop", level2, tag2, thema2, trainer2, uhrzeit2)
        Dim workshops As New XElement(ns + "workshops", workshop1, workshop2)
        Dim xdoc As New XDocument(workshops)
        xdoc.Save("c:\workshopsLinq.xml")
        Process.Start("iexplore.exe", "c:\workshopsLinq.xml")
    End Sub

    Private Sub btnByHierarchy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnByHierarchy.Click
        Dim strName As String = "Peter"
        Dim ns As XNamespace = "urn:ep:dev2007:workshops:linq"
        Dim xdoc As XDocument = _
            New XDocument( _
                New XElement(ns + "workshops", _
                    New XElement(ns + "workshop", New XAttribute("level", "1"), _
                        New XElement(ns + "tag", "heute"), _
                        New XElement(ns + "thema", "XML 1"), _
                        New XElement(ns + "trainer", strName), _
                        New XElement(ns + "uhrzeit", "11:00")), _
                    New XElement(ns + "workshop", New XAttribute("level", "2"), _
                        New XElement(ns + "tag", "heute"), _
                        New XElement(ns + "thema", "XML 2"), _
                        New XElement(ns + "trainer", strName), _
                        New XElement(ns + "uhrzeit", "15:00"))))
        xdoc.Save("c:\workshopsLinq.xml")
        Process.Start("iexplore.exe", "c:\workshopsLinq.xml")
    End Sub

    Private Sub btnByTags_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnByTags.Click
        Dim xmlDoc As XDocument
        Const strName As String = "Peter"
        xmlDoc = <?xml version="1.0"?>
                 <ep:workshops>
                     <ep:workshop ep:level="1">
                         <ep:tag>heute</ep:tag>
                         <ep:thema>XML 1</ep:thema>
                         <ep:trainer><%= strName %></ep:trainer>
                         <ep:uhrzeit>11:00</ep:uhrzeit>
                     </ep:workshop>
                     <ep:workshop ep:level="2">
                         <ep:tag>heute</ep:tag>
                         <ep:thema>XML 2</ep:thema>
                         <ep:trainer><%= strName %></ep:trainer>
                         <ep:uhrzeit>15:00</ep:uhrzeit>
                     </ep:workshop>
                 </ep:workshops>

        'Dim y(2) As XElement
        'For i As Integer = 0 To 2
        '    y(i) = <b><%= i %></b>
        'Next
        'Dim x As XElement = <a><%= y %></a>
        'MsgBox(x.ToString)

        xmlDoc.Save("c:\workshopsLinq.xml")
        Process.Start("iexplore.exe", "c:\workshopsLinq.xml")
    End Sub

    Private Sub btnSelectLevelOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectLevelOne.Click
        Dim myReader As New Xml.XmlTextReader("c:\workshopsLinq.xml")
        Dim xmlDoc As XDocument = XDocument.Load(myReader)
        Dim levelOne As Object
        levelOne = <ep:workshops>
                       <%= From ws In xmlDoc...<ep:workshop> _
                           Where ws.@ep:level = "1" _
                           Select ws %>
                   </ep:workshops>
        My.Computer.FileSystem.WriteAllText("c:\workshopsLinqLevel1.xml", levelOne.ToString, False)
        Process.Start("iexplore.exe", "c:\workshopsLinqLevel1.xml")
    End Sub

    Private Sub btnTransform_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTransform.Click
        Dim reader As Xml.XmlReader = _
           Xml.XmlReader.Create(New System.IO.StringReader(My.Resources.workshopsWithNamespace.ToString))
        Dim data As XDocument = XDocument.Load(reader)

        Dim workshops As Object = From workshop In data.<ep:workshops>.<ep:workshop> _
                                  Select <ss:Row>
                                             <ss:Cell><ss:Data ss:Type="Number"><%= workshop.@ep:level %></ss:Data></ss:Cell>
                                             <ss:Cell><ss:Data ss:Type="String"><%= workshop.<ep:tag>.Value %></ss:Data></ss:Cell>
                                             <ss:Cell><ss:Data ss:Type="String"><%= workshop.<ep:thema>.Value %></ss:Data></ss:Cell>
                                             <ss:Cell><ss:Data ss:Type="String"><%= workshop.<ep:trainer>.Value %></ss:Data></ss:Cell>
                                             <ss:Cell><ss:Data ss:Type="String"><%= workshop.<ep:uhrzeit>.Value %></ss:Data></ss:Cell>
                                         </ss:Row>
        Dim wb As Object = <?xml version="1.0"?>
                           <?mso-application progid="Excel.Sheet"?>
                           <Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"
                               xmlns:o="urn:schemas-microsoft-com:office:office"
                               xmlns:x="urn:schemas-microsoft-com:office:excel"
                               xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
                               xmlns:html="http://www.w3.org/TR/REC-html40">
                               <!-- <DocumentProperties xmlns="urn:schemas-microsoft-com:office:office">
                                   <Author>Dr. Eckehard Pfeifer</Author>
                                   <LastAuthor>Dr. Eckehard Pfeifer</LastAuthor>
                                   <Created><%= Now %></Created>
                                   <Company>Entwicklung - Beratung - Training</Company>
                                   <Version>12.00</Version>
                               </DocumentProperties>
                               <ExcelWorkbook xmlns="urn:schemas-microsoft-com:office:excel">
                                   <WindowHeight>10170</WindowHeight>
                                   <WindowWidth>21135</WindowWidth>
                                   <WindowTopX>240</WindowTopX>
                                   <WindowTopY>15</WindowTopY>
                                   <ProtectStructure>False</ProtectStructure>
                                   <ProtectWindows>False</ProtectWindows>
                               </ExcelWorkbook>-->
                               <Styles>
                                   <Style ss:ID="Default" ss:Name="Normal">
                                       <Alignment ss:Vertical="Bottom"/>
                                       <Borders/>
                                       <Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#000000"/>
                                       <Interior/>
                                       <NumberFormat/>
                                       <Protection/>
                                   </Style>
                                   <Style ss:ID="myHeading">
                                       <Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#000000"
                                           ss:Bold="1"/>
                                   </Style>
                               </Styles>
                               <Worksheet ss:Name="Unsere Workshops">
                                   <Table ss:ExpandedColumnCount="5" ss:ExpandedRowCount=<%= data.<ep:workshops>.<ep:workshop>.Count + 1 %> ss:DefaultRowHeight="15">
                                       <Row ss:StyleID="myHeading">
                                           <Cell><Data ss:Type="String">Level</Data></Cell>
                                           <Cell><Data ss:Type="String">Tag</Data></Cell>
                                           <Cell><Data ss:Type="String">Thema</Data></Cell>
                                           <Cell><Data ss:Type="String">Trainer</Data></Cell>
                                           <Cell><Data ss:Type="String">Uhrzeit</Data></Cell>
                                       </Row>
                                       <%= workshops %>
                                   </Table>
                                   <!--<WorksheetOptions xmlns="urn:schemas-microsoft-com:office:excel">
                                       <PageSetup>
                                           <Header x:Margin="0.3"/>
                                           <Footer x:Margin="0.3"/>
                                           <PageMargins x:Bottom="0.78740157499999996" x:Left="0.7" x:Right="0.7"
                                               x:Top="0.78740157499999996"/>
                                       </PageSetup>
                                       <Unsynced/>
                                       <Print>
                                           <ValidPrinterInfo/>
                                           <PaperSizeIndex>9</PaperSizeIndex>
                                           <HorizontalResolution>300</HorizontalResolution>
                                           <VerticalResolution>300</VerticalResolution>
                                       </Print>
                                       <Selected/>
                                       <ProtectObjects>False</ProtectObjects>
                                       <ProtectScenarios>False</ProtectScenarios>
                                   </WorksheetOptions>-->
                               </Worksheet>
                           </Workbook>

        wb.Save("C:\data.xml")
        Process.Start("excel.exe", "C:\data.xml")
    End Sub
End Class
