﻿
Public Class Form1
    Dim WithEvents mySettings As Xml.XmlReaderSettings
    Dim blnErrorOccured As Boolean = False

    Private Sub btnCreate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreate.Click
        Const strPre As String = "n"
        Const strUrn As String = "urn:ep:dev2007:workshops:test"

        Dim xmlDoc As New Xml.XmlDocument
        Dim nspmgr As New Xml.XmlNamespaceManager(xmlDoc.NameTable)
        nspmgr.AddNamespace(strPre, strUrn)

        Dim pi As Xml.XmlProcessingInstruction = xmlDoc.CreateProcessingInstruction("xml", "version='1.0' encoding='utf-8'")
        xmlDoc.AppendChild(pi)

        Dim ndRoot As Xml.XmlNode = xmlDoc.CreateNode(Xml.XmlNodeType.Element, strPre, "workshops", strUrn)
        xmlDoc.AppendChild(ndRoot)

        Dim ndWorkshop As Xml.XmlNode = xmlDoc.CreateNode(Xml.XmlNodeType.Element, strPre, "workshop", strUrn)
        Dim attrLevel As Xml.XmlAttribute = xmlDoc.CreateAttribute(strPre, "level", strUrn)
        'Dim attrLevel As Xml.XmlNode = xmlDoc.CreateNode(Xml.XmlNodeType.Attribute, strPre, "level", strUrn)
        attrLevel.Value = "1"
        ndWorkshop.Attributes.Append(attrLevel)

        Dim ndThema As Xml.XmlNode = xmlDoc.CreateNode(Xml.XmlNodeType.Element, strPre, "thema", strUrn)
        ndThema.InnerText = "XML Aufbau"
        ndWorkshop.AppendChild(ndThema)

        Dim ndTrainer As Xml.XmlNode = xmlDoc.CreateNode(Xml.XmlNodeType.Element, strPre, "trainer", strUrn)
        ndTrainer.InnerText = "Peter"
        ndWorkshop.AppendChild(ndTrainer)

        ndRoot.AppendChild(ndWorkshop)
        MsgBox(xmlDoc.OuterXml)

        xmlDoc.Save("c:\workshopsTestCreate.xml")
    End Sub

    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        Const strPre As String = "n"
        Const strUrn As String = "urn:ep:dev2007:workshops:test"
        Dim myXmlTextWriter As New Xml.XmlTextWriter("c:\workshopsTestWrite.xml", System.Text.Encoding.UTF8)

        myXmlTextWriter.WriteStartDocument()
        myXmlTextWriter.WriteStartElement(strPre, "workshops", strUrn)
        myXmlTextWriter.WriteStartElement(strPre, "workshop", strUrn)
        myXmlTextWriter.WriteStartAttribute(strPre, "level", strUrn)
        myXmlTextWriter.WriteString("1")
        myXmlTextWriter.WriteEndAttribute()
        myXmlTextWriter.WriteStartElement(strPre, "thema", strUrn)
        myXmlTextWriter.WriteString("XML Aufbau")
        myXmlTextWriter.WriteEndElement()
        myXmlTextWriter.WriteStartElement(strPre, "trainer", strUrn)
        myXmlTextWriter.WriteString("Peter")
        myXmlTextWriter.WriteEndElement()
        myXmlTextWriter.WriteEndElement()
        myXmlTextWriter.WriteEndDocument()
        myXmlTextWriter.Flush()
        myXmlTextWriter.Close()

        Process.Start("iexplore.exe", "c:\workshopsTestWrite.xml")
    End Sub

    Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
        Dim xmldoc As New Xml.XmlDocument
        xmldoc.Load("c:\workshopsTestCreate.xml")
        MsgBox(xmldoc.OuterXml)
    End Sub

    Private Sub btnRead1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead1.Click
        Dim myXmlTextReader As New Xml.XmlTextReader("c:\workshopsTestWrite.xml")
        Dim xmldoc As New Xml.XmlDocument
        'While Not myXmlTextReader.EOF
        '    Console.WriteLine(myXmlTextReader.Value)
        'myXmlTextReader.Read()
        'End While
        xmldoc.Load(myXmlTextReader)
        MsgBox(xmldoc.OuterXml)
    End Sub

    Private Sub btnRead2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead2.Click
        Dim xmlDoc As New Xml.XmlDocument
        xmlDoc.LoadXml(My.Resources.workshops)
        MsgBox(xmlDoc.OuterXml)
    End Sub

    Private Sub btnInfer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInfer.Click
        Dim inference = New Xml.Schema.XmlSchemaInference()
        Dim schemaSet = New Xml.Schema.XmlSchemaSet()
        schemaSet = inference.InferSchema(New Xml.XmlTextReader(My.Resources.workshops, Xml.XmlNodeType.Document, Nothing))

        Dim i As Integer = 0
        For Each schemafile As Xml.Schema.XmlSchema In schemaSet.Schemas()
            Dim sw As New System.IO.StreamWriter("c:\workshopsTest" & i.ToString & ".xsd")
            Dim writer = Xml.XmlWriter.Create(sw)
            schemafile.Write(writer)
            writer.Close()
            sw.Close()
            i = i + 1
        Next
        Process.Start("iexplore.exe", "c:\workshopsTest0.xsd")
    End Sub

    Private Sub btnValidateWithLocation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnValidateWithLocation.Click
        'Const cstrFileName = "XML\workshops-schemaLocation-gültig.xml"
        Const cstrFileName = "XML\workshops-schemaLocation-ungültig.xml"
        mySettings = New Xml.XmlReaderSettings
        mySettings.ValidationType = Xml.ValidationType.Schema 'das ist XSD
        mySettings.ValidationFlags = mySettings.ValidationFlags Or Xml.Schema.XmlSchemaValidationFlags.ProcessSchemaLocation
        mySettings.ValidationFlags = mySettings.ValidationFlags Or Xml.Schema.XmlSchemaValidationFlags.ReportValidationWarnings

        Dim myReader As Xml.XmlReader = Xml.XmlReader.Create(cstrFileName, mySettings)
        While (myReader.Read())
        End While
        If blnErrorOccured Then
            'do something
            blnErrorOccured = False
        Else
            MsgBox("Alles OK")
        End If
    End Sub

    Private Sub mySettings_ValidationEventHandler1(ByVal sender As Object, ByVal e As System.Xml.Schema.ValidationEventArgs) Handles mySettings.ValidationEventHandler
        blnErrorOccured = True
        MsgBox(e.Message)
    End Sub

    Private Sub btnValidate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnValidate.Click
        'Const cstrFileName = "XML\workshops-schemaLocation-gültig.xml"
        Const cstrFileName = "XML\workshops-schemaLocation-ungültig.xml"
        mySettings = New Xml.XmlReaderSettings
        mySettings.ValidationType = Xml.ValidationType.Schema 'das ist XSD
        mySettings.ValidationFlags = mySettings.ValidationFlags Or Xml.Schema.XmlSchemaValidationFlags.ReportValidationWarnings
        mySettings.Schemas.Add(Nothing, "XML\workshopsTest.xsd")

        Dim myReader As Xml.XmlReader = Xml.XmlReader.Create(cstrFileName, mySettings)
        While (myReader.Read())
        End While
        If blnErrorOccured Then
            'do something
            blnErrorOccured = False
        Else
            MsgBox("Alles OK")
        End If
    End Sub

    Private Sub btnAllSubjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAllSubjects.Click
        Const strUrn As String = "urn:ep:dev2007:workshops:test"
        Dim xmlDoc As New Xml.XmlDocument
        xmlDoc.LoadXml(My.Resources.workshops)
        Dim nspmgr As New Xml.XmlNamespaceManager(xmlDoc.NameTable)
        nspmgr.AddNamespace("n", strUrn)
        Dim ndList As Xml.XmlNodeList = xmlDoc.SelectNodes("n:workshops/n:workshop", nspmgr)
        For Each nd As Xml.XmlNode In ndList
            Dim ndThema As Xml.XmlNode = nd.SelectSingleNode("n:thema", nspmgr)
            Console.WriteLine(ndThema.InnerText)
        Next
    End Sub

    Private Sub btnLevel2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLevel2.Click
        Const strUrn As String = "urn:ep:dev2007:workshops:test"
        Dim xmlDoc As New Xml.XmlDocument
        xmlDoc.LoadXml(My.Resources.workshops)
        Dim nspmgr As New Xml.XmlNamespaceManager(xmlDoc.NameTable)
        nspmgr.AddNamespace("n", strUrn)
        Dim ndList As Xml.XmlNodeList = xmlDoc.SelectNodes("n:workshops/n:workshop[@n:level='2']", nspmgr)
        For Each nd As Xml.XmlNode In ndList
            Dim ndThema As Xml.XmlNode = nd.SelectSingleNode("n:thema", nspmgr)
            Console.WriteLine(ndThema.InnerText)
        Next
    End Sub

    Private Sub btnTransform_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTransform.Click
        Dim xmlDoc As New Xml.XmlDocument
        xmlDoc.Load("XML\workshops.xml")
        Dim xmlTrans As New Xml.Xsl.XslCompiledTransform
        xmlTrans.Load("XML\workshops-level-2.xsl")
        Dim myWriter As Xml.XmlWriter = Xml.XmlWriter.Create("c:\transformedWorkshops.html")
        xmlTrans.Transform(xmlDoc, myWriter)
        myWriter.Close()
        Process.Start("iexplore.exe", "c:\transformedWorkshops.html")
    End Sub
End Class
