Imports packaging = System.IO.Packaging

Public Class wdSample

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateDoc.Click
        CreateWordDoc("c:\myDoc.docx.zip", txtBody.Text)
    End Sub

    Private Sub CreateWordDoc(ByVal fileFullPath As String, ByVal input As String)
        Dim cstrNameSpaceW As String = "http://schemas.openxmlformats.org/wordprocessingml/2006/main"
        Dim cstrNameSpaceRel As String = "http://schemas.openxmlformats.org/officeDocument/2006/relationships/officeDocument"
        Dim cstrContentType As String = "application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml"

        'Dokument-Inhalt
        Dim xmlDoc As Xml.XmlDocument = New Xml.XmlDocument()
        Dim wordDocument As Xml.XmlElement = xmlDoc.CreateElement("w:wordDocument", cstrNameSpaceW)
        xmlDoc.AppendChild(wordDocument)

        Dim body As Xml.XmlNode = xmlDoc.CreateElement("w:body", cstrNameSpaceW)

        ' zerlegen des Inputs
        Dim bodyText() As String = input.Split(vbLf)

        ' und Erzeugen von Paragraphen
        For line As Integer = 0 To bodyText.Length - 1
            Dim paragraph As Xml.XmlNode = xmlDoc.CreateElement("w:p", cstrNameSpaceW)
            Dim run As Xml.XmlElement = xmlDoc.CreateElement("w:r", cstrNameSpaceW)
            Dim text As Xml.XmlNode = xmlDoc.CreateElement("w:t", cstrNameSpaceW)

            text.InnerText = bodyText(line)
            run.AppendChild(text)
            paragraph.AppendChild(run)
            body.AppendChild(paragraph)
        Next

        wordDocument.AppendChild(body)

        'Paket erstellen
        Dim paket As packaging.Package = _
            packaging.Package.Open(fileFullPath, System.IO.FileMode.Create, System.IO.FileAccess.ReadWrite)

        'Haupt-Part erstellen
        Dim uri As Uri = New Uri("/document.xml", UriKind.Relative)
        Dim part As packaging.PackagePart = paket.CreatePart(uri, cstrContentType)
        Dim partWriter As System.IO.StreamWriter = _
            New System.IO.StreamWriter(part.GetStream(System.IO.FileMode.Create, System.IO.FileAccess.Write))

        xmlDoc.Save(partWriter)
        partWriter.Close()

        '.rels-Datei erstellen
        Dim relationShip As packaging.PackageRelationship = paket.CreateRelationship(uri, packaging.TargetMode.Internal, cstrNameSpaceRel, "rId1")

        'und Schluss
        paket.Close()
        Process.Start("Winword.exe", fileFullPath)
    End Sub

    'nur zum Vorgehen bei Files
    Sub Demo()
        Dim datei As System.IO.FileStream = _
                System.IO.File.Open("c:\aha.txt", System.IO.FileMode.Create, System.IO.FileAccess.ReadWrite)
        datei.Close()
    End Sub
End Class

