Imports packaging = System.IO.Packaging

Public Class xlSample

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateEmptyBook.Click
        CreateExcelDoc("c:\myWorkbook.xlsx")
    End Sub

    Private Sub CreateExcelDoc(ByVal fileFullPath As String)
        Dim namespaceXl As String = "http://schemas.openxmlformats.org/spreadsheetml/2006/main"
        Dim namespaceRel As String = "http://schemas.openxmlformats.org/officeDocument/2006/relationships"
        Dim namespaceRelWb As String = "http://schemas.openxmlformats.org/officeDocument/2006/relationships/officeDocument"
        Dim namespaceRelWs As String = "http://schemas.openxmlformats.org/officeDocument/2006/relationships/worksheet"
        Dim contentTypeWb As String = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml"
        Dim contentTypeSh As String = "application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml"

        'folgende Ids werden beim Speichern durch Excel durch andere ersetzt
        Dim relationBookInArchiv As String = "rId1"
        Dim relationSheetToBookID1 As String = "rId2"
        Dim relationSheetToBookID2 As String = "rId3"

        'Paket erstellen
        Dim paket As packaging.Package = _
            packaging.Package.Open(fileFullPath, IO.FileMode.Create, IO.FileAccess.ReadWrite)

        'die workbook.xml-Datei
        Dim xmlBook As XmlDocument = New XmlDocument()
        Dim xmlWb As XmlElement = xmlBook.CreateElement("workbook", namespaceXl)
        Dim xmlShs As XmlElement = xmlBook.CreateElement("sheets", namespaceXl)
        Dim xmlSh As XmlElement = xmlBook.CreateElement("sheet", namespaceXl)
        xmlSh.Attributes.Append(xmlBook.CreateAttribute("name"))
        xmlSh.Attributes("name").Value = "Zahl und Formel"
        xmlSh.Attributes.Append(xmlBook.CreateAttribute("sheetId"))
        xmlSh.Attributes("sheetId").Value = "1"
        xmlSh.Attributes.Append(xmlBook.CreateAttribute("r:id", namespaceRel))
        xmlSh.Attributes("id", namespaceRel).Value = relationSheetToBookID1
        xmlShs.AppendChild(xmlSh)

        xmlSh = xmlBook.CreateElement("sheet", namespaceXl)
        xmlSh.Attributes.Append(xmlBook.CreateAttribute("name"))
        xmlSh.Attributes("name").Value = "Texte"
        xmlSh.Attributes.Append(xmlBook.CreateAttribute("sheetId"))
        xmlSh.Attributes("sheetId").Value = "2"
        xmlSh.Attributes.Append(xmlBook.CreateAttribute("r:id", namespaceRel))
        xmlSh.Attributes("id", namespaceRel).Value = relationSheetToBookID2
        xmlShs.AppendChild(xmlSh)

        xmlWb.AppendChild(xmlShs)
        xmlBook.AppendChild(xmlWb)

        'workbook-part erzeugen
        Dim uri As Uri = New Uri("/xl/workbook.xml", UriKind.RelativeOrAbsolute)
        Dim partBook As packaging.PackagePart = paket.CreatePart(uri, contentTypeWb)
        Dim partWriter As IO.StreamWriter = _
            New IO.StreamWriter(partBook.GetStream(IO.FileMode.Create, IO.FileAccess.Write))
        xmlBook.Save(partWriter)
        partWriter.Close()

        '.rels-Datei
        Dim relationShip As packaging.PackageRelationship = _
            paket.CreateRelationship(uri, packaging.TargetMode.Internal, namespaceRelWb, relationBookInArchiv)

        'sheet1.xml-Dokument
        Dim xmlSheet As XmlDocument = New XmlDocument()
        Dim xlSh As XmlElement = xmlSheet.CreateElement("worksheet", namespaceXl)
        Dim xlData As XmlElement = xmlSheet.CreateElement("sheetData", namespaceXl)
        Dim xlRow As XmlElement = xmlSheet.CreateElement("row", namespaceXl)
        Dim xlNumericCell As XmlElement = xmlSheet.CreateElement("c", namespaceXl)
        Dim xlCellValue As XmlElement = xmlSheet.CreateElement("v", namespaceXl)
        xlCellValue.InnerText = "123"
        xlNumericCell.AppendChild(xlCellValue)
        xlRow.AppendChild(xlNumericCell)
        Dim xlFormulaCell As XmlElement = xmlSheet.CreateElement("c", namespaceXl)
        Dim xlFormula As XmlElement = xmlSheet.CreateElement("f", namespaceXl)
        xlFormula.InnerText = "A1*3"
        xlFormulaCell.AppendChild(xlFormula)
        xlRow.AppendChild(xlFormulaCell)
        xlData.AppendChild(xlRow)
        xlSh.AppendChild(xlData)
        xmlSheet.AppendChild(xlSh)

        'sheet1-part einbinden
        uri = New Uri("/xl/worksheets/sheet1.xml", UriKind.Relative)
        Dim partSheet As packaging.PackagePart = paket.CreatePart(uri, contentTypeSh)
        partWriter = New IO.StreamWriter(partSheet.GetStream(IO.FileMode.Create, IO.FileAccess.Write))
        xmlSheet.Save(partWriter)
        partWriter.Close()

        'hier mit Linq ein sheet2 erzeugen
        Dim ns As XNamespace = namespaceXl '"http://schemas.openxmlformats.org/spreadsheetml/2006/7/main"

        Dim xdocWS As XDocument
        xdocWS = _
            New XDocument( _
                New XElement(ns + "worksheet", _
                    New XElement(ns + "sheetData", _
                        New XElement(ns + "row", New XAttribute("r", "2"), _
                            New XElement(ns + "c", New XAttribute("r", "B2"), New XAttribute("t", "inlineStr"), _
                                New XElement(ns + "is", _
                                    New XElement(ns + "t", "Ein Text") _
                                ) _
                            ) _
                        ), _
                        New XElement(ns + "row", New XAttribute("r", "3"), _
                            New XElement(ns + "c", New XAttribute("r", "B3"), New XAttribute("t", "inlineStr"), _
                                New XElement(ns + "is", _
                                    New XElement(ns + "t", "und noch ein Text") _
                                ) _
                            ) _
                        ) _
                    ) _
                ) _
            )

        'sheet2-part einbinden
        uri = New Uri("/xl/worksheets/sheet2.xml", UriKind.Relative)
        partSheet = paket.CreatePart(uri, contentTypeSh)
        partWriter = New IO.StreamWriter(partSheet.GetStream(IO.FileMode.Create, IO.FileAccess.Write))
        xdocWS.Save(partWriter)
        partWriter.Close()

        'workbook.xml.rels-Datei
        uri = New Uri("worksheets/sheet1.xml", UriKind.RelativeOrAbsolute)
        relationShip = partBook.CreateRelationship(uri, packaging.TargetMode.Internal, namespaceRelWs, relationSheetToBookID1)
        uri = New Uri("worksheets/sheet2.xml", UriKind.RelativeOrAbsolute)
        relationShip = partBook.CreateRelationship(uri, packaging.TargetMode.Internal, namespaceRelWs, relationSheetToBookID2)

        'und Schluss
        paket.Close()
        Process.Start("excel.exe", fileFullPath)
    End Sub
End Class
