﻿Imports Packaging = Microsoft.Office.DocumentFormat.OpenXml.Packaging
Imports OpenXml = Microsoft.Office.DocumentFormat.OpenXml

Public Class presentationDocuments

    Private Sub btnSimplest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSimplest.Click
        Dim presDoc As Packaging.PresentationDocument = _
            Packaging.PresentationDocument.Create("c:\pres.pptx", OpenXml.PresentationDocumentType.Presentation)
        Dim pres As Packaging.PresentationPart = presDoc.AddPresentationPart
        Dim sld As Packaging.SlidePart = pres.AddNewPart(Of Packaging.SlidePart)("rId1")
        Dim sldMaster As Packaging.SlideMasterPart = pres.AddNewPart(Of Packaging.SlideMasterPart)("rId2")
        Dim theme As Packaging.ThemePart = pres.AddNewPart(Of Packaging.ThemePart)("rId3")

        Dim sldLayout As Packaging.SlideLayoutPart = sld.AddNewPart(Of Packaging.SlideLayoutPart)("rId4")
        sldLayout.AddPart(Of Packaging.SlideMasterPart)(sldMaster)

        Dim part As Packaging.SlideLayoutPart = sldMaster.AddPart(Of Packaging.SlideLayoutPart)(sldLayout)
        Dim id As String = sldMaster.GetIdOfPart(part)
        sldMaster.AddPart(Of Packaging.ThemePart)(theme)

        Dim xmlEmptyShapeTree As XElement = _
            <p:spTree xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
                xmlns:p="http://schemas.openxmlformats.org/presentationml/2006/main">
                <p:nvGrpSpPr>
                    <p:cNvPr id="1" name=""/>
                    <p:cNvGrpSpPr/>
                    <p:nvPr/>
                </p:nvGrpSpPr>
                <p:grpSpPr>
                    <a:xfrm>
                        <a:off x="0" y="0"/>
                        <a:ext cx="0" cy="0"/>
                        <a:chOff x="0" y="0"/>
                        <a:chExt cx="0" cy="0"/>
                    </a:xfrm>
                </p:grpSpPr>
            </p:spTree>

        Dim aShape As XElement = _
            <p:sp xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
                xmlns:p="http://schemas.openxmlformats.org/presentationml/2006/main">
                <p:nvSpPr>
                    <p:cNvPr id="2" name="myRectangle"/>
                    <p:cNvSpPr/>
                    <p:nvPr/>
                </p:nvSpPr>
                <p:spPr>
                    <a:xfrm>
                        <a:off x="1000100" y="714356"/>
                        <a:ext cx="1643074" cy="785818"/>
                    </a:xfrm>
                    <a:prstGeom prst="rect">
                        <a:avLst/>
                    </a:prstGeom>
                </p:spPr>
                <p:style>
                    <a:lnRef idx="2">
                        <a:schemeClr val="accent1">
                            <a:shade val="50000"/>
                        </a:schemeClr>
                    </a:lnRef>
                    <a:fillRef idx="1">
                        <a:schemeClr val="dk2"/>
                    </a:fillRef>
                    <a:effectRef idx="0">
                        <a:schemeClr val="accent1"/>
                    </a:effectRef>
                    <a:fontRef idx="minor">
                        <a:schemeClr val="lt1"/>
                    </a:fontRef>
                </p:style>
                <p:txBody>
                    <a:bodyPr/>
                    <a:p>
                        <a:pPr algn="ctr"/>
                        <a:r>
                            <a:t>Etwas Text</a:t>
                        </a:r>
                    </a:p>
                </p:txBody>
            </p:sp>

        Dim xmlShapeTreeAndShape As XElement = _
            <p:spTree xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
                xmlns:p="http://schemas.openxmlformats.org/presentationml/2006/main">
                <p:nvGrpSpPr>
                    <p:cNvPr id="1" name=""/>
                    <p:cNvGrpSpPr/>
                    <p:nvPr/>
                </p:nvGrpSpPr>
                <p:grpSpPr>
                    <a:xfrm>
                        <a:off x="0" y="0"/>
                        <a:ext cx="0" cy="0"/>
                        <a:chOff x="0" y="0"/>
                        <a:chExt cx="0" cy="0"/>
                    </a:xfrm>
                </p:grpSpPr>
                <%= aShape %>
            </p:spTree>

        Dim xmlSld As XElement = _
        <p:sld xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
            xmlns:p="http://schemas.openxmlformats.org/presentationml/2006/main">
            <p:cSld>
                <%= xmlShapeTreeAndShape %>
            </p:cSld>
        </p:sld>

        Dim xmlSldMaster As XElement = _
        <p:sldMaster xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
            xmlns:p="http://schemas.openxmlformats.org/presentationml/2006/main"
            xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships">
            <p:cSld name="myMaster">
                <%= xmlShapeTreeAndShape %>
            </p:cSld>
            <p:clrMap bg1="lt1" tx1="dk1" bg2="lt2" tx2="dk2"
                accent1="accent1" accent2="accent2" accent3="accent3"
                accent4="accent4" accent5="accent5" accent6="accent6"
                hlink="hlink" folHlink="folHlink"/>
            <p:sldLayoutIdLst>
                <p:sldLayoutId id="2147483649" r:id=<%= id %>/>
            </p:sldLayoutIdLst>
        </p:sldMaster>

        Dim xmlSldLayout As XElement = _
         <p:sldLayout xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
             xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
             xmlns:p="http://schemas.openxmlformats.org/presentationml/2006/main" preserve="1">
             <p:cSld name="Empty Slide">
                 <%= xmlShapeTreeAndShape %>
             </p:cSld>
         </p:sldLayout>

        Dim xmlThema As XDocument = XDocument.Load("docs\myTheme.xml")

        Dim xmlPres As XElement = _
            <p:presentation xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
                xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
                xmlns:p="http://schemas.openxmlformats.org/presentationml/2006/main" saveSubsetFonts="1">
                <p:sldMasterIdLst>
                    <p:sldMasterId id="2147483648" r:id="rId2"/>
                </p:sldMasterIdLst>
                <p:sldIdLst>
                    <p:sldId id="256" r:id="rId1"/>
                </p:sldIdLst>
                <p:sldSz cx="9144000" cy="6858000"/>
                <p:notesSz cx="6858000" cy="9144000"/>
            </p:presentation>

        Dim encoder As System.Text.UTF8Encoding = New System.Text.UTF8Encoding
        Dim stream As IO.Stream
        stream = pres.GetStream
        Dim buffer() As Byte = encoder.GetBytes(xmlPres.ToString)
        stream.Write(buffer, 0, buffer.Length)

        stream = sld.GetStream
        buffer = encoder.GetBytes(xmlSld.ToString)
        stream.Write(buffer, 0, buffer.Length)

        stream = sldLayout.GetStream
        buffer = encoder.GetBytes(xmlSldLayout.ToString)
        stream.Write(buffer, 0, buffer.Length)

        stream = sldMaster.GetStream
        buffer = encoder.GetBytes(xmlSldMaster.ToString)
        stream.Write(buffer, 0, buffer.Length)

        stream = theme.GetStream
        buffer = encoder.GetBytes(xmlThema.ToString)
        stream.Write(buffer, 0, buffer.Length)

        presDoc.Close()
        Process.Start("powerpnt.exe", "c:\pres.pptx")
    End Sub
End Class

