﻿Imports Packaging = Microsoft.Office.DocumentFormat.OpenXml.Packaging
Imports OpenXml = Microsoft.Office.DocumentFormat.OpenXml

Public Class spreadsheetDocuments

    Private Sub btnCreateSimpleWb_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateSimpleWb.Click
        Dim wbDoc As Packaging.SpreadsheetDocument = _
            Packaging.SpreadsheetDocument.Create("c:\wb.xlsx", OpenXml.SpreadsheetDocumentType.Workbook)
        Dim wb As Packaging.WorkbookPart = wbDoc.AddWorkbookPart
        Dim ws As Packaging.WorksheetPart = wb.AddNewPart(Of Packaging.WorksheetPart)("rId1")

        Dim xmlWs As XElement = _
            <worksheet xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main">
                <sheetData>
                    <row>
                        <c>
                            <v>2</v>
                        </c>
                        <c>
                            <f>A1*3</f>
                        </c>
                    </row>
                </sheetData>
            </worksheet>

        Dim utf8encoder As System.Text.UTF8Encoding = New System.Text.UTF8Encoding()
        Dim stream As System.IO.Stream = ws.GetStream()
        Dim buffer() As Byte = utf8encoder.GetBytes(xmlWs.ToString)
        stream.Write(buffer, 0, buffer.Length)

        Dim xmlWb As XElement = _
        <workbook xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main"
            xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships">
            <sheets>
                <sheet name="Testblatt" sheetId="1" r:id="rId1"/>
            </sheets>
        </workbook>
        stream = wb.GetStream
        buffer = utf8encoder.GetBytes(xmlWb.ToString)
        stream.Write(buffer, 0, buffer.Length)

        wbDoc.Close()
        Process.Start("excel.exe", "c:\wb.xlsx")
    End Sub

    Private Sub btnSharedStrings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSharedStrings.Click
        Dim wbDoc As Packaging.SpreadsheetDocument = Packaging.SpreadsheetDocument.Open("docs\sharedStrings.xlsx", True)
        Dim sh As Packaging.SharedStringTablePart
        Dim xDoc As XDocument
        For Each sh In wbDoc.WorkbookPart.GetPartsOfType(Of Packaging.SharedStringTablePart)()
            xDoc = XDocument.Load(New Xml.XmlTextReader(sh.GetStream))
            MsgBox(xDoc.ToString)
        Next
        wbDoc.Close()
    End Sub

    Private Sub btnWithTable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWithTable.Click
        Dim wbDoc As Packaging.SpreadsheetDocument = Packaging.SpreadsheetDocument.Create("c:\wb.xlsx", OpenXml.SpreadsheetDocumentType.Workbook)
        Dim wb As Packaging.WorkbookPart = wbDoc.AddWorkbookPart
        Dim ws As Packaging.WorksheetPart = wb.AddNewPart(Of Packaging.WorksheetPart)("rId1")
        Dim tb As Packaging.TableDefinitionPart = ws.AddNewPart(Of Packaging.TableDefinitionPart)("rId2")

        Dim xmlTb As XElement = _
        <table xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main"
            id="1" name="myList" displayName="meineListe" ref="B2:C4">
            <tableColumns count="2">
                <tableColumn id="1" name="Thema"></tableColumn>
                <tableColumn id="2" name="Trainer"></tableColumn>
            </tableColumns>
            <tableStyleInfo name="TableStyleLight8" showFirstColumn="0" showLastColumn="0"
                showRowStripes="1" showColumnStripes="0"/>
        </table>

        Dim utf8encoder As System.Text.UTF8Encoding = New System.Text.UTF8Encoding()
        Dim stream As System.IO.Stream = tb.GetStream()
        Dim buffer() As Byte = utf8encoder.GetBytes(xmlTb.ToString)
        stream.Write(buffer, 0, buffer.Length)

        Dim xmlWs As XElement = _
            <worksheet xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main"
                xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships">
                <sheetData>
                    <row r="2" spans="2:3">
                        <c r="B2" t="inlineStr">
                            <is>
                                <t>Thema</t>
                            </is>
                        </c>
                        <c r="C2" t="inlineStr">
                            <is>
                                <t>Trainer</t>
                            </is>
                        </c>
                    </row>
                </sheetData>
                <tableParts count="1">
                    <tablePart r:id="rId2"></tablePart>
                </tableParts>
            </worksheet>
        stream = ws.GetStream()
        buffer = utf8encoder.GetBytes(xmlWs.ToString)
        stream.Write(buffer, 0, buffer.Length)

        Dim xmlWb As XElement = _
        <workbook xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main"
            xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships">
            <sheets>
                <sheet name="Test" sheetId="1" r:id="rId1"/>
            </sheets>
        </workbook>
        stream = wb.GetStream
        buffer = utf8encoder.GetBytes(xmlWb.ToString)
        stream.Write(buffer, 0, buffer.Length)

        wbDoc.Close()
        Process.Start("excel.exe", "c:\wb.xlsx")
    End Sub


End Class