﻿
Imports Packaging = Microsoft.Office.DocumentFormat.OpenXml.Packaging
Imports OpenXml = Microsoft.Office.DocumentFormat.OpenXml
Imports <xmlns:cp="http://schemas.openxmlformats.org/package/2006/metadata/core-properties">
Imports <xmlns:ep="urn:ep:dev2007:workshops:openXml">

Public Class wordprocessingDocuments

    Private Sub btnCreateWordDoc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateSimpleWordDoc.Click
        Dim wordDoc As Packaging.WordprocessingDocument = _
            Packaging.WordprocessingDocument.Create("c:\test.docx", OpenXml.WordprocessingDocumentType.Document)
        Using (wordDoc)
            Dim mainPart As Packaging.MainDocumentPart = wordDoc.AddMainDocumentPart

            Dim xmlContent As XDocument = _
                <?xml version="1.0" encoding="UTF-8" standalone="yes"?>
                <w:document xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main">
                    <w:body>
                        <w:p>
                            <w:r>
                                <w:t>Hallo, Welt!</w:t>
                            </w:r>
                        </w:p>
                    </w:body>
                </w:document>

            Dim myStream As System.IO.Stream = mainPart.GetStream
            Dim utf8encoder As New System.Text.UTF8Encoding
            Dim buffer() As Byte = utf8encoder.GetBytes(xmlContent.ToString)
            myStream.Write(buffer, 0, buffer.Length)

            'wordDoc.Close()
        End Using
        Process.Start("winword.exe", "c:\test.docx")
    End Sub

    Private Sub btnGetProps_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetProps.Click
        Dim testDoc As Packaging.WordprocessingDocument = _
            Packaging.WordprocessingDocument.Open("docs\testDokument.docx", True)
        Dim propPart As Packaging.CoreFilePropertiesPart = testDoc.CoreFilePropertiesPart
        Dim xmldocProps As New Xml.XmlDocument
        xmldocProps.Load(propPart.GetStream)
        Dim nspmgr As New Xml.XmlNamespaceManager(xmldocProps.NameTable)
        nspmgr.AddNamespace("cp", "http://schemas.openxmlformats.org/package/2006/metadata/core-properties")

        Dim ndsProps As Xml.XmlNodeList = xmldocProps.SelectNodes("cp:coreProperties/*", nspmgr)
        For Each nd As Xml.XmlNode In ndsProps
            Console.WriteLine(nd.Name & " " & nd.InnerText)
        Next

        'dasselbe mit LINQ
        Dim myReader As Xml.XmlReader = Xml.XmlReader.Create(propPart.GetStream)
        Dim xd As XDocument = XDocument.Load(myReader)
        Dim x As System.Collections.IEnumerable 'As Object reicht hier nicht
        x = From prop In xd.<cp:coreProperties>.Descendants _
            Select prop
        Dim y As Xml.Linq.XElement
        For Each y In x
            Console.WriteLine(y.Name.LocalName & " " & y.Value)
        Next
        testDoc.Close()

    End Sub

    Private Sub btnHeader_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHeader.Click
        Dim wordDoc As Packaging.WordprocessingDocument = _
            Packaging.WordprocessingDocument.Create("c:\test.docx", OpenXml.WordprocessingDocumentType.Document)
        'Using (wordDoc)
        Dim mainPart As Packaging.MainDocumentPart = wordDoc.AddMainDocumentPart
        Dim headerPart As Packaging.HeaderPart = mainPart.AddNewPart(Of Packaging.HeaderPart)("myId")

        Dim header As XElement = _
         <w:hdr xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main">
             <w:p>
                 <w:pPr>
                     <w:pStyle w:val="Kopfzeile"/>
                 </w:pPr>
                 <w:r>
                     <w:t>Meine Kopfzeile</w:t>
                 </w:r>
             </w:p>
         </w:hdr>
        Dim myStream As System.IO.Stream = headerPart.GetStream
        Dim utf8encoder As New System.Text.UTF8Encoding
        Dim buffer() As Byte = utf8encoder.GetBytes(header.ToString)
        myStream.Write(buffer, 0, buffer.Length)

        Dim id As String = mainPart.GetIdOfPart(headerPart)

        Dim body As XElement = _
         <w:document xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main">
             <w:body>
                 <w:p>
                     <w:r>
                         <w:t>Hallo, Welt!</w:t>
                     </w:r>
                 </w:p>
                 <w:sectPr>
                     <w:headerReference w:type="default" r:id=<%= id %>
                         xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"/>
                 </w:sectPr>
             </w:body>
         </w:document>
        myStream = mainPart.GetStream
        buffer = utf8encoder.GetBytes(body.ToString)
        myStream.Write(buffer, 0, buffer.Length)
        wordDoc.Close()
        'End Using
        Process.Start("winword.exe", "c:\test.docx")

    End Sub

#Region "doc with pic"

    Private Sub btnCreateWordDocWithPic_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateWordDocWithPic.Click
        Dim wordDoc As Packaging.WordprocessingDocument = _
     Packaging.WordprocessingDocument.Create("c:\test.docx.zip", OpenXml.WordprocessingDocumentType.Document)
        'Using (wordDoc)
        Dim mainPart As Packaging.MainDocumentPart = wordDoc.AddMainDocumentPart
        createComplexMainPartContent(mainPart, "pictures\winter.jpg")
        wordDoc.Close()
        'End Using
        Process.Start("winword.exe", "c:\test.docx.zip")
    End Sub

    Private Sub createComplexMainPartContent(ByVal myPart As Packaging.MainDocumentPart, ByVal imageFileName As String)
        Dim imagePart As Packaging.ImagePart = myPart.AddImagePart(Packaging.ImagePartType.Jpeg)
        Dim stream As System.IO.FileStream = New System.IO.FileStream(imageFileName, System.IO.FileMode.Open)
        imagePart.FeedData(stream)
        Dim id As String
        id = myPart.GetIdOfPart(imagePart)
        Dim xmlContent As String = createImageParagraph(id)
        Dim myStream As System.IO.Stream = myPart.GetStream
        Dim utf8encoder As New System.Text.UTF8Encoding
        Dim buffer() As Byte = utf8encoder.GetBytes(xmlContent)
        myStream.Write(buffer, 0, buffer.Length)
    End Sub

    Function createImageParagraph(ByVal id As String) As String
        Dim par As XElement = _
        <w:document xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
            xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing">
            <w:body>
                <w:p>
                    <w:r>
                        <w:t>Hallo, Welt!</w:t>
                    </w:r>
                </w:p>
                <w:p>
                    <w:r>
                        <w:rPr>
                            <w:noProof/>
                        </w:rPr>
                        <w:drawing>
                            <wp:inline distT="0" distB="0" distL="0" distR="0">
                                <wp:extent cx="5760720" cy="4320540"/>
                                <wp:effectExtent l="19050" t="0" r="0" b="0"/>
                                <wp:docPr id="1" name="Grafik 0" descr="Winter.jpg"/>
                                <wp:cNvGraphicFramePr>
                                    <a:graphicFrameLocks xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main" noChangeAspect="1"/>
                                </wp:cNvGraphicFramePr>
                                <a:graphic xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main">
                                    <a:graphicData uri="http://schemas.openxmlformats.org/drawingml/2006/picture">
                                        <pic:pic xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture">
                                            <pic:nvPicPr>
                                                <pic:cNvPr id="0" name="Winter.jpg"/>
                                                <pic:cNvPicPr/>
                                            </pic:nvPicPr>
                                            <pic:blipFill>
                                                <a:blip r:embed=<%= id %>
                                                    xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"/>
                                                <a:stretch>
                                                    <a:fillRect/>
                                                </a:stretch>
                                            </pic:blipFill>
                                            <pic:spPr>
                                                <a:xfrm>
                                                    <a:off x="0" y="0"/>
                                                    <a:ext cx="5760720" cy="4320540"/>
                                                </a:xfrm>
                                                <a:prstGeom prst="rect">
                                                    <a:avLst/>
                                                </a:prstGeom>
                                            </pic:spPr>
                                        </pic:pic>
                                    </a:graphicData>
                                </a:graphic>
                            </wp:inline>
                        </w:drawing>
                    </w:r>
                </w:p>
            </w:body>
        </w:document>
        Return par.ToString
    End Function

#End Region

    Private Sub btnChangePicture_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChangePicture.Click
        Dim doc As Packaging.WordprocessingDocument = Packaging.WordprocessingDocument.Open("docs\mitBild.docx", True)
        Dim mainPart As Packaging.MainDocumentPart = doc.MainDocumentPart
        'Id="rId4"  ist wichtig, nicht der Pfad!!!
        Dim imagePart As Packaging.ImagePart
        For Each imagePart In mainPart.ImageParts
            Dim id As String = mainPart.GetIdOfPart(imagePart)
            If id = "rId4" Then
                Dim stream As System.IO.FileStream = New System.IO.FileStream("pictures/Sonnenuntergang.jpg", System.IO.FileMode.Open)
                imagePart.FeedData(stream)
                Exit For
            End If
        Next
        doc.Close()
        Process.Start("winword.exe", "docs\mitBild.docx")
    End Sub

    Private Sub btnCustomXml_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCustomXml.Click
        Dim doc As Packaging.WordprocessingDocument = _
            Packaging.WordprocessingDocument.Create("c:\customXml.docx", OpenXml.WordprocessingDocumentType.Document)
        Dim mainPart As Packaging.MainDocumentPart = doc.AddMainDocumentPart

        Dim data As XDocument = XDocument.Load("docs\aWorkshop.xml")
        Dim customXmlPart As Packaging.CustomXmlPart = mainPart.AddNewPart(Of Packaging.CustomXmlPart)()
        Dim xmlDataFileStream As New System.IO.FileStream("docs\aWorkshop.xml", IO.FileMode.Open)
        customXmlPart.FeedData(xmlDataFileStream)

        Dim body As XElement = _
        <w:document xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main">
            <w:body>
                <w:p>
                    <w:r>
                        <w:t xml:space="preserve">Sehr geehrte Damen und Herren, zum Workshop am </w:t>
                    </w:r>
                    <w:sdt>
                        <w:sdtPr>
                            <w:dataBinding w:xpath="/ep:workshops/ep:workshop/ep:tag"
                                w:prefixMapping="xmlns:ep='urn:ep:dev2007:workshops:openXml'"/>
                            <w:text/>
                        </w:sdtPr>
                        <w:sdtContent>
                            <w:r>
                                <w:t><%= From workshop In data...<ep:workshop> _
                                         Select workshop.<ep:tag>.Value %>
                                </w:t>
                            </w:r>
                        </w:sdtContent>
                    </w:sdt>
                    <w:r>
                        <w:t xml:space="preserve"> um </w:t>
                    </w:r><w:sdt>
                        <w:sdtPr>
                            <w:dataBinding w:xpath="/ep:workshops/ep:workshop/ep:uhrzeit"
                                w:prefixMapping="xmlns:ep='urn:ep:dev2007:workshops:openXml'"/>
                            <w:text/>
                        </w:sdtPr>
                        <w:sdtContent>
                            <w:r>
                                <w:t><%= From workshop In data...<ep:workshop> _
                                         Select workshop.<ep:uhrzeit>.Value %>
                                </w:t>
                            </w:r>
                        </w:sdtContent>
                    </w:sdt>
                    <w:r>
                        <w:t xml:space="preserve"> zum Thema</w:t>
                    </w:r>
                </w:p>
                <w:p>
                    <w:pPr>
                        <w:ind w:firstLine="708"/>
                        <w:outlineLvl w:val="0"/>
                    </w:pPr>
                    <w:sdt>
                        <w:sdtPr>
                            <w:dataBinding w:xpath="/ep:workshops/ep:workshop/ep:thema"
                                w:prefixMapping="xmlns:ep='urn:ep:dev2007:workshops:openXml'"/>
                            <w:text/>
                        </w:sdtPr>
                        <w:sdtContent>
                            <w:r>
                                <w:rPr>
                                    <w:b/>
                                </w:rPr>
                                <w:t><%= From workshop In data...<ep:workshop> _
                                         Select workshop.<ep:thema>.Value %>
                                </w:t>
                            </w:r>
                        </w:sdtContent>
                    </w:sdt>
                </w:p>
                <w:p><w:r>
                    <w:t xml:space="preserve">mit </w:t>
                    </w:r>
                    <w:sdt>
                        <w:sdtPr>
                            <w:dataBinding w:xpath="/ep:workshops/ep:workshop/ep:trainer"
                                w:prefixMapping="xmlns:ep='urn:ep:dev2007:workshops:openXml'"/>
                            <w:text/>
                        </w:sdtPr>
                        <w:sdtContent>
                            <w:r>
                                <w:t><%= From workshop In data...<ep:workshop> _
                                         Select workshop.<ep:trainer>.Value %>
                                </w:t>
                            </w:r>
                        </w:sdtContent>
                    </w:sdt>
                    <w:r>
                        <w:t xml:space="preserve"> laden wir herzlich ein.</w:t>
                    </w:r>
                </w:p>
            </w:body>
        </w:document>
        Dim myStream As System.IO.Stream = mainPart.GetStream
        Dim utf8encoder As New System.Text.UTF8Encoding
        Dim buffer() As Byte = utf8encoder.GetBytes(body.ToString)
        myStream.Write(buffer, 0, buffer.Length)
        doc.Close()
        Process.Start("winword.exe", "c:\customXml.docx")
    End Sub

End Class
