﻿Imports System.Runtime.InteropServices

'wichtig: Register for COM Interop

<GuidAttribute("CDC27DF3-504F-4d72-98DE-3B6EB8E79E00"), ProgIdAttribute("pptDocInspector.myInspector")> _
Public Class myInspector
    Implements Microsoft.Office.Core.IDocumentInspector

    Public Sub GetInfo(ByRef Name As String, ByRef Desc As String) Implements Microsoft.Office.Core.IDocumentInspector.GetInfo
        Name = "Layout-Inspector"
        Desc = "Testet auf Einhaltung eines bestimmten Layouts"
    End Sub

    Public Sub Fix(ByVal Doc As Object, ByVal Hwnd As Integer, ByRef Status As Microsoft.Office.Core.MsoDocInspectorStatus, ByRef Result As String) Implements Microsoft.Office.Core.IDocumentInspector.Fix
        Dim pres As Microsoft.Office.Interop.PowerPoint.Presentation = CType(Doc, Microsoft.Office.Interop.PowerPoint.Presentation)
        Dim rib As Ribbon1 = Nothing
        Dim it As New Microsoft.Office.Tools.Ribbon.RibbonDropDownItem
        If pptDocInspector.Globals.Ribbons.Count > 0 Then
            rib = CType(pptDocInspector.Globals.Ribbons(0), Ribbon1)
        End If
        For Each sld As Microsoft.Office.Interop.PowerPoint.Slide In pres.Slides
            If sld.Layout <> PowerPoint.PpSlideLayout.ppLayoutObject And _
                    sld.Layout <> PowerPoint.PpSlideLayout.ppLayoutTitle Then
                sld.SlideShowTransition.Hidden = Microsoft.Office.Core.MsoTriState.msoTrue
                If Not rib Is Nothing Then
                    rib.ddSlides.Items.Add(it)
                    it.Label = sld.Name.ToString
                End If
            End If
        Next
        Status = Microsoft.Office.Core.MsoDocInspectorStatus.msoDocInspectorStatusDocOk
        Result = "Folien mit nicht korrektem Layout wurden u. U. ausgeblendet."
    End Sub

    Public Sub Inspect(ByVal Doc As Object, ByRef Status As Microsoft.Office.Core.MsoDocInspectorStatus, ByRef Result As String, ByRef Action As String) Implements Microsoft.Office.Core.IDocumentInspector.Inspect
        Dim pres As Microsoft.Office.Interop.PowerPoint.Presentation = CType(Doc, Microsoft.Office.Interop.PowerPoint.Presentation)
        Dim blnToFix As Boolean = False
        For Each sld As Microsoft.Office.Interop.PowerPoint.Slide In pres.Slides
            If sld.Layout <> PowerPoint.PpSlideLayout.ppLayoutObject And _
                    sld.Layout <> PowerPoint.PpSlideLayout.ppLayoutTitle And _
                    sld.SlideShowTransition.Hidden <> Microsoft.Office.Core.MsoTriState.msoTrue Then
                Result = "Es gibt sichtbare Folien, die nicht das geforderte Layout haben."
                Action = "Betroffene Folien ausblenden"
                Status = Microsoft.Office.Core.MsoDocInspectorStatus.msoDocInspectorStatusIssueFound
                blnToFix = True
                Exit For
            End If
        Next
        If Not blnToFix Then
            Result = "Folien mit nicht korrektem Layout wurden u. U. ausgeblendet."
            Action = ""
            Status = Microsoft.Office.Core.MsoDocInspectorStatus.msoDocInspectorStatusDocOk
        End If
    End Sub
End Class



