﻿Imports System.IO
Imports System.Reflection
Imports System.Runtime.InteropServices

Partial Public Class ThisAddIn

    Private ribbon As RibbonXML

    ''aktivieren
    Protected Overrides Function RequestService(ByVal serviceGuid As Guid) As Object
        If serviceGuid = GetType(Office.IRibbonExtensibility).GUID Then
            If ribbon Is Nothing Then
                ribbon = New RibbonXML
            End If
            Return ribbon
        End If

        Return MyBase.RequestService(serviceGuid)
    End Function

End Class

<ComVisible(True)> _
Public Class RibbonXML
    Implements Office.IRibbonExtensibility

    Private ribbon As Office.IRibbonUI
    Private img As stdole.IPictureDisp
    Private blnPressed As Boolean

    Public Sub New()
    End Sub

    Public Function GetCustomUI(ByVal ribbonID As String) As String Implements Office.IRibbonExtensibility.GetCustomUI
        Return My.Resources.RibbonXML
    End Function

#Region "Multifunktionsleisten-Callbacks"

    Public Sub onLoad(ByVal ribbonUI As Office.IRibbonUI)
        Me.ribbon = ribbonUI
        img = ImageConverter.GetIPictureDispFromPicture(My.Resources.Image1)
        blnPressed = True
    End Sub

    Function getButtonImage(ByVal c As Office.IRibbonControl) As stdole.IPictureDisp
        Return imageConverter.GetIPictureDispFromPicture(My.Resources.Image2)
    End Function

    Function getImage(ByVal c As Office.IRibbonControl) As stdole.IPictureDisp
        Return img
    End Function

    Function getItemCount(ByVal c As Office.IRibbonControl) As Integer
        Return 2
    End Function

    Function getItemImage(ByVal c As Office.IRibbonControl, ByVal index As Integer) As stdole.IPictureDisp
        Select Case index
            Case 0
                Return ImageConverter.GetIPictureDispFromPicture(My.Resources.Image1)
            Case 1
                Return ImageConverter.GetIPictureDispFromPicture(My.Resources.Image2)
            Case Else
                Return Nothing
        End Select
    End Function

    Function getItemSupertip(ByVal c As Office.IRibbonControl, ByVal index As Integer) As String
        Select Case index
            Case 0
                Return "Das ist Item 1"
            Case 1
                Return "Das ist Item 2"
            Case Else
                Return ""
        End Select
    End Function

    Function getItemLabel(ByVal c As Office.IRibbonControl, ByVal index As Integer) As String
        Select Case index
            Case 0
                Return "Item 1"
            Case 1
                Return "Item 2"
            Case Else
                Return ""
        End Select
    End Function

    Sub onAction(ByVal c As Office.IRibbonControl, ByVal id As String, ByVal ind As Integer)
        Me.ribbon.InvalidateControl(id)
        Select Case ind
            Case 0
                img = ImageConverter.GetIPictureDispFromPicture(My.Resources.Image1)
            Case 1
                img = ImageConverter.GetIPictureDispFromPicture(My.Resources.Image2)
        End Select
    End Sub

    Public Sub onToggleButton(ByVal control As Office.IRibbonControl, ByVal isPressed As Boolean)
        blnPressed = isPressed
        If isPressed Then
            MessageBox.Show("Gedrückt")
        Else
            MessageBox.Show("Losgelassen")
        End If
    End Sub

    Public Function getPressed(ByVal c As Office.IRibbonControl) As Boolean
        Return blnPressed
    End Function

#End Region


End Class

