﻿Option Strict Off

Imports System.IO
Imports System.Reflection
Imports System.Runtime.InteropServices
Imports Office = Microsoft.Office.Core


Partial Public Class ThisAddIn
    Private mXmlToolbar As XMLToolbar

    Protected Overrides Function CreateRibbonExtensibilityObject() As Microsoft.Office.Core.IRibbonExtensibility
        If mXmlToolbar Is Nothing Then
            mXmlToolbar = New XMLToolbar
        End If
        Return mXmlToolbar
    End Function

    'auch das funkioniert
    'Protected Overrides Function RequestService(ByVal serviceGuid As System.Guid) As Object
    '    If serviceGuid = GetType(Office.IRibbonExtensibility).GUID Then
    '        If mXmlToolbar Is Nothing Then
    '            mXmlToolbar = New XMLToolbar
    '        End If
    '        Return mXmlToolbar
    '    Else
    '        Return MyBase.RequestService(serviceGuid)
    '    End If
    'End Function

    Private Sub Application_SheetSelectionChange(ByVal Sh As Object, ByVal Target As Microsoft.Office.Interop.Excel.Range) Handles Application.SheetSelectionChange
        'nicht ganz optimal
        Try
            mXmlToolbar.ribbon.InvalidateControl("validationOnOff")
        Catch ex As Exception

        End Try

    End Sub

End Class

<ComVisible(True)> _
Public Class XMLToolbar
    Implements Office.IRibbonExtensibility

    Public ribbon As Office.IRibbonUI
    Private WithEvents wbActive As Excel.Workbook
    Private blnCheckDataForExport As Boolean
    Private blnCheckDataForImport As Boolean
    Private blnInvalidImportData As Boolean
    Private WithEvents settings As Xml.XmlReaderSettings


    Public Function GetCustomUI(ByVal ribbonID As String) As String Implements Office.IRibbonExtensibility.GetCustomUI
        Return GetResourceText("Excel_2007_XML_Toolbox.XMLToolbar.xml")
    End Function

#Region "Multifunktionsleisten-Callbacks"

    Public Sub onLoad(ByVal ribbonUI As Office.IRibbonUI)
        Me.ribbon = ribbonUI
    End Sub

    Public Sub showRange(ByVal c As Office.IRibbonControl)
        Dim frm As New showXML
        Dim xDoc As New Xml.XmlDocument
        Try
            Dim r As Excel.Range = CType(Globals.ThisAddIn.Application.Selection, Excel.Range)
            xDoc.LoadXml(r.Value(Excel.XlRangeValueDataType.xlRangeValueXMLSpreadsheet).ToString)
            Dim pi As Xml.XmlProcessingInstruction
            pi = CType(xDoc.ChildNodes(1), Xml.XmlProcessingInstruction)
            Dim com As Xml.XmlComment
            com = xDoc.CreateComment(pi.OuterXml)
            xDoc.InsertAfter(com, xDoc.ChildNodes(0))
            xDoc.RemoveChild(pi)
            xDoc.Save(My.Computer.FileSystem.SpecialDirectories.Temp & "\temp.xml")
            frm.WebBrowser1.Navigate(My.Computer.FileSystem.SpecialDirectories.Temp & "\temp.xml")
            frm.ShowDialog()
            My.Computer.FileSystem.DeleteFile(My.Computer.FileSystem.SpecialDirectories.Temp & "\temp.xml")
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub saveAsXml(ByVal c As Office.IRibbonControl)
        Dim Filename As Object
        Dim app As Excel.Application = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application
        Try
            Dim wb As Excel.Workbook = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook
            Filename = app.GetSaveAsFilename("dummy.xml", "XML-Dateien,*.xml")
            If Filename.ToString <> CType(False, String) Then
                'keine Warnung zum Verlust von Informationen wegen des Formats
                wb.SaveAs(Filename.ToString, FileFormat:=Excel.XlFileFormat.xlXMLSpreadsheet)
            End If
        Catch ex As Exception

        End Try
    End Sub

    Public Sub loadXML(ByVal c As Office.IRibbonControl)
        Dim FileName As Object
        Dim app As Excel.Application = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application
        FileName = app.GetOpenFilename("XML-Dateien,*.xml", , , , False)
        Try
            Select Case c.Id
                'es wird nur geöffnet, nicht importiert
                Case "loadWithPrompt"
                    app.Workbooks.OpenXML(FileName, , Excel.XlXmlLoadOption.xlXmlLoadPromptUser)
                Case "loadImportToList"
                    app.Workbooks.OpenXML(FileName, , Excel.XlXmlLoadOption.xlXmlLoadImportToList)
                Case "loadOpenXml"
                    Try
                        app.Workbooks.OpenXML(FileName, 1, Excel.XlXmlLoadOption.xlXmlLoadOpenXml)
                    Catch ex As Exception
                        app.Workbooks.OpenXML(FileName, , Excel.XlXmlLoadOption.xlXmlLoadOpenXml)
                    End Try
                Case "loadMapXml"
                    app.Workbooks.OpenXML(FileName, , Excel.XlXmlLoadOption.xlXmlLoadMapXml)
            End Select
        Catch ex As Exception

        End Try
    End Sub

    Public Sub saveAsXmlData(ByVal c As Office.IRibbonControl)
        Dim Filename As Object
        Try
            Dim r As Excel.Range = Globals.ThisAddIn.Application.ActiveCell
            If r.XPath.Value > "" Then
                Dim app As Excel.Application = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application
                Dim wb As Excel.Workbook = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook
                Filename = app.GetSaveAsFilename("dummy.xml", "XML-Dateien,*.xml")
                If Filename.ToString <> CType(False, String) Then
                    'keine Warnung zum Verlust von Informationen wegen des Formats
                    wb.SaveAsXMLData(Filename.ToString, r.XPath.Map)
                End If

            Else
                MsgBox("Bitte eine Zelle mit XML-Zuordnung auswählen.")
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub reloadSchema(ByVal c As Office.IRibbonControl)
        Dim activeWorkbook As Excel.Workbook
        activeWorkbook = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook
        If Not activeWorkbook Is Nothing Then
            Dim frm As New reloadSchema
            frm.activeWorkbook = activeWorkbook
            frm.ShowDialog()
        End If
    End Sub

    Public Sub viewSchema(ByVal c As Office.IRibbonControl)
        Dim frm As New showXML
        Dim xmlDoc As New Xml.XmlDocument
        Try
            Dim r As Excel.Range = Globals.ThisAddIn.Application.ActiveCell
            If r.XPath.Value > "" Then
                xmlDoc.LoadXml(r.XPath.Map.Schemas(1).XML)
                xmlDoc.Save(My.Computer.FileSystem.SpecialDirectories.Temp & "\temp.xml")
                frm.WebBrowser1.Navigate(My.Computer.FileSystem.SpecialDirectories.Temp & "\temp.xml")
                frm.ShowDialog()
                My.Computer.FileSystem.DeleteFile(My.Computer.FileSystem.SpecialDirectories.Temp & "\temp.xml")
            Else
                MsgBox("Bitte eine Zelle mit XML-Zuordnung auswählen.")
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub rangeProps(ByVal c As Office.IRibbonControl)
        Try
            Dim rng As Excel.Range = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveCell
            If Not rng Is Nothing Then
                Dim frm As New rangeProps
                frm.activeCell = rng
                frm.ShowDialog()
            End If
        Catch
        End Try
    End Sub

    Public Sub listAllMappings(ByVal c As Office.IRibbonControl)
        Dim frm As New listAllMappings
        Dim activeWorkbook As Excel.Workbook
        Try
            activeWorkbook = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook
            If Not activeWorkbook Is Nothing Then
                frm.activeWorkbook = activeWorkbook
                frm.ShowDialog()
            End If
        Catch ex As Exception

        End Try
    End Sub

    Public Sub refreshAllData(ByVal c As Office.IRibbonControl)
        Try
            For Each map As Excel.XmlMap In Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook.XmlMaps
                map.DataBinding.Refresh()
            Next
        Catch ex As Exception

        End Try
    End Sub

    Public Sub validateData(ByVal c As Office.IRibbonControl)
        Try
            Dim r As Microsoft.Office.Interop.Excel.Range = Globals.ThisAddIn.Application.ActiveCell
            If r.XPath.Value > "" Then
                If r.XPath.Map.IsExportable Then
                    Dim strData As String = ""
                    Dim validationState As Boolean
                    validationState = r.XPath.Map.ShowImportExportValidationErrors
                    r.XPath.Map.ShowImportExportValidationErrors = True
                    Dim response As Excel.XlXmlExportResult = r.XPath.Map.ExportXml(strData)
                    If response = Excel.XlXmlExportResult.xlXmlExportSuccess Then
                        MsgBox("Alles OK.")
                    End If
                    r.XPath.Map.ShowImportExportValidationErrors = validationState
                Else
                    MsgBox("Nicht exportierbare Daten.")
                End If
            Else
                MsgBox("Nichts zu zeigen.")
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Function enableValidationOnOff(ByVal c As Office.IRibbonControl) As Boolean
        Return Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.CommandBars.GetEnabledMso("XmlMapProperties")
    End Function

    Public Function getPressedValidationOnOff(ByVal c As Office.IRibbonControl) As Boolean
        Try
            Dim rng As Excel.Range = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveCell
            If rng.XPath.Value > "" Then
                Return rng.XPath.Map.ShowImportExportValidationErrors
            End If
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Sub validationOnOff(ByVal c As Office.IRibbonControl, ByVal pressed As Boolean)
        Try
            Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveCell.XPath.Map.ShowImportExportValidationErrors = pressed
        Catch ex As Exception

        End Try
    End Sub

    Public Sub exportData(ByVal c As Office.IRibbonControl)
        Dim activeCell As Microsoft.Office.Interop.Excel.Range = Globals.ThisAddIn.Application.ActiveCell
        If Not activeCell Is Nothing Then
            Try
                If activeCell.XPath.Value > "" Then
                    If activeCell.XPath.Map.IsExportable Then
                        wbActive = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook
                        blnCheckDataForExport = True
                        Dim cbb As Office.CommandBarButton = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.CommandBars.FindControl(Id:=7432)
                        cbb.Execute() 'das erspart eigene Dialogfelder, kann aber die COMException nicht auslösen
                        'activeCell.XPath.Map.Export(My.Computer.FileSystem.SpecialDirectories.Temp & "\temp.xml", True)
                    Else
                        MsgBox("Nicht exportierbare Daten.")
                    End If
                Else
                    MsgBox("Nichts zu exportieren.")
                End If
            Catch ex As COMException
                'ein Fehler wird durch BeforeXMLExport ausgelöst, wenn dort Cancel=True gesetzt wird und die Export-Methode eingesetzt wird
                'MsgBox("Keine Sorge, es wurde nichts gespeichert.")
            Catch ex As Exception
                MsgBox(ex.Message)
            Finally
                blnCheckDataForExport = False
            End Try
        End If
    End Sub

    Public Sub importData(ByVal c As Office.IRibbonControl)
        wbActive = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook
        If Not wbActive Is Nothing Then
            blnCheckDataForImport = True
            Dim cbb As Office.CommandBarButton
            cbb = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.CommandBars.FindControl(Id:=7433)
            cbb.Execute()
            blnCheckDataForImport = False
        End If
    End Sub

    Public Sub addCustomXml(ByVal c As Office.IRibbonControl)
        Try
            Dim activeWorkbook As Excel.Workbook = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook
            If Not activeWorkbook Is Nothing Then
                Dim dialog As New System.Windows.Forms.OpenFileDialog
                dialog.Filter = "XML (*.xml)|*.xml"
                dialog.ShowDialog()
                If dialog.FileName <> "" Then
                    Dim xmldoc As New Xml.XmlDocument
                    xmldoc.Load(dialog.FileName.ToString)
                    activeWorkbook.CustomXMLParts.Add(xmldoc.OuterXml)
                End If
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub showCustomXml(ByVal c As Office.IRibbonControl)
        Try
            Dim activeWorkbook As Excel.Workbook = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook
            If Not activeWorkbook Is Nothing Then
                Dim frm As New showCustomXml
                frm.activeWorkbook = activeWorkbook
                frm.ShowDialog()
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub changeCustomXml(ByVal c As Office.IRibbonControl)
        Try
            Dim activeWorkbook As Excel.Workbook = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveWorkbook
            If Not activeWorkbook Is Nothing Then
                Dim frm As New changeCustomXml
                frm.activeWorkbook = activeWorkbook
                frm.ShowDialog()
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub


#End Region

#Region "Hilfsfunktionen"

    Private Shared Function GetResourceText(ByVal resourceName As String) As String
        Dim asm As Assembly = Assembly.GetExecutingAssembly()
        Dim resourceNames() As String = asm.GetManifestResourceNames()
        For i As Integer = 0 To resourceNames.Length - 1
            If String.Compare(resourceName, resourceNames(i), StringComparison.OrdinalIgnoreCase) = 0 Then
                Using resourceReader As StreamReader = New StreamReader(asm.GetManifestResourceStream(resourceNames(i)))
                    If resourceReader IsNot Nothing Then
                        Return resourceReader.ReadToEnd()
                    End If
                End Using
            End If
        Next
        Return Nothing
    End Function

#End Region

    Private Sub wb_BeforeXmlExport(ByVal Map As Microsoft.Office.Interop.Excel.XmlMap, ByVal Url As String, ByRef Cancel As Boolean) Handles wbActive.BeforeXmlExport
        If blnCheckDataForExport Then
            Dim retValue As Excel.XlXmlExportResult
            Dim strData As String = ""
            Dim validationState As Boolean
            Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.EnableEvents = False
            validationState = Map.ShowImportExportValidationErrors
            Map.ShowImportExportValidationErrors = True
            retValue = Map.ExportXml(strData) 'hier auch DisplayAlerts = False denkbar
            Map.ShowImportExportValidationErrors = validationState
            Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.EnableEvents = True
            If retValue = Excel.XlXmlExportResult.xlXmlExportValidationFailed Then
                Cancel = True
                'MsgBox("Keine Sorge, es wurde nichts gespeichert.")
            Else
                MsgBox("Die Daten wurden erfolgreich exportiert.")
            End If
        End If
    End Sub

    Private Sub wbActive_BeforeXmlImport(ByVal Map As Microsoft.Office.Interop.Excel.XmlMap, ByVal Url As String, ByVal IsRefresh As Boolean, ByRef Cancel As Boolean) Handles wbActive.BeforeXmlImport
        If blnCheckDataForImport Then
            Try
                Dim xmlDoc As New Xml.XmlDocument
                Dim schemaSet As New Xml.Schema.XmlSchemaSet
                schemaSet.Add(Nothing, New Xml.XmlTextReader(Map.Schemas(1).XML, Xml.XmlNodeType.Document, Nothing)) 'das erste Nothing ist wichtig
                settings = New Xml.XmlReaderSettings
                settings.ValidationType = Xml.ValidationType.Schema
                settings.ValidationFlags = Xml.Schema.XmlSchemaValidationFlags.ReportValidationWarnings Or settings.ValidationFlags
                settings.Schemas.Add(schemaSet)
                Dim docReader As Xml.XmlReader
                docReader = Xml.XmlReader.Create(Url, settings)
                xmlDoc.Load(docReader)
                docReader.Close()
                Cancel = blnInvalidImportData
            Catch ex As Exception
            Finally
                blnInvalidImportData = False
            End Try
        End If
    End Sub

    Private Sub settings_ValidationEventHandler(ByVal sender As Object, ByVal e As System.Xml.Schema.ValidationEventArgs) Handles settings.ValidationEventHandler
        blnInvalidImportData = True
        MsgBox(e.Exception.Message)
    End Sub
End Class
