﻿Public Class listAllMappings

    Private mActiveWorkbook As Excel.Workbook

    Public WriteOnly Property activeWorkbook() As Excel.Workbook
        Set(ByVal value As Excel.Workbook)
            mActiveWorkbook = value
        End Set
    End Property


    Private Sub listAllMappings_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cboMaps.Items.Clear()
        lblMapInfo.Text = ""
        cboListObjects.Items.Clear()
        lblListObjectInfo.Text = ""
        Try
            For Each map As Excel.XmlMap In mActiveWorkbook.XmlMaps
                cboMaps.Items.Add(map.Name)
            Next
            If cboMaps.Items.Count > 0 Then
                cboMaps.SelectedIndex = 0
            End If
        Catch ex As Exception

        End Try
        Try
            For Each wsh As Excel.Worksheet In mActiveWorkbook.Worksheets
                For Each lo As Excel.ListObject In wsh.ListObjects
                    cboListObjects.Items.Add(wsh.Name & "\" & lo.DisplayName)
                Next
            Next
            If cboListObjects.Items.Count > 0 Then
                cboListObjects.SelectedIndex = 0
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub cboMaps_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboMaps.SelectedIndexChanged
        Dim map As Excel.XmlMap = mActiveWorkbook.XmlMaps(cboMaps.SelectedItem.ToString)
        lblMapInfo.Text = map.RootElementNamespace.Prefix & ":" & map.RootElementNamespace.Uri
        DataGridView1.Rows.Clear()
        Try
            If Not map.WorkbookConnection Is Nothing Then
                Dim con As Excel.WorkbookConnection = map.WorkbookConnection
                For i As Integer = 1 To con.Ranges.Count
                    Dim strAddress1() As String = Split(con.Ranges.Item(i).Address(External:=True), "!")
                    Dim strAddress2() As String = Split(strAddress1(1), ",")
                    For j As Integer = 0 To strAddress2.Count - 1
                        Dim rng1 As Excel.Range = Excel_2007_XML_Toolbox.Globals.ThisAddIn.Application.Range(strAddress1(0) & "!" & strAddress2(j))
                        For Each rng As Excel.Range In rng1
                            Dim k As Integer = DataGridView1.Rows.Add
                            Dim row As DataGridViewRow = DataGridView1.Rows(k)
                            row.Cells(Address.Name).Value = rng.Worksheet.Name & "!" & rng.Address
                            row.Cells(XPath.Name).Value = rng.XPath.Value
                        Next
                    Next
                Next
            End If

        Catch ex As Exception

        End Try
    End Sub

    Private Sub cboListObjects_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboListObjects.SelectedIndexChanged
        Dim strDummy() As String = Split(cboListObjects.SelectedItem.ToString, "\")
        Dim wsh As Excel.Worksheet = CType(mActiveWorkbook.Worksheets(strDummy(0)), Excel.Worksheet)
        Dim lo As Excel.ListObject = wsh.ListObjects(strDummy(1))
        If Not lo.XmlMap Is Nothing Then
            lblListObjectInfo.Text = lo.XmlMap.RootElementNamespace.Prefix & ":" & lo.XmlMap.RootElementNamespace.Uri
            For Each lc As Excel.ListColumn In lo.ListColumns
                Dim i As Integer = DataGridView2.Rows.Add
                Dim row As DataGridViewRow = DataGridView2.Rows(i)
                row.Cells(ListAddress.Name).Value = lc.Range.Address
                row.Cells(ListXPath.Name).Value = lc.XPath.Value
            Next
        Else
            lblListObjectInfo.Text = "no map"
            DataGridView2.Rows.Clear()
        End If
    End Sub
End Class