﻿Public Class reloadSchema

    Private mActiveWorkbook As Excel.Workbook

    Public WriteOnly Property activeWorkbook() As Excel.Workbook
        Set(ByVal value As Excel.Workbook)
            mActiveWorkbook = value
        End Set
    End Property

    Private Sub reloadSchema_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        actualizeProps()
        If ListBox1.Items.Count > 0 Then
            ListBox1.SelectedIndex = 0
        Else
            lblNamespace.Text = ""
        End If
    End Sub

    Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
        Dim dlg As New OpenFileDialog
        dlg.Filter = "XML-Schema (*.xsd)|*.xsd|XML-Data (*.xml)|*.xml"
        dlg.ShowDialog()
        If dlg.FileName <> "" Then
            Try
                Dim map As Excel.XmlMap = mActiveWorkbook.XmlMaps.Add(dlg.FileName)
                Dim props As Office.DocumentProperties
                props = CType(mActiveWorkbook.CustomDocumentProperties, Office.DocumentProperties)
                Dim prop As Office.DocumentProperty = props.Add(map.Name, False, Office.MsoDocProperties.msoPropertyTypeString, dlg.FileName & "|" & map.RootElementNamespace.Uri)
                Me.Close()
            Catch ex As Exception

            Finally
                actualizeProps()
                ListBox1.SelectedIndex = ListBox1.Items.Count - 1
            End Try
        End If
    End Sub

    Private Sub actualizeProps()
        ListBox1.Items.Clear()
        For Each prop As Office.DocumentProperty In CType(mActiveWorkbook.CustomDocumentProperties, Office.DocumentProperties)
            If prop.Value.ToString.Contains("|") Then
                Try
                    Dim map As Excel.XmlMap
                    map = mActiveWorkbook.XmlMaps(prop.Name)
                    ListBox1.Items.Add(map.Name)
                Catch ex As Exception
                    prop.Delete()
                End Try
            End If
        Next
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        Try
            Dim map As Excel.XmlMap
            map = mActiveWorkbook.XmlMaps(ListBox1.SelectedItem.ToString)
            If map.RootElementNamespace.Uri > "" Then
                lblNamespace.Text = map.RootElementNamespace.Uri
            Else
                lblNamespace.Text = "no namespace used"
            End If
        Catch ex As Exception

        End Try
    End Sub

    Private Sub btnReload_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnReload.Click
        Dim strMapName As String
        Dim mapOld As Excel.XmlMap
        Dim mapNew As Excel.XmlMap
        Dim blnExitFor As Boolean = False
        Dim strSchemaPath As String
        Dim props As Office.DocumentProperties
        Dim prop As Office.DocumentProperty
        If ListBox1.SelectedItems.Count = 1 Then
            strMapName = ListBox1.SelectedItem.ToString
            mapOld = mActiveWorkbook.XmlMaps(strMapName)
            For Each wsh As Excel.Worksheet In mActiveWorkbook.Worksheets
                For Each listObj As Excel.ListObject In wsh.ListObjects
                    If listObj.XmlMap.Name = strMapName Then
                        Dim rh As Excel.Range = listObj.HeaderRowRange
                        Dim col As New Collection
                        For Each r As Excel.Range In rh
                            col.Add(r.XPath.Value, r.Address)
                            r.XPath.Clear()
                        Next
                        mapOld.Delete()
                        props = CType(mActiveWorkbook.CustomDocumentProperties, Office.DocumentProperties)
                        prop = props(strMapName)
                        strSchemaPath = prop.Value.ToString.Substring(0, prop.Value.ToString.IndexOf("|"))
                        mapNew = mActiveWorkbook.XmlMaps.Add(strSchemaPath)
                        mapNew.Name = strMapName
                        For Each r As Excel.Range In rh
                            r.XPath.SetValue(mapNew, col(r.Address).ToString)
                        Next
                        blnExitFor = True
                        Exit For
                    End If
                Next
                If blnExitFor Then
                    Exit For
                End If
            Next
            If Not blnExitFor Then
                mapOld.Delete()
                props = CType(mActiveWorkbook.CustomDocumentProperties, Office.DocumentProperties)
                prop = props(strMapName)
                strSchemaPath = prop.Value.ToString.Substring(0, prop.Value.ToString.IndexOf("|"))
                mapNew = mActiveWorkbook.XmlMaps.Add(strSchemaPath)
                mapNew.Name = strMapName
            End If
        End If
        Me.Close()
    End Sub
End Class