﻿'TODO:  Follow these steps to enable the Ribbon (XML) item:

'1: Copy the following code block into the ThisAddin, ThisWorkbook, or ThisDocument class.

'Protected Overrides Function CreateRibbonExtensibilityObject() As Microsoft.Office.Core.IRibbonExtensibility
'    Return New Ribbon1()
'End Function

'2. Create callback methods in the "Ribbon Callbacks" region of this class to handle user
'   actions, such as clicking a button. Note: if you have exported this Ribbon from the
'   Ribbon designer, move your code from the event handlers to the callback methods and
'   modify the code to work with the Ribbon extensibility (RibbonX) programming model.

'3. Assign attributes to the control tags in the Ribbon XML file to identify the appropriate callback methods in your code.

'For more information, see the Ribbon XML documentation in the Visual Studio Tools for Office Help.

Partial Class ThisAddIn
    Protected Overrides Function CreateRibbonExtensibilityObject() As Microsoft.Office.Core.IRibbonExtensibility
        Return New XMLToolbox()
    End Function
End Class

<Runtime.InteropServices.ComVisible(True)> _
    Public Class XMLToolbox
    Implements Office.IRibbonExtensibility

    Private ribbon As Office.IRibbonUI

    Public Sub New()
    End Sub

    Public Function GetCustomUI(ByVal ribbonID As String) As String Implements Office.IRibbonExtensibility.GetCustomUI
        Return GetResourceText("Word_2007_XML_Toolbox.XMLToolbox.xml")
    End Function

#Region "Ribbon Callbacks"
    'Create callback methods here. For more information about adding callback methods, select the Ribbon XML item in Solution Explorer and then press F1.
    Public Sub Ribbon_Load(ByVal ribbonUI As Office.IRibbonUI)
        Me.ribbon = ribbonUI
    End Sub

    Public Sub openFile(ByVal c As Office.IRibbonControl)
        Dim dialog As New System.Windows.Forms.OpenFileDialog
        dialog.Filter = "XML (*.xml)|*.xml"
        dialog.ShowDialog()
        If dialog.FileName <> "" Then
            Dim doc As Word.Document
            Dim app As Word.Application = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application
            Try
                doc = app.Documents.Open(FileName:=dialog.FileName.ToString, ConfirmConversions:=False)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub

    Public Sub saveAsXmlFile(ByVal c As Office.IRibbonControl)
        Dim dialog As New System.Windows.Forms.SaveFileDialog
        dialog.Filter = "XML (*.xml)|*.xml"
        dialog.ShowDialog()
        If dialog.FileName <> "" Then
            Dim doc As Word.Document
            Dim app As Word.Application = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application
            Try
                doc = app.ActiveDocument
                doc.SaveAs(FileName:=dialog.FileName.ToString, FileFormat:=Word.WdSaveFormat.wdFormatXML)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub

    Public Sub currentSelection(ByVal c As Office.IRibbonControl)
        Dim strFileToOpen As String = "c:\dummyWordML.xml"
        Try
            Dim doc As Word.Document = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            Dim xmlDoc As New Xml.XmlDocument
            xmlDoc.LoadXml(doc.Application.Selection.Range.XML)
            Dim pi As Xml.XmlProcessingInstruction = CType(xmlDoc.ChildNodes(1), Xml.XmlProcessingInstruction)
            Dim com As Xml.XmlComment = xmlDoc.CreateComment(pi.OuterXml)
            xmlDoc.InsertAfter(com, xmlDoc.ChildNodes(0))
            xmlDoc.RemoveChild(pi)
            xmlDoc.Save(strFileToOpen)
            Dim frm As New showXml
            frm.fileToOpen = strFileToOpen
            frm.ShowDialog()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub bodyOnly(ByVal c As Office.IRibbonControl)
        Dim strFileToOpen As String = "c:\dummyWordML.xml"
        Dim sw As IO.StreamWriter = New IO.StreamWriter(strFileToOpen)
        Try
            Dim doc As Word.Document = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            Dim xmlDoc As New Xml.XmlDocument
            xmlDoc.LoadXml(doc.Application.Selection.Range.XML)
            Dim nsmgr As New Xml.XmlNamespaceManager(xmlDoc.NameTable)
            nsmgr.AddNamespace("w", "http://schemas.microsoft.com/office/word/2003/wordml")
            sw.Write(xmlDoc.SelectSingleNode("*//w:body", nsmgr).OuterXml)
            sw.Close()
            Dim frm As New showXml
            frm.fileToOpen = strFileToOpen
            frm.ShowDialog()
        Catch ex As Exception
            sw.Close()
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub entireDocument(ByVal c As Office.IRibbonControl)
        Dim strFileToOpen As String = "c:\dummyWordML.xml"
        Try
            Dim doc As Word.Document = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            Dim xmlDoc As New Xml.XmlDocument
            xmlDoc.LoadXml(doc.Range.XML)
            Dim pi As Xml.XmlProcessingInstruction = CType(xmlDoc.ChildNodes(1), Xml.XmlProcessingInstruction)
            Dim com As Xml.XmlComment = xmlDoc.CreateComment(pi.OuterXml)
            xmlDoc.InsertAfter(com, xmlDoc.ChildNodes(0))
            xmlDoc.RemoveChild(pi)
            xmlDoc.Save(strFileToOpen)
            Dim frm As New showXml
            frm.fileToOpen = strFileToOpen
            frm.ShowDialog()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub insertXml(ByVal c As Office.IRibbonControl)
        Dim frm As New insertXml
        frm.ShowDialog()
    End Sub


    Public Sub selectionOpenXML(ByVal c As Office.IRibbonControl)
        Dim strFileToOpen As String = "c:\dummyWordML.xml"
        Try
            Dim xmlDoc As New Xml.XmlDocument
            xmlDoc.LoadXml(Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.Selection.Range.WordOpenXML)
            Dim pi As Xml.XmlProcessingInstruction = CType(xmlDoc.ChildNodes(1), Xml.XmlProcessingInstruction)
            Dim com As Xml.XmlComment = xmlDoc.CreateComment(pi.OuterXml)
            xmlDoc.InsertAfter(com, xmlDoc.ChildNodes(0))
            xmlDoc.RemoveChild(pi)
            xmlDoc.Save(strFileToOpen)
            Dim frm As New showXml
            frm.fileToOpen = strFileToOpen
            frm.ShowDialog()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub entireDocumentOpenXML(ByVal c As Office.IRibbonControl)
        Dim strFileToOpen As String = "c:\dummyWordML.xml"
        Try
            Dim doc As Word.Document = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            Dim xmlDoc As New Xml.XmlDocument
            xmlDoc.LoadXml(doc.Range.WordOpenXML)
            Dim pi As Xml.XmlProcessingInstruction = CType(xmlDoc.ChildNodes(1), Xml.XmlProcessingInstruction)
            Dim com As Xml.XmlComment = xmlDoc.CreateComment(pi.OuterXml)
            xmlDoc.InsertAfter(com, xmlDoc.ChildNodes(0))
            xmlDoc.RemoveChild(pi)
            xmlDoc.Save(strFileToOpen)
            Dim frm As New showXml
            frm.fileToOpen = strFileToOpen
            frm.ShowDialog()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub bodyOpenXML(ByVal c As Office.IRibbonControl)
        Dim strFileToOpen As String = "c:\dummyWordML.xml"
        Dim sw As IO.StreamWriter = New IO.StreamWriter(strFileToOpen)
        Try
            Dim doc As Word.Document = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            Dim xmlDoc As New Xml.XmlDocument
            xmlDoc.LoadXml(doc.Range.WordOpenXML)
            Dim nsmgr As New Xml.XmlNamespaceManager(xmlDoc.NameTable)
            nsmgr.AddNamespace("w", "http://schemas.openxmlformats.org/wordprocessingml/2006/main")
            sw.Write(xmlDoc.SelectSingleNode("*//w:body", nsmgr).OuterXml)
            sw.Close()
            Dim frm As New showXml
            frm.fileToOpen = strFileToOpen
            frm.ShowDialog()
        Catch ex As Exception
            sw.Close()
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub showOptionsDialog(ByVal c As Office.IRibbonControl)
        Try
            Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.Dialogs(Word.WdWordDialog.wdDialogXMLOptions).Show()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub toggleXmlTagView(ByVal c As Office.IRibbonControl)
        Try
            Dim doc As Word.Document = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            doc.ActiveWindow.View.ShowXMLMarkup = Word.WdConstants.wdToggle
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub reloadSchema(ByVal c As Office.IRibbonControl)
        Try
            Dim frm As New schemaReferences
            frm.activeDocument = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            frm.btnReload.Visible = True
            frm.Text = "Reload Schema"
            frm.ShowDialog()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub validate(ByVal c As Office.IRibbonControl)
        Dim strMessage As String = ""
        Dim status As Boolean = False
        Try
            Dim doc As Word.Document = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            status = doc.XMLSchemaReferences.AutomaticValidation
            doc.XMLSchemaReferences.AutomaticValidation = True 'notwendig
            For Each nd As Word.XMLNode In doc.XMLSchemaViolations
                strMessage = strMessage & nd.BaseName & " - " & nd.ValidationErrorText & vbCrLf
            Next
            doc.XMLSchemaReferences.AutomaticValidation = status
            If strMessage > "" Then
                MsgBox(strMessage)
            Else
                MsgBox("Keine Schema-Verletzungen gefunden.")
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub viewNodeProperties(ByVal c As Office.IRibbonControl)
        Try
            Dim frm As New nodeProperties
            frm.activeDocument = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            frm.ShowDialog()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub eventMonitor(ByVal ca As Office.IRibbonControl)
        Dim frm As New eventMonitor
        frm.ShowInTaskbar = True
        frm.TopMost = True
        frm.Show()
    End Sub

    Public Sub showCustomXml(ByVal c As Office.IRibbonControl)
        Try
            Dim frm As New showCustomXml
            frm.activeDocument = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            frm.fileToOpen = "c:\dummyWordML.xml"
            frm.ShowDialog()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub addCustomXml(ByVal c As Office.IRibbonControl)
        Dim dialog As New System.Windows.Forms.OpenFileDialog
        dialog.Filter = "XML (*.xml)|*.xml"
        dialog.ShowDialog()
        If dialog.FileName <> "" Then
            Dim doc As Word.Document
            Try
                doc = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
                Dim xmldoc As New Xml.XmlDocument
                xmldoc.Load(dialog.FileName.ToString)
                doc.CustomXMLParts.Add(xmldoc.OuterXml)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub

    Public Sub changeCustomXml(ByVal c As Office.IRibbonControl)
        Try
            Dim frm As New changeCustomXml
            frm.activeDocument = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
            frm.ShowDialog()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Public Sub applyMapping(ByVal c As Office.IRibbonControl)
        Try
            Dim contentControl As Word.ContentControl
            If Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.Selection.Range.ContentControls.Count <> 1 Then
                MsgBox("Bitte ein einzelnes Inhaltssteuerelement markieren.")
            Else
                contentControl = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.Selection.Range.ContentControls(1)
                Dim frm As New applyMapping
                frm.contentControl = contentControl
                frm.activeDocument = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
                frm.ShowDialog()
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

#End Region

#Region "Helpers"

    Private Shared Function GetResourceText(ByVal resourceName As String) As String
        Dim asm As Reflection.Assembly = Reflection.Assembly.GetExecutingAssembly()
        Dim resourceNames() As String = asm.GetManifestResourceNames()
        For i As Integer = 0 To resourceNames.Length - 1
            If String.Compare(resourceName, resourceNames(i), StringComparison.OrdinalIgnoreCase) = 0 Then
                Using resourceReader As IO.StreamReader = New IO.StreamReader(asm.GetManifestResourceStream(resourceNames(i)))
                    If resourceReader IsNot Nothing Then
                        Return resourceReader.ReadToEnd()
                    End If
                End Using
            End If
        Next
        Return Nothing
    End Function

#End Region

End Class
