﻿Public Class applyMapping

    Private mActiveDocument As Word.Document
    Private custom As Office.CustomXMLPart
    Private nd As Office.CustomXMLNode
    Private mContentControl As Word.ContentControl

    Public Property contentControl() As Word.ContentControl
        Get
            Return mContentControl
        End Get
        Set(ByVal value As Word.ContentControl)
            mContentControl = value
        End Set
    End Property

    Public WriteOnly Property activeDocument() As Word.Document
        Set(ByVal value As Word.Document)
            mActiveDocument = value
        End Set
    End Property

    Private Sub applyMapping_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            ComboBox1.Items.Clear()
            For Each customDummy As Office.CustomXMLPart In mActiveDocument.CustomXMLParts
                ComboBox1.Items.Add(customDummy.NamespaceURI)
            Next
            If ComboBox1.Items.Count > 0 Then
                ComboBox1.SelectedIndex = 0
            End If
            ComboBox1.SelectedItem = mContentControl.XMLMapping.CustomXMLPart.NamespaceURI
            ListBox1.SelectedItem = mContentControl.XMLMapping.XPath
            Label1.Text = mContentControl.Range.Text
        Catch ex As Exception
            Label1.Text = ""
        End Try
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        Try
            custom = mActiveDocument.CustomXMLParts(ComboBox1.SelectedIndex + 1)
            ListBox1.Items.Clear()
            For Each ndDummy As Office.CustomXMLNode In custom.DocumentElement.ChildNodes
                If ndDummy.NodeType = Microsoft.Office.Core.MsoCustomXMLNodeType.msoCustomXMLNodeElement Then
                    writeXPath(ndDummy)
                End If
            Next
        Catch ex As Exception

        End Try
    End Sub

    Private Sub writeXPath(ByVal nd As Office.CustomXMLNode)
        ListBox1.Items.Add(nd.XPath)
        For Each ndDummy As Office.CustomXMLNode In nd.ChildNodes
            If ndDummy.NodeType = Microsoft.Office.Core.MsoCustomXMLNodeType.msoCustomXMLNodeElement Then
                writeXPath(ndDummy)
            End If
        Next
    End Sub

    Private Sub btnApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnApply.Click
        Try
            mContentControl.XMLMapping.SetMapping(ListBox1.SelectedItem.ToString)
            Me.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        Try
            Label1.Text = custom.SelectSingleNode(ListBox1.SelectedItem.ToString).Text
        Catch ex As Exception

        End Try
    End Sub
End Class