﻿
Imports System.Windows.Forms

Public Class eventMonitor
    Dim WithEvents doc As Word.Document
    Dim WithEvents app As Word.Application
    Dim intCount As Integer = 0

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        DataGridView1.Rows.Clear()
        intCount = 0
    End Sub

    Private Sub eventMonitor_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        Try
            app = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application
            doc = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
        Catch ex As Exception
            app = Nothing
            doc = Nothing
        End Try
    End Sub

    Private Sub app_DocumentChange() Handles app.DocumentChange
        Try
            doc = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
        Catch
            doc = Nothing
        End Try
    End Sub

    Private Sub app_DocumentOpen(ByVal Doc As Microsoft.Office.Interop.Word.Document) Handles app.DocumentOpen
        Try
            Doc = Word_2007_XML_Toolbox.Globals.ThisAddIn.Application.ActiveDocument
        Catch
            Doc = Nothing
        End Try
    End Sub

    Private Sub app_Quit() Handles app.Quit
        If Me.Visible = True Then
            Me.Close()
        End If
    End Sub

    Private Sub app_XMLSelectionChange(ByVal Sel As Microsoft.Office.Interop.Word.Selection, ByVal OldXMLNode As Microsoft.Office.Interop.Word.XMLNode, ByVal NewXMLNode As Microsoft.Office.Interop.Word.XMLNode, ByRef Reason As Integer) Handles app.XMLSelectionChange
        intCount = intCount + 1
        Dim strDetails As String = ""
        Dim intRow As Integer = DataGridView1.Rows.Add
        Dim row As DataGridViewRow = DataGridView1.Rows(intRow)
        Try
            row.Cells("ID").Value = intCount
            row.Cells("Level").Value = "Application [" & doc.Name & "]"
            row.Cells("EventName").Value = "XMLSelectionChange"
            If Not OldXMLNode Is Nothing Then
                strDetails = "OldXMLNode: " & OldXMLNode.BaseName & ", "
            Else
                strDetails = "OldXMLNode: [Nothing], "
            End If
            If Not NewXMLNode Is Nothing Then
                strDetails = strDetails & "NewXMLNode: " & NewXMLNode.BaseName & ", "
            Else
                strDetails = strDetails & "NewXMLNode: [Nothing], "
            End If
            Dim strReason As String = ""
            Select Case Reason
                Case Word.WdXMLSelectionChangeReason.wdXMLSelectionChangeReasonDelete
                    strReason = "Delete"
                Case Word.WdXMLSelectionChangeReason.wdXMLSelectionChangeReasonInsert
                    strReason = "Insert"
                Case Word.WdXMLSelectionChangeReason.wdXMLSelectionChangeReasonMove
                    strReason = "Move"
                Case Else
                    strReason = "?"
            End Select
            strDetails = strDetails & "Reason: " & strReason
        Catch ex As Exception
            strDetails = ex.Message
        Finally
            row.Cells(Details.Name).Value = strDetails
            selectLastInsertedRow(intRow)
        End Try
    End Sub

    Private Sub app_XMLValidationError(ByVal XMLNode As Microsoft.Office.Interop.Word.XMLNode) Handles app.XMLValidationError
        intCount = intCount + 1
        Dim strDetails As String = ""
        Dim intRow As Integer = DataGridView1.Rows.Add
        Dim row As DataGridViewRow = DataGridView1.Rows(intRow)
        Try
            row.Cells(ID.Name).Value = intCount
            row.Cells(Level.Name).Value = "Application [" & doc.Name & "]"
            row.Cells(EventName.Name).Value = "XMLValidationError"
            If Not XMLNode Is Nothing Then
                strDetails = "XMLNode: " & XMLNode.BaseName & ", "
                strDetails = strDetails & "Reason: " & XMLNode.ValidationErrorText
            Else
                strDetails = "XMLNode: [Nothing], "
            End If
        Catch ex As Exception
            strDetails = ex.Message
        Finally
            row.Cells(Details.Name).Value = strDetails
            selectLastInsertedRow(intRow)
        End Try
    End Sub

    Private Sub doc_XMLAfterInsert(ByVal NewXMLNode As Microsoft.Office.Interop.Word.XMLNode, ByVal InUndoRedo As Boolean) Handles doc.XMLAfterInsert
        intCount = intCount + 1
        Dim strDetails As String = ""
        Dim intRow As Integer = DataGridView1.Rows.Add
        Dim row As DataGridViewRow = DataGridView1.Rows(intRow)
        Try
            row.Cells(ID.Name).Value = intCount
            row.Cells(Level.Name).Value = "Document [" & doc.Name & "]"
            row.Cells(EventName.Name).Value = "XMLAfterInsert"

            If Not NewXMLNode Is Nothing Then
                strDetails = strDetails & "NewXMLNode: " & NewXMLNode.BaseName & ", "
            Else
                strDetails = strDetails & "NewXMLNode: [Nothing], "
            End If
        Catch ex As Exception
            strDetails = ex.Message
        Finally
            row.Cells(Details.Name).Value = strDetails
            selectLastInsertedRow(intRow)
        End Try
    End Sub

    Private Sub doc_XMLBeforeDelete(ByVal DeletedRange As Microsoft.Office.Interop.Word.Range, ByVal OldXMLNode As Microsoft.Office.Interop.Word.XMLNode, ByVal InUndoRedo As Boolean) Handles doc.XMLBeforeDelete
        intCount = intCount + 1
        Dim strDetails As String = ""
        Dim intRow As Integer = DataGridView1.Rows.Add
        Dim row As DataGridViewRow = DataGridView1.Rows(intRow)
        Try
            row.Cells(ID.Name).Value = intCount
            row.Cells(Level.Name).Value = "Document [" & doc.Name & "]"
            row.Cells(EventName.Name).Value = "XMLBeforeDelete"

            If Not OldXMLNode Is Nothing Then
                strDetails = strDetails & "OldXMLNode: " & OldXMLNode.BaseName & ", "
            Else
                strDetails = strDetails & "OldXMLNode: [Nothing], "
            End If
        Catch ex As Exception
            strDetails = ex.Message
        Finally
            row.Cells(Details.Name).Value = strDetails
            selectLastInsertedRow(intRow)
        End Try
    End Sub

    Private Sub selectLastInsertedRow(ByVal i As Integer)
        For Each r As DataGridViewRow In DataGridView1.Rows
            r.Selected = False
        Next
        DataGridView1.Rows(i).Selected = True
    End Sub

  
End Class